*****************************************************************************
* L1540 RPL Standalone Library for HP39/40G                 M.A.L./13.03.2003
*****************************************************************************
*
* History of changes
*
* 20.11.2001  creation
* 22.07.2002  first release
* 25.01.2003  fixes and enhancements
* 03.03.2003  pre-release for comments
* 13.03.2003  final release
* 29.11.2013  Inizio personalizzazione (by Alessandro Strano)
*
* Library number, make sure it's consistent everywhere
xROMID 604

    TITLE       MAL RPL Standalone Library

*****************************************************************************
* Aux Routines Declaration
*****************************************************************************
EXTERNAL _DUMMY
EXTERNAL _DTNR
EXTERNAL _CDTNR
EXTERNAL _NRDT

EXTERNAL _MYBOP
EXTERNAL _GETHEX2
EXTERNAL _GETBIN2
EXTERNAL _FMBASE
EXTERNAL _TOBASE
EXTERNAL _D32
EXTERNAL _SWC
EXTERNAL _PREPDEC
EXTERNAL _PREPDECB
EXTERNAL _AGGHEX
EXTERNAL _AGGBIN
EXTERNAL _MOSTRASIG
EXTERNAL _MOSTRAUNS
EXTERNAL _MOSTRALABEL

EXTERNAL _SAVESCR
EXTERNAL _RESTORESCR

*****************************************************************************
* Unsupported Entry Points
*****************************************************************************
ASSEMBLE
=ApNameFP       EQU #3F31B
=LockKey        EQU #36AB6
Ck&DoMsgBox     EQU #3F327      ( $ -> )

=TRAVERSE+      EQU     #08D0F
=GPPushT/FLp    EQU     #0DD87
=matchob?       EQU     #0ECD8
=FPointer       EQU     #177C7
=ListOfEqs!     EQU     #273C1
=NotesDisp      EQU     #3F71A
=NotesExit0     EQU     #3F71C
=NotesHKeys     EQU     #3F71D
=NotesInit0     EQU     #3F71F
=NotesSKeys     EQU     #3F7A3
=LEDone         EQU     #6C1B4 (3)
=LEQuit         EQU     #6C1D2 (3)
=EndChooseOK    EQU     #6C385 (3)
*=ApNameFP       EQU     #7D03F (3)
=ApNameEdSKey   EQU     #7D076 (3)
=USEROB         EQU     #80711

=ListToArry	EQU     #3F90A
=UNCOERCE2	EQU     #112B7
=la>COL		EQU     #3F771
=CRUNCH{}	EQU     #3F01E
=COERCE2	EQU     #112A3
=LineB		EQU     #3F862

=^XEQGET2	EQU     #255002
=^XEQGET4	EQU     #256002
=^XEQGETID	EQU     #257002

=PurgeLib#      EQU     #3F422
=AtUserStack    EQU     #24EE3

*****************************************************************************
* Program to initialize the library at warmstart
*****************************************************************************
RPL
NULLNAME MALcfg
:: # 604 TOSRRP ;

*****************************************************************************
* Dummy to shift all the nibbles
* adjust the number of DUPs to make download work
* seems SWAPDROPs in certain file positions make download fail
*****************************************************************************
RPL
NULLNAME _DUMMY
::
  DUP                           ( --- 5 nibbles per DUP )
;

*****************************************************************************
* KeyCodes returned by WaitForKey
*****************************************************************************
DEFINE kcSYMB           SEVEN
DEFINE kcPLOT           EIGHT
DEFINE kcNUM            NINE
DEFINE kcHOME           ELEVEN
DEFINE kcAPLET          TWELVE
DEFINE kcVIEWS          THIRTEEN

DEFINE kcUpArrow        TEN
DEFINE kcLeftArrow      FOURTEEN
DEFINE kcDownArrow      FIFTEEN
DEFINE kcRightArrow     SIXTEEN

DEFINE kcA              SEVENTEEN
DEFINE kcB              EIGHTEEN
DEFINE kcC              NINETEEN
DEFINE kcD              TWENTY
DEFINE kcE              TWENTYTWO
DEFINE kcF              TWENTYTHREE

DEFINE kc0              FORTYEIGHT
DEFINE kc1              FORTYTHREE
DEFINE kc2              FORTYFOUR
DEFINE kc3              FORTYFIVE
DEFINE kc4              THIRTYEIGHT
DEFINE kc5              THIRTYNINE
DEFINE kc6              FORTY
DEFINE kc7              THIRTYTHREE
DEFINE kc8              THIRTYFOUR
DEFINE kc9              THIRTYFIVE

DEFINE kcMinus          FORTYONE
DEFINE kcPlus           FORTYSIX
DEFINE kcMult           THIRTYSIX
DEFINE kcDiv            THIRTYONE

DEFINE kcOn             FORTYSEVEN
DEFINE kcDEL            TWENTYONE
DEFINE kcENTER          FIFTYONE
DEFINE kcF1             ONE
DEFINE kcF2             TWO
DEFINE kcF3             THREE
DEFINE kcF4             FOUR
DEFINE kcF6             SIX
DEFINE kcNeg            FIFTY

*****************************************************************************
* Help
*****************************************************************************
ASSEMBLE
        CON(3)  8               ( a command )
RPL
xNAME AA                        ( --- easy to type )
::
CK0                             ( has no args )
  $ "L1540 HELP"
  { 
*        12345678901234         ---- 1*14 chars in list, 6*22 chars in text
* 1234567890123456789012
*--------------------------------------------------------------------------
    { $ "*** Alessandro"
$ "\0A\0A" }
    { $ "AL ALPHA LOCK"
$ "SYSEVAL 151587\0AAL" }
    { $ "PA(x,y%)->z"
$ "PA(x,y)=x+x*y/100\0APA(\0A" }
    { $ "PS(x,y%)->z"
$ "PS(x,y)=x-x*y/100\0APS(\0A" }
    { $ "HEX(dec)"
$ "Hex calculator\0AHEX(\0AKey:+ - * / (-) home\0Aenter del" }
    { $ "BIN(dec)"
$ "Binary calculator\0ABIN(\0AKey:+ - * (-) / home\0Aenter del" }

*--------------------------------------------------------------------------
    { $ "*** Cons&Units"
$ "\0A\0A" }
    { $ "CK(C)->K"
$ "CelsiusKelvin\0A CK(C)->K\0A absolute scale" }
    { $ "KC(K)->C"
$ "KelvinCelsius\0A KC(K)->C\0A absolute scale" }
*--------------------------------------------------------------------------
    { $ "*** Time&Date"
$ "\0A\0A" }
    { $ "HP(h,h')->h+"
$ "Hours Plus\0AHP(hh.mmss,hh.mmss')->\0A hh.mmss+hh.mmss'" }
    { $ "HM(h,h')->h-"
$ "Hours Minus\0AHM(hh.mmss,hh.mmss')->\0A hh.mmss-hh.mmss'" }
    { $ "SD(d,t)->s"
$ "SetDate and time\0ASD(date,time)->sec\0A sec since 1.1.1991\0A format see DT" }
    { $ "DD(d1,d2)->"
$ "DeltaDays\0ADD(date1,date2)->ddays\0A date fmt see DT" }
    { $ "DP(d1,)->d2"
$ "DatePlus\0ADP(date1,days)->date2\0A date fmt see DT" }
    { $ "TN(d,t)->s"
$ "TimeNumber\0ATN(date,time)->sec\0ATN(0,any)->curr sec\0A sec since 01.01.1991" }
    { $ "NT(s)->{d,t}"
$ "NumberTime\0ANT(s)->{date,time}\0A sec since 01.01.1991" }
    { $ "DY(d)->17"
$ "Day of week\0ADY(date)->{17,$day}\0A date fmt see DT" }
    { $ "YW(y,w)->d"
$ "date of Year's Week\0AYW(year,week)->\0A dd.mmyyyy\0A (1st day of week)" }
    { $ "CA(d)->.my"
$ "CAlendar\0ACA(.mmyyyy)->.mmyyyy\0ACA(0)->current month\0A  months,  years\0A ENTER current month\0A ON exits" }
*--------------------------------------------------------------------------
     { $ "*** System"
$ "\0A\0A" }
    { $ "BYEFUNCT"
$ "deletes L1540 fm calc\0Abyefunct\0A use CAPITAL letters\0A ignore error messages" }
    { $ "PURGELIB(n)"
$ "purges a library\0APURGELIB(n)->n\0A does not delete L1540" }
*--------------------------------------------------------------------------
 }
  ChooseSimple
  ITE
    ::
*      _SAVESCR SWAP                 ( poi $ )
      RECLAIMDISP               ( --- clear alpha display )
      TURNMENUOFF               ( --- remove menu keys )
* return 2nd line of help text
      DUPDUP                    ( $ $ $ )
      NEWLINE$ ONE POS$         ( $ $ posnl )
      #1+LAST$                  ( $ $' )
      DUP NEWLINE$ ONE POS$     ( $ $' posnl )
      1_#1-SUB$                 ( $ $'' )
*      ONE {}N                   ( {$''} )
      SWAP                      ( $' $ )
      DUPNULL$? ITE
      DROP                      ( $' )
      ::
        ONE SIX Disp5x7
        $ "Any Key continues " DISPROW7
        WaitForKey 2DROP        ( poi $'' )
      ;
*      _RESTORESCR               ( $'' )
    ;
  %0                            ( need to return something )
;

***************************************************************************
*PA(x,y) = x-x*y/100 by Alessandro Strano
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PA
::
CK2&Dispatch
#00001                               
:: 
   OVER
   %*
   % 100 %/ %+
;
;
***************************************************************************
*PS(x,y) = x-x*y/100 by Alessandro Strano
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PS
::
CK2&Dispatch
#00001                               
:: 
   OVER
   %*
   % 100 %/ %-
;
;
***************************************************************************
*ALPHALOCK esegue SYSEVAL 151587  by Alessandro Strano  
*HXS 5 32052   -> 32052  l'indirizzo 151587 in esadecimale invertito
***************************************************************************
ASSEMBLE
        CON(3) 0
RPL
xNAME AL             
::
CK0
 ::
   HXS 5 32052 xSYSEVAL
   %0                            ( need to return something )
 ;
;

***************************************************************************
* absolute temperature conversions
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME KC                        ( K->C )
::
CK1&Dispatch
#00001                          ( real )
::
  % 273.15 %-
;
;
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CK                        ( C->K )
::
CK1&Dispatch
#00001                          ( real )
::
  % 273.15 %+
;
;

***************************************************************************
* HMS+
* hh.mmss1 hh.mmss2 -> hh.mmss
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME HP
::
CK2&Dispatch
#00011                          ( %date1 %date2 )
::
  %HMS+
;
;

***************************************************************************
* HMS-
* hh.mmss1 hh.mmss2 -> hh.mmss
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME HM
::
CK2&Dispatch
#00011                          ( %date1 %date2 )
::
  %HMS-
;
;

***************************************************************************
* ddays
* date1 date2 -> ddays
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DD
::
CK2&Dispatch
#00011                          ( %date1 %date2 )
::
* =~xDDAYS        EQU     #0021004
  ROMPTR 004 021                ( ddmmyyyy )
;
;

***************************************************************************
* date plus
* date days -> date'
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DP
::
CK2&Dispatch
#00011                          ( %date %days )
::
* =~xDATE+        EQU     #0022004
  ROMPTR 004 022                ( ddmmyyyy )
;
;

***************************************************************************
* date and time
* -> {date time} & msgbox
***************************************************************************
ASSEMBLE
        CON(3)  8
RPL
xNAME DT
::
CK0
::
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
* =~xDATE         EQU     #001B004 ( d ) 
  ROMPTR 004 01B
* =~xTIME         EQU     #001A004
  ROMPTR 004 01A
  2DUP                          ( d t d t)
* =~xTSTR         EQU     #0020004
  ROMPTR 004 020                ( $data&time )
  Ck&DoMsgBox
  TWO{}N                        ( { d t } )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* day of week
* date -> { 1..7 $day }
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DY
::
CK1&Dispatch
#00001                          ( %date )
::
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
*  DUP DO>STR $ ":\0A" &$
*  SWAP
  %0                            ( --- dummy time )
* =~xTSTR         EQU     #0020004
  ROMPTR 004 020                ( $date&time )
  FOUR 1_#1-SUB$                ( $date $day )
  $ "MONTUEWEDTHUFRISATSUN"     ( $date $day $search )
  OVER ONE                      ( $date $day $search $find 1 )
  POS$                          ( $date $day 1,4,7,... --- must be 1,2,3,... )
  THREE #/ SWAPDROP #1+         ( $date $day 1,2,3,... )
  UNCOERCE                      ( $date $day d )
*  UNROT                         ( d $date $day )
*  &$
*  Ck&DoMsgBox                   ( d )
  SWAP
  TWO{}N                        ( d $day )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* date of (first day of) week of year
* y w -> dd.mmyyyy
* always a monday
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME YW
::
CK2&Dispatch
#00011                          ( %y %w )
::
  FORTYTWO SetSysFlag           ( y w --- EU date format, else err )
  % 7 %* % 4 %-                 ( y 7*w-4 )
  SWAP
  % 1.0E6 %/ % 1.01 %+          ( w' 1.01yyyy )
  SWAP                          ( d1 w' )
  % 15.101582                   ( d1 w' d0 --- reference date )
  3PICK                         ( d1 w' d0 d1 )
  ROMPTR 004 021                ( d1 w' dd --- DDAYS )
  % 7 %MOD %-                   ( d1 d1' )
  ROMPTR 004 022                ( dd.mmyyyy --- DATE+ )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* set date and time
* date time -> time_number [sec since 1.1.1991]
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME SD
::
CK2&Dispatch
#00011                          ( d t )
::
  FORTYONE SetSysFlag           ( n --- EU clock format )
  FORTYTWO SetSysFlag           ( n --- EU date format )
  2DUP                          ( d t d t )
* =~xSETTIME      EQU     #001E004
  ROMPTR 004 01E                ( d t d )
* =~xSETDATE      EQU     #001D004
  ROMPTR 004 01D                ( d t )
  _DTNR
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* time number
* date time -> time_number [sec since 1.1.1991]
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME TN
::
CK2&Dispatch
#00011                          ( d t  )
::
  FORTYONE SetSysFlag           ( d t --- EU clock format )
  FORTYTWO SetSysFlag           ( d t --- EU date format )
  OVER %0<> ITE
    _DTNR
    :: 2DROP _CDTNR ;
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* inverse of time number
* time_number -> { date time }
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME NT
::
CK1&Dispatch
#00001                          ( s )
::
  FORTYONE SetSysFlag           ( s --- EU clock format )
  FORTYTWO SetSysFlag           ( s --- EU date format )
  _NRDT                         ( date time )
  TWO{}N                        ( {date time} )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* CAL
* arg 0 -> current month
* arg dd.mmyyyy -> go there
* calendar with menu
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CA
::
CK1&Dispatch
#00001                          ( 0 or mm.yyyy )
::                              ( arg )
  _SAVESCR                      ( poi arg )
  SWAP                          ( arg poi )
*
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
  DUP %0= IT
    ::                          ( provide current mm.yyyy )
      DROP
      ROMPTR 004 01B            ( dd.mmyyyy )
    ;
  %FP % 100 %*                  ( mm.yyyy )
  DUP %IP                       ( %mm.yyyy %m )
  SWAP                          ( %m %mm.yyyy )
  %FP % 10000 %*                ( %m %y )
*  COERCESWAP COERCESWAP         ( #m #y )
  COERCE2
* menu loop top
  BEGIN                         ( #m #y )
****************************************************************************
  # 0630 #MAX                   ( --- 1584 )
  # 270F #MIN                   ( --- 9999 )
  SWAP
  ONE #MAX
  TWELVE #MIN
  SWAP                          ( #m #y --- range checked )
*
  2DUP                          ( #m #y #m #y )
*  UNCOERCE SWAP UNCOERCE SWAP   ( #m #y %m %y )
  UNCOERCE2
  % 10000 %/ %+
*
  % 100
  %/
  %1 %+
  %0
  ERRSET
  ROMPTR 004 022                ( --- DATE+DAYS )
  ERRTRAP
  ::
    ERRJMP
  ;
  BINT49 ClrSysFlag BINT50 ClrSysFlag           ( --- DOSTD)
  DUP
  BEGIN
  DUP
  % 1E-2
  %MOD
  % 1.01
  %+
  % 1.01199
  OVER
  ROMPTR 004 021                ( --- DDAYS )
  %7
  %MOD
  DUP
  %3
  %>
  IT
  ::
    %7
    %-
  ;
*  UNROT SWAP
  SWAPROT
  ROMPTR 004 021                ( --- DDAYS )
  %+
  %7
  %/
  %FLOOR
  %1 %+
  DUP%0=
  WHILE
  ::
    DROPDUP
    % 3.0109999E1
    %+
  ;
  REPEAT
  OVER
  %FP
  % 100
  %*
  DUP
  %IP COERCE
  ARRY [
    $ "Gen"
    $ "Feb"
    $ "Mar"
    $ "Apr"
    $ "Mag"
    $ "Giu"
    $ "Lug"
    $ "Ago"
    $ "Set"
    $ "Ott"
    $ "Nov"
    $ "Dic"
  ]

  GETATELN
  DROP
  APPEND_SPACE
  SWAP
  %FP
  % 1E4
  %*
  DO>STR
*  DUPLEN$
*  1_#1-SUB$
  &$
* add day number of first day of month
* stack now: flags 2.01 #m #y 1.mmyyyy wk
* use for display of number of first day of month
  CHR_:
  >T$
  5PICK 5PICK
*  2OVER                         ( ... #m #y )
*  UNCOERCE SWAP UNCOERCE SWAP   ( ... %m %y )
  UNCOERCE2
  % 1000000 %/                  ( ... %m .00yyyy )
  DUP                           ( ... %m .00yyyy .00yyyy )
  % 1.01 %+                     ( ... %m .00yyyy 1.01yyyy )
  SWAP                          ( ... %m 1.01yyyy .00yyyy )
  ROT                           ( ... 1.01yyyy .00yyyy %m )
  % 100 %/                      ( ... 1.01yyyy .00yyyy .mm )
  %1 %+ %+                      ( ... 1.01yyyy .00yyyy+1.mm )
  ROMPTR 004 021                ( --- DDAYS )
  %1 %+
  DO>STR
*  DUPLEN$
*  1_#1-SUB$                     ( --- remove decimal dot )
  &$
*
* use ABUFF
*  ClrDA1IsStat
  RECLAIMDISP
  TURNMENUOFF                   ( --- remove menu keys )
*
  $>grob
  ABUFF
  ZEROZERO
  GROB!
*
* put a date and time string in the upper right corner
*
  ROMPTR 004 01B                ( --- DATE )
  ROMPTR 004 01A                ( --- TIME )
  ROMPTR 004 020                ( --- TIMESTR )
*  FIVE NINETEEN SUB$
*  TWENTY                       ( --- TBD: cut off sec? )
*  1_#1-SUB$
  $>grob
  ABUFF
*  BINT72
  BINT50                        ( --- was FIFTYSIX, BINT54, BINT51, BINT50 )
  ZERO
  GROB!
*
  ZERO SEVEN
  BINT130
  BINT7
  LINEON

  $ "Lu Ma Me Gi Ve Sa Do"
  $>GROB
  ABUFF
  BINT11
  BINT9
  GROB!
  OVERDUP
  % 1E-2
  %+
  DUP
  % 1.13
  %>=
  IT
  ::
    % 1.19999E-1
    %-
  ;
  ROMPTR 004 021                ( --- DDAYS )
  COERCE
  $ " 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31"
  SWAP
  BINT3
  #*
  1_#1-SUB$
  % 1.01199
  4ROLL
  ROMPTR 004 021                ( --- DDAYS )
  %7
  %MOD
  COERCE
  BINT3
  #*
*    1234567890123456789012
  $ "                      "    ( --- Blank$ replacement )
  SWAP #1+ 1_#1-SUB$
  SWAP&$
  BINT17
  BEGIN
  3PICK
  % 100
  %+
  DO>STR
  CDR$
*  DUPLEN$
*  1_#1-SUB$
  $>grob
  ABUFF
  BINT0
  4PICK
  #1+
  GROB!
  BINT17
  OVER#=
  4PICK
  % 5.2E1
  %>=
  AND
  IT
  ::
    ROTDROP
    %0
    3UNROLL
  ;
  OVER
  BINT21
  1_#1-SUB$
  $>GROB
  ZEROZERO
  3PICK
  GROBDIM
  SWAP#1-
  SUBGROB
  ABUFF
  BINT11
  4PICK
  GROB!
  ROT
  %1 %+
  ROT
  BINT22
  LAST$
  ROT
  #8+
  OVER LEN$
  #0=
  UNTIL
  3DROP
****************************************************************************
*                               ( #m #y )
*  FLUSHKEYS                     ( m y )
  WaitForKey                    ( m y #c #p )
  DROP                          ( m y #c --- ignore plane for now )
  TURNMENUOFF
  ::
  kcRightArrow #=casedrop       ( --- M+ )
  ::
    SWAP#1+                     ( y m' )
    TWELVE OVER#<               ( y m' m'>12? )
    ITE
     ::                         ( y m' --- m'>12 )
       DROPONE                  ( y 1 )
       SWAP#1+                  ( 1 y+1 )
     ;
     SWAP                       ( m' y )
     FALSE
  ;
  kcLeftArrow #=casedrop        ( --- M- )
  ::
    SWAP                        ( y m )
    DUP#1=                      ( y m m=1? )
    ITE
      ::                        ( y m --- m=1 )
        DROP TWELVE             ( y 12 )
        SWAP#1-                 ( 12 y-1 )
      ;
      ::                        ( y m --- m>1 )
        #1-                     ( y m-1 )
        SWAP                    ( m y )
      ;
    FALSE
  ;
  kcDownArrow #=casedrop        ( --- Y+ )
    :: #1+ FALSE ;
  kcUpArrow #=casedrop          ( --- Y- )
    :: #1- FALSE ;
  kcENTER #=casedrop            ( --- NOW )
  ::                            ( m y )
    2DROP                       
    ROMPTR 004 01B              ( dd.mmyyyy --- DATE )
    %FP                         ( .mmyyyy )
    % 100 %*                    ( mm.yyyy )
    DUP %IP COERCE              ( mm.yyyy m )
    SWAP %FP % 10000 %*         ( m %yyyy )
    COERCE                      ( m y )
    FALSE
  ;
  kcOn #=casedrop :: TRUE ;     ( --- exit )
  DROP DoBadKey FALSE           ( any other key )
  ;
****************************************************************************
  UNTIL                         ( #m #y  )
  UNCOERCE % 1E6 %/
  SWAP UNCOERCE
  % 100 %/ %+                   ( .mmyyyy )

* footer begin
*  xMENU                         ( f )

*  DOSTOSYSF
*  ClrDAsOK
* footer end
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
*                               ( poi out )
  _RESTORESCR                   ( out )
;
;

***************************************************************************
* purge lib from calc
* no args
* MALFUNCT is internal name of lib --- see memory library view
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BYEFUNCT                  ( not easily or accidentally typed in )
::
  CK0                           ( no args )
  '                             ( put pgm on stack )
  ::
    AtUserStack                 ( clear last saved command name )
    # 604 PurgeLib#             ( purge lib 1540 )
  ;
  TOTEMPOB                      ( copy pgm to TEMPOB ... )
  COLA_EVAL                     ( ... and run from there without returning )
;

***************************************************************************
* purge any lib from calc
* libno -> libno
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PURGELIB
::
CK1&Dispatch
#00001                          ( n )
::
  COERCE                        ( #n )
  DUP 1540 #=?SKIP              ( --- do not delete this lib with this cmd )
    ::
      DUP                       ( #n #n )
      PurgeLib#                 ( #n )
    ;
  UNCOERCE                      ( n )
;
;


***************************************************************************
* CALCOLATORE ESADECIMALE BY ALESSANDRO STRANO
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL

DEFINE STO_VA   1PUTLAM
DEFINE STO_SGN  2PUTLAM
DEFINE STO_VB   3PUTLAM
DEFINE STO_POI  4PUTLAM
DEFINE STO_SGNR 5PUTLAM
DEFINE STO_PASS 6PUTLAM
DEFINE STO_NUL  7PUTLAM
DEFINE RCL_VA   1GETLAM
DEFINE RCL_SGN  2GETLAM
DEFINE RCL_VB   3GETLAM
DEFINE RCL_POI  4GETLAM
DEFINE RCL_SGNR 5GETLAM
DEFINE RCL_PASS 6GETLAM
DEFINE RCL_NUL  7GETLAM

xNAME HEX
::
 CK1&Dispatch
 #00001                          ( real )
::
 0 0 0 0 0 0 0
 {
   NULLLAM NULLLAM NULLLAM NULLAM NULLAM NULLAM NULLAM
 }
 BIND 

   _SAVESCR ( poi ) 
   STO_POI

   ZERO UNCOERCE STO_VB
*GESTISCE IL VALORE PASSATO
    _AGGHEX 
    DUP
    STO_VA
    BINT2 STO_PASS
    BINT0 STO_SGN
    _PREPDEC
    % 16 _TOBASE
    DISPROW5
*-------------------------

 $ "Hex - A. Strano" DISPROW1
*   123456789012345678901 
   _MOSTRALABEL
   ZERO FORTYFOUR
   BINT130
   BINT44
   LINEON
   
  
 
 
  
BEGIN
   RCL_POI	
   EIGHT _GETHEX2  ( poi len s BINT )    
   STO_SGNR ( poi len s )
   SWAPDROP ( poi s )
   SWAPDROP ( s )	
   
   DUPNULL$? 
   ITE 
      :: BINT1 STO_NUL 
      ;
      :: BINT0 STO_NUL  
   ;   

   RCL_NUL BINT1 #=
   ITE
      ::
        DROP ;  
      ::
        DUP DISPROW5

        % 16 _FMBASE ( dec1 )
         DUP
        _MOSTRAUNS
        _AGGHEX
        DUP STO_VB
        _MOSTRASIG
    ;   

 
   RCL_SGNR BINT9 #= ( pressato HOME )
   IT :: BINT0 STO_PASS ;

   RCL_SGNR BINT5 #=  ( pressato ON )
   IT :: BINT3 STO_PASS ;

 
   RCL_SGNR BINT13 #=  ( NOT )
   IT ::
        RCL_NUL BINT1 #= 
        ITE 
            :: ( SE E' STATO PREMUTO SOLO L'OPERATORE LAVORA SU VA )
               RCL_VA %CHS 
               %1 %-
               DUP STO_VA 
               _PREPDEC
               % 16 _TOBASE
               DISPROW5
               BINT0 STO_SGNR
               BINT4 STO_PASS               
              ;
             :: ( SE E' STATO PREMUTO VALORE + L'OPERATORE LAVORA SU VB )
	       RCL_VB %CHS 
               %1 %-
                DUP STO_VB 
               _PREPDEC
               % 16 _TOBASE
               DISPROW5
               BINT0 STO_SGNR
        ;
   ; 

   RCL_SGNR BINT14 #=  ( NEG )
   IT ::
	RCL_NUL BINT1 #= 
        ITE 
            :: ( SE E' STATO PREMUTO SOLO L'OPERATORE LAVORA SU VA )
              RCL_VA %CHS 
              DUP STO_VA 
              _PREPDEC
              % 16 _TOBASE
              DISPROW5
              BINT0 STO_SGNR
              BINT4 STO_PASS
            ;
            :: ( SE E' STATO PREMUTO VALORE + L'OPERATORE LAVORA SU VB )
              RCL_VB %CHS 
              DUP STO_VB 
              _PREPDEC
              % 16 _TOBASE
              DISPROW5
              BINT0 STO_SGNR
        ;
   ; 


RCL_SGNR BINT15 #=  ( pressato SWAP )
   IT :: 
       RCL_SGN BINT0 #<>
       ITE :: 
            RCL_VB RCL_VA STO_VB STO_VA
            RCL_VA
            _PREPDEC
            % 16 _TOBASE
            DISPROW5
            BINT2 STO_PASS 
            BINT0 STO_SGNR
          ; 
           ::
            BINT0 STO_SGNR 
            BINT4 STO_PASS
       ;
   ;


*---- ( SE L'OPERATORE VIENE INSERITO DOPO )
  RCL_PASS BINT2 #=   
  IT ::
     RCL_SGNR BINT0 #<>
     IT ::
        RCL_SGN BINT0 #=
        IT ::
           RCL_NUL BINT1 #=
           ITE ::
               RCL_SGNR STO_SGN ( E' STATO INSERITO SOLO OPERATORE, QUINDI LO PRENDO ) 
               BINT4 STO_PASS
               ; 
               ::
               BINT5 STO_PASS  ( E' STATO INSERITO VALORE + OPERATORE SOVRASCRIVO I PRIMI VALORI )
           ; 
        ; 		
      ; 
   ;
*----




   RCL_PASS 
   ::
     
     BINT2 #=casedrop :: 
                         RCL_SGN BINT0 #=
                         IT ::
                             RCL_SGNR BINT0 #<>
                             IT :: RCL_SGNR STO_SGN
                             ;
                         ;
                 
                     ERRSET
                       ::
                                 
                         RCL_SGN
                         ::
                           BINT1 #=casedrop :: RCL_VA RCL_VB %- ;
                           BINT2 #=casedrop :: RCL_VA RCL_VB %+ ;
                           BINT3 #=casedrop :: RCL_VA RCL_VB %* ;
                           BINT4 #=casedrop :: RCL_VA RCL_VB %/ %0 TRCXY ;
                           BINT10 #=casedrop :: RCL_VA RCL_VB %0 _MYBOP _AGGHEX ; ( AND )
                           BINT11 #=casedrop :: RCL_VA RCL_VB %1 _MYBOP _AGGHEX ; ( OR )
                           BINT12 #=casedrop :: RCL_VA RCL_VB %-1 _MYBOP _AGGHEX ; ( XOR )
                           DROP DoBadKey :: RCL_VB ;
                         ;
                         
                         DUP STO_VA
                         _PREPDEC
                         % 16 _TOBASE 
                         DISPROW5
                         RCL_SGNR STO_SGN    	

                      ;
                   ERRTRAP
                     ::

                     BINT2 STO_PASS 
                     ZERO UNCOERCE STO_VA 
                     ZERO UNCOERCE STO_VB
                     BINT0 STO_SGN 
                     BINT0 STO_SGNR
                     RCL_VA DUP
                     DO>STR DISPROW5
                     _PREPDEC
                     DROP

                     $ "Error" Ck&DoMsgBox
                     TURNMENUOFF
                     _MOSTRALABEL
                     ERRORCLR
                     ;

                    ;      
     BINT3 #=casedrop ::  BINT2 STO_PASS 
                          ZERO UNCOERCE STO_VA 
                          ZERO UNCOERCE STO_VB
                          BINT0 STO_SGN 
                          BINT0 STO_SGNR
                          RCL_VA DUP
                          DO>STR DISPROW5
                          _PREPDEC
                          DROP
                       ;


     BINT4 #=casedrop :: BINT2 STO_PASS ; 

     BINT5 #=casedrop ::                       
                          RCL_SGNR STO_SGN 
                          RCL_VB STO_VA
                          BINT2 STO_PASS
                      ;

   ;

   
   RCL_PASS BINT0 #=
       
UNTIL 
 
*********FINE
   DROP
   RCL_POI
   RCL_VA
   ABND
  _RESTORESCR
;
;		

***************************************************************************
* CALCOLATORE BINARIO BY ALESSANDRO STRANO
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL

DEFINE STO_VA   1PUTLAM
DEFINE STO_SGN  2PUTLAM
DEFINE STO_VB   3PUTLAM
DEFINE STO_POI  4PUTLAM
DEFINE STO_SGNR 5PUTLAM
DEFINE STO_PASS 6PUTLAM
DEFINE STO_NUL  7PUTLAM
DEFINE RCL_VA   1GETLAM
DEFINE RCL_SGN  2GETLAM
DEFINE RCL_VB   3GETLAM
DEFINE RCL_POI  4GETLAM
DEFINE RCL_SGNR 5GETLAM
DEFINE RCL_PASS 6GETLAM
DEFINE RCL_NUL  7GETLAM

xNAME BIN
::
 CK1&Dispatch
 #00001                          ( real )
::
 0 0 0 0 0 0 0
 {
   NULLLAM NULLLAM NULLLAM NULLAM NULLAM NULLAM NULLAM
 }
 BIND 

   _SAVESCR ( poi ) 
   STO_POI

   ZERO UNCOERCE STO_VB
*GESTISCE IL VALORE PASSATO
    _AGGBIN
    DUP    
    STO_VA
    BINT2 STO_PASS
    BINT0 STO_SGN
    _PREPDECB
    % 2 _TOBASE
    DISPROW5
*-------------------------

 $ "Bin - A. Strano" DISPROW1
*   123456789012345678901 
   _MOSTRALABEL
   ZERO FORTYFOUR
   BINT130
   BINT44
   LINEON

BEGIN
   RCL_POI	
   SIXTEEN _GETBIN2  ( poi len s BINT )    

   STO_SGNR

   SWAPDROP ( poi s )
   SWAPDROP ( s )	

   DUPNULL$?
   ITE 
      :: BINT1 STO_NUL 
      ;
      :: BINT0 STO_NUL  
   ;   


   RCL_NUL BINT1 #=
   ITE
      ::
        DROP ;
      ::
        DUP DISPROW5
        % 2 _FMBASE ( dec1 )
        DUP
        _MOSTRAUNS 
        _AGGBIN 
        DUP STO_VB
        _MOSTRASIG
    ;   

   RCL_SGNR BINT9 #= ( pressato HOME )
   IT :: BINT0 STO_PASS ;

   RCL_SGNR BINT5 #=  ( pressato ON )
   IT :: BINT3 STO_PASS ;

 RCL_SGNR BINT13 #=  ( NOT )
   IT ::
        RCL_NUL BINT1 #= 
        ITE 
            :: ( SE E' STATO PREMUTO SOLO L'OPERATORE LAVORA SU VA )
               RCL_VA %CHS 
               %1 %-
               DUP STO_VA 
               _PREPDECB
               % 2 _TOBASE
               DISPROW5
               BINT0 STO_SGNR
               BINT4 STO_PASS               
              ;
             :: ( SE E' STATO PREMUTO VALORE + L'OPERATORE LAVORA SU VB )
	       RCL_VB %CHS 
               %1 %-
               DUP STO_VB 
               _PREPDECB
               % 2 _TOBASE
               DISPROW5
               BINT0 STO_SGNR
        ;
   ; 

   RCL_SGNR BINT14 #=  ( NEG )
   IT ::
	RCL_NUL BINT1 #= 
        ITE 
            :: ( SE E' STATO PREMUTO SOLO L'OPERATORE LAVORA SU VA )
              RCL_VA %CHS 
              DUP STO_VA 
              _PREPDECB
              % 2 _TOBASE
              DISPROW5
              BINT0 STO_SGNR
              BINT4 STO_PASS
            ;
            :: ( SE E' STATO PREMUTO VALORE + L'OPERATORE LAVORA SU VB )
              RCL_VB %CHS 
              DUP STO_VB 
              _PREPDECB
              % 2 _TOBASE
              DISPROW5
              BINT0 STO_SGNR
        ;
   ; 

RCL_SGNR BINT15 #=  ( pressato SWAP )
   IT :: 
       RCL_SGN BINT0 #<>
       ITE :: 
            RCL_VB RCL_VA STO_VB STO_VA
            RCL_VA
            _PREPDECB
            % 2 _TOBASE
            DISPROW5
            BINT2 STO_PASS 
            BINT0 STO_SGNR
          ; 
           ::
            BINT0 STO_SGNR 
            BINT4 STO_PASS
       ;
   ;

*---- ( SE L'OPERATORE VIENE INSERITO DOPO )
  RCL_PASS BINT2 #=   
  IT ::
     RCL_SGNR BINT0 #<>
     IT ::
        RCL_SGN BINT0 #=
        IT ::
           RCL_NUL BINT1 #=
           ITE ::
               RCL_SGNR STO_SGN ( E STATO INSERITO SOLO OPERATORE, QUINDI LO PRENDO ) 
               BINT4 STO_PASS
               ; 
               ::
               BINT5 STO_PASS  ( E STATO INSERITO VALORE + OPERATORE SOVRASCRIVO I PRIMI VALORI )
           ; 
        ; 		
      ; 
   ;
*----


   RCL_PASS 
   ::

     BINT2 #=casedrop :: 
                         RCL_SGN BINT0 #=
                         IT ::
                             RCL_SGNR BINT0 #<>
                             IT :: RCL_SGNR STO_SGN 
                             ;  
                         ;
                                                  
                      
                    ERRSET
                       ::
                         RCL_SGN
                         ::
                           BINT1 #=casedrop :: RCL_VA RCL_VB %- ;
                           BINT2 #=casedrop :: RCL_VA RCL_VB %+ ;
                           BINT3 #=casedrop :: RCL_VA RCL_VB %* ;
                           BINT4 #=casedrop :: RCL_VA RCL_VB %/ %0 TRCXY ;
                           BINT10 #=casedrop :: RCL_VA RCL_VB %0 _MYBOP _AGGBIN ; ( AND )
                           BINT11 #=casedrop :: RCL_VA RCL_VB %1 _MYBOP _AGGBIN ; ( OR )
                           BINT12 #=casedrop :: RCL_VA RCL_VB %-1 _MYBOP _AGGBIN ; ( XOR )
                           DROP DoBadKey :: RCL_VB ;
                         ;
                         DUP STO_VA
                         _PREPDECB
                         % 2 _TOBASE 
                         DISPROW5
                         RCL_SGNR STO_SGN    	
                      ;
                   ERRTRAP
                     ::
 
                       BINT2 STO_PASS 
                       ZERO UNCOERCE STO_VA 
                       ZERO UNCOERCE STO_VB
                       BINT0 STO_SGN 
                       BINT0 STO_SGNR
                       RCL_VA DUP
                       DO>STR DISPROW5
                       _PREPDECB
                       DROP
  
                       $ "Error" Ck&DoMsgBox
                       TURNMENUOFF
                       _MOSTRALABEL
                       ERRORCLR
                     ;           
                    ;

     BINT3 #=casedrop ::  BINT2 STO_PASS 
                          ZERO UNCOERCE STO_VA 
                          ZERO UNCOERCE STO_VB 
                          BINT0 STO_SGN 
                          BINT0 STO_SGNR
                          RCL_VA DUP
                          DO>STR DISPROW5
                          _PREPDECB
                          DROP   ( ????? DUBBIO SU QUESTO DROP )
                       ;


     BINT4 #=casedrop :: BINT2 STO_PASS ; 

     BINT5 #=casedrop :: RCL_SGNR STO_SGN 
                         RCL_VB STO_VA
                         BINT2 STO_PASS
                      ;

   ;

   
   RCL_PASS BINT0 #=
       
UNTIL
 
*********FINE
   DROP
   RCL_POI
   RCL_VA
   ABND
  _RESTORESCR  
;
;		

*****************************************************************************
* Auxiliary Routines
*****************************************************************************

*****************************************************************************
* MOSTRA VALORE IN DECIMALE SEGNATO
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _MOSTRASIG
::
  DO>STR $ " sig= " SWAP &$
  DISPROW3
;

*****************************************************************************
* ETICHETTE
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _MOSTRALABEL
::
 $ "and or  xor not    xch" DISPROW8
;

*****************************************************************************
* MOSTRA VALORE IN DECIMALE NON SEGNATO
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _MOSTRAUNS
::
  DO>STR $ " uns= " SWAP &$
  DISPROW2
;

*****************************************************************************
* AGGIUSTA I VALORI REALI OPERAZIONI SU BIT - CALC. ESADECIMALE
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _AGGHEX
::

  % 4294967296 %MOD

  DUP % 2147483647 %>
  IT :: % 4294967296 %- ;
;

*****************************************************************************
* AGGIUSTA I VALORI REALI DOPO OPERAZIONI SU BIT - CALC. BINARIO
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _AGGBIN
::
  % 65536 %MOD

  DUP % 32767 %>
  IT :: % 65536 %- ;
;

*****************************************************************************
* PREPARA I VALORI DECIMALI PER CONVERSIONI IN ESADECIMALE CON SEGNO
* by Alessandro Strano
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _PREPDEC
::
 DUP _MOSTRASIG 

 %0 RNDXY                      ( d --- rounded to zero fractional digits )
  DUP %0 %<                     ( d d<0? )
  ITE
   ::                           ( d --- d<0 )
     DUP % -2147483648          ( d d minint )
     %< IT :: DROP SETSIZEERR ;          ( d --- d<minint? )
     % 4294967296 %+            ( d' --- 2-complement )
   ;
   ::                           ( d --- d>= 0 )
     DUP % 2147483647 %>        ( d d>maxint? )
     IT :: DROP SETSIZEERR ;              ( d )
   ;

   DUP _MOSTRAUNS
;

*****************************************************************************
* PREPARA I VALORI DECIMALI PER CONVERSIONI IN BINARIO CON SEGNO
* by Alessandro Strano
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _PREPDECB
::
  DUP _MOSTRASIG

  %0 RNDXY                      ( d --- rounded to zero fractional digits )
  DUP %0 %<                     ( d d<0? )
  ITE
   ::                           ( d --- d<0 )
     DUP % -32768        ( d d minint )
     %< IT :: DROP SETSIZEERR ;           ( d --- d<minint? )
     % 65536 %+            ( d' --- 2-complement )
   ;
   ::                           ( d --- d>= 0 )
     DUP % 32767  %>        ( d d>maxint? )
     IT :: DROP SETSIZEERR ;              ( d )
   ;
 
   DUP _MOSTRAUNS
   
;

***************************************************************************
* bit logic ops on two reals
* %a %b %p ->
* p = 0: AND
* p = 1: OR
* p = -1: XOR
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
NULLNAME _MYBOP
::
  %1 %+ COERCE                  ( a b p --- p mapped to 0/1/2 )
  UNROT                         ( p a b )
  _D32                          ( p a b )
  UNROT                         ( b p a )
  _D32                          ( b p a )
  UNROT                         ( a b p --- a,b string[32], #p )
  ::                            ( a b p )
    BINT0 #=casedrop
      ::                        ( a b --- XOR )
        BINT32                  ( --- loop thru all chars )
        #1+_ONE_DO (DO)         ( a b )
          DUPINDEX@             ( a b b i )
          SUB$1#                ( a b b[i] )
          3PICK                 ( a b b[i] a )
          INDEX@                ( a b b[i] a i )
          SUB$1#                ( a b b[i] a[i] )
          #=ITE
            BINT48 BINT49
          INDEX@ SWAP           ( a b 0/1 i )
          _SWC                  ( a b' )
        LOOP                    ( a b' )
      ;
    BINT1 #=casedrop
      ::                        ( s n --- AND )
        BINT32                  ( --- loop thru all chars )
        #1+_ONE_DO (DO)         ( a b )
          DUPINDEX@             ( a b b i )
          SUB$1#                ( a b b[i] )
          3PICK                 ( a b b[i] a )
          INDEX@                ( a b b[i] a i )
          SUB$1#                ( a b b[i] a[i] )
          BINT49 #=
          SWAP
          BINT49 #=
          ANDITE
            BINT49 BINT48
          INDEX@ SWAP           ( a b 0/1 i )
          _SWC                  ( a b' )
        LOOP                    ( a b' )
      ;
    BINT2 #=casedrop
      ::                        ( s n --- OR )
        BINT32                  ( --- loop thru all chars )
        #1+_ONE_DO (DO)         ( a b )
          DUPINDEX@             ( a b b i )
          SUB$1#                ( a b b[i] )
          3PICK                 ( a b b[i] a )
          INDEX@                ( a b b[i] a i )
          SUB$1#                ( a b b[i] a[i] )
          BINT49 #=
          SWAP
          BINT49 #=
          OR ITE
            BINT49 BINT48
          INDEX@ SWAP           ( a b 0/1 i )
          _SWC                  ( a b' )
        LOOP                    ( a b' )
      ;
    SETSIZEERR                  ( --- bad arg value )
  ;                             ( a b' )
  SWAPDROP                      ( b' )
  %2 _FMBASE                    ( dez )
;

*****************************************************************************
* conversion hex -> decimal
* s -> %
* s expected to contain valid and upcase hex chars
*****************************************************************************
RPL
NULLNAME _HEXDEZ
::
  DUPNULL$?
  ITE
    %0                          ( 0 --- result for empty string )
    ::                          ( s --- nonempty, do the conversion )
      %0 %1                     ( s 0 1 --- initialize sum and factor )
      ROT                       ( sum fac s )
      DUPLEN$                   ( sum fac s lens )
      #1+_ONE_DO (DO)           ( sum fac s )
        DUP DUPLEN$             ( sum fac s s lens )
        #1+                     ( sum fac s s lens+1 )
        INDEX@#-                ( sum fac s s lens-i+1 --- lens,lens-1,... )
        SUB$1#                  ( sum fac s #s[j] )
* 0..9 = 48..57, A..F = 65..70
        FORTYEIGHT #-           ( sum fac s c )
* 0..9 = 0..9, A..F = 17..22
        DUP NINE #>
        IT :: SEVEN #- ;        ( sum fac s 0..15 )
        UNCOERCE                ( sum fac s %0..15 )
        ROT                     ( sum s %c fac )
        DUP % 16 %*             ( sum s %c fac fac' )
        4UNROLL                 ( sum fac' s %c fac )
        %*                      ( sum fac' s %f )
        4ROLL                   ( fac' s %f sum )
        %+                      ( fac' s sum' )
        UNROT                   ( sum' fac' s )
      LOOP                      ( sum fac s )
      2DROP                     ( %sum )
    ;
;

*****************************************************************************
* unique number for each date and time, based on 1.1.1991
* date time -> dtnr [sec]
*****************************************************************************
RPL
NULLNAME _DTNR
::                              ( dd tt )
  %HMS>                         ( dd h )
  % 3600 %*                     ( dd hsec )
  % 1.011991                    ( dd hsec ref)
  ROT                           ( hsec ref dd )
  ROMPTR 004 021                ( hsec ddays --- ddays )
  % 86400 %*                    ( hsec dsec )
  %+                            ( dhsec )
;

*****************************************************************************
* current _DTNR
* -> cdtnr [sec]
*****************************************************************************
RPL
NULLNAME _CDTNR
::
  ROMPTR 004 01B                ( dd )
  ROMPTR 004 01A                ( tt )
  _DTNR                         ( sec )
;

*****************************************************************************
* converse of _DTNR
* dtnr -> date time
*****************************************************************************
RPL
NULLNAME _NRDT
::                              ( s )
  % 86400 2DUP                  ( s 86400 s 86400 )
  %/ %IP                        ( s 86400 dd )
  % 1.011991 OVER               ( s 86400 dd refdate dd )
  ROMPTR 004 022                ( s 86400 dd date --- DATEPLUS )
  4UNROLL                       ( date s 86400 dd )
  %* %-                         ( date dt )
  % 3600 %/                     ( date h )
  %>HMS                         ( date time )
;


*****************************************************************************
* GETHEX2 by Alessandro Strano
*****************************************************************************
RPL
NULLNAME _GETHEX2
::
  FLUSHKEYS
  NULL$                         ( len s --- initial user entry )
  BEGIN                         
    DUPLEN$ 3PICK #> ( MAX ... CIFRE - len s lens )
    IT :: DUPLEN$ 
          1_#1-SUB$ 
    ;		
    DUP CHR_Space >T$        ( s s_ )
    DISPROW7                    ( s )
    WaitForKey                  ( s #c #p )
    DROP                        ( s #c --- plane of no interest )
    ::
      kcA #=casedrop :: CHR_A >T$ FALSE ;
      kcB #=casedrop :: CHR_B >T$ FALSE ;
      kcC #=casedrop :: CHR_C >T$ FALSE ;
      kcD #=casedrop :: CHR_D >T$ FALSE ;
      kcE #=casedrop :: CHR_E >T$ FALSE ;
      kcF #=casedrop :: CHR_F >T$ FALSE ;

      kc0 #=casedrop :: CHR_0 >T$ FALSE ;
      kc1 #=casedrop :: CHR_1 >T$ FALSE ;
      kc2 #=casedrop :: CHR_2 >T$ FALSE ;
      kc3 #=casedrop :: CHR_3 >T$ FALSE ;
      kc4 #=casedrop :: CHR_4 >T$ FALSE ;
      kc5 #=casedrop :: CHR_5 >T$ FALSE ;
      kc6 #=casedrop :: CHR_6 >T$ FALSE ;
      kc7 #=casedrop :: CHR_7 >T$ FALSE ;
      kc8 #=casedrop :: CHR_8 >T$ FALSE ;
      kc9 #=casedrop :: CHR_9 >T$ FALSE ;

      kcHOME #=casedrop :: BINT9 TRUE ; ( len s bint T  --- exit )

      kcMinus #=casedrop :: BINT1 TRUE ; ( len s bint T)
      kcPlus #=casedrop :: BINT2 TRUE ; ( len s bint T)
      kcMult #=casedrop :: BINT3 TRUE ; ( len s bint T)
      kcDiv #=casedrop :: BINT4 TRUE ; ( len s bint T)


      kcF1 #=casedrop :: BINT10 TRUE ; ( len s bint T)
      kcF2 #=casedrop :: BINT11 TRUE ; ( len s bint T)
      kcF3 #=casedrop :: BINT12 TRUE ; ( len s bint T)
      kcF4 #=casedrop :: BINT13 TRUE ; ( len s bint T)
      kcF6 #=casedrop :: BINT15 TRUE ; ( len s bint T)
      kcNeg #=casedrop :: BINT14 TRUE ; ( len s bint T)

      kcOn #=casedrop ::
          DUPNULL$?
          ITE
            :: BINT5 TRUE ;                ( s T --- DOESN'T ESC )
            ::
              DROPNULL$         ( s --- clear input )
              FALSE             ( s F )
            ;
        ;
      kcDEL #=casedrop ::
          DUPLEN$               ( --- delete last char )
          1_#1-SUB$
          FALSE
        ;
      kcENTER #=casedrop :: 
                           DUPNULL$?
                           ITE
                              :: FALSE ;                ( s T --- DOESN'T ESC )
                              ::
                                 BINT0 TRUE         ( s --- clear input )
                           ;
  
                         ;
      DROP DoBadKey FALSE       ( any other key )
    ;

  UNTIL                         ( len s bint )
;

*****************************************************************************
* GETBIN2 by Alessandro Strano
*****************************************************************************
RPL
NULLNAME _GETBIN2
::
  FLUSHKEYS
  NULL$                         ( s --- initial user entry )
  BEGIN
    DUPLEN$ 3PICK #> ( MAX ... CIFRE)
    IT :: DUPLEN$ 
          1_#1-SUB$ 
    ;		
    DUP CHR_Space >T$          ( s s_ )
    DISPROW7                    ( s )
    WaitForKey                  ( s #c #p )
    DROP                        ( s #c --- plane of no interest )
    ::
      kc0 #=casedrop :: CHR_0 >T$ FALSE ;
      kc1 #=casedrop :: CHR_1 >T$ FALSE ;

      kcHOME #=casedrop :: BINT9 TRUE ; ( len s bint T  --- exit )

      kcMinus #=casedrop :: BINT1 TRUE ; ( len s bint T)
      kcPlus #=casedrop :: BINT2 TRUE ; ( len s bint T)
      kcMult #=casedrop :: BINT3 TRUE ; ( len s bint T)
      kcDiv #=casedrop :: BINT4 TRUE ; ( len s bint T)

      kcF1 #=casedrop :: BINT10 TRUE ; ( len s bint T)
      kcF2 #=casedrop :: BINT11 TRUE ; ( len s bint T)
      kcF3 #=casedrop :: BINT12 TRUE ; ( len s bint T)
      kcF4 #=casedrop :: BINT13 TRUE ; ( len s bint T)
      kcF6 #=casedrop :: BINT15 TRUE ; ( len s bint T)

      kcNeg #=casedrop :: BINT14 TRUE ; ( len s bint T)

      kcOn #=casedrop ::
          DUPNULL$?
          ITE
            :: BINT5 TRUE ;                ( s T --- DOESN'T ESC )
            ::
              DROPNULL$         ( s --- clear input )
              FALSE             ( s F )
            ;
        ;
      kcDEL #=casedrop ::
          DUPLEN$               ( --- delete last char )
          1_#1-SUB$
          FALSE
        ;
      kcENTER #=casedrop :: 
                           DUPNULL$?
                           ITE
                              :: FALSE ;                ( s T --- DOESN'T ESC )
                              ::
                                 BINT0 TRUE         ( s --- clear input )
                           ;
  
                         ;
      DROP DoBadKey FALSE       ( any other key )
    ;

  UNTIL                         ( len s bint )
;


*****************************************************************************
* unsigned integer base conversion to decimal
* $s %b -> %d
* s expected to contain only valid and upcase chars
* uses 0..9, A..F..
*****************************************************************************
NULLNAME _FMBASE
::                              ( $s %b )
  SWAP                          ( b s )
  DUPNULL$?
  ITE
    ::                          ( b s ---  s empty )
      2DROP %0                  ( 0 --- result for empty string )
    ;
    ::                          ( b s --- nonempty, do the conversion )
      %0 %1                     ( b s 0 1 --- initialize sum and factor )
      ROT                       ( b sum fac s )
      DUPLEN$                   ( b sum fac s lens )
      #1+_ONE_DO (DO)           ( b sum fac s )
        DUP DUPLEN$             ( b sum fac s s lens )
        #1+                     ( b sum fac s s lens+1 )
        INDEX@#-                ( b sum fac s s lens-i+1 --- lens,lens-1,... )
        SUB$1#                  ( b sum fac s #s[j] )
* 0..9 = 48..57, A..F = 65..70
        FORTYEIGHT #-           ( b sum fac s c )
* 0..9 = 0..9, A..F = 17..22
        DUP NINE #>
        IT :: SEVEN #- ;        ( b sum fac s 0..15 )
        UNCOERCE                ( b sum fac s %0..15 )
        ROT                     ( b sum s %c fac )
        DUP                     ( b sum s %c fac fac )
        6PICK                   ( b sum s %c fac fac b )
        %*                      ( b sum s %c fac fac' )
        4UNROLL                 ( b sum fac' s %c fac )
        %*                      ( b sum fac' s %f )
        4ROLL                   ( b fac' s %f sum )
        %+                      ( b fac' s sum' )
        UNROT                   ( b sum' fac' s )
      LOOP                      ( b sum fac s )
      2DROP                     ( b %sum )
      SWAPDROP                  ( %d )
    ;
;

*****************************************************************************
* unsigned integer base conversion from decimal
* %d %b -> $s
* $s contains only valid and upcase chars
* uses 0..9, A..F..
*****************************************************************************
NULLNAME _TOBASE
::                              ( %d %b )
  SWAP                          ( b d )
  NULL$SWAP                     ( b s d --- dst string initialized )
  BEGIN                         ( b s d )
    3PICK 2DUP                  ( b s d b d b )
    %MOD                        ( b s d b %rem )
    COERCE                      ( b s d b rem )
    FORTYEIGHT #+               ( b s d b rem' )
    DUP FIFTYEIGHT #< ?SKIP     ( b s d b rem' )
      :: SEVEN #+ ;             ( b s d b rem'' )
    #>CHR                       ( b s d b sc )
    4ROLL                       ( b d b sc s )
    SWAP                        ( b d b s sc )
    >H$                         ( b d b s' )
    UNROT                       ( b s' d b )
    %/ %IP                      ( b s' d' )
    DUP %0=                     ( b s' d' T|F )
  UNTIL                         ( b s d )
  ROT2DROP                      ( $s )
;

*****************************************************************************
* dez to 32bit string
* %d -> $s
* s[i] = 0 or 1, length(s) = 32 with leading zeros, if any
* for use with binary arithmetic
* unsigned integer 0..2^32-1 = 0 .. 4,294,967,295, dez checked for this
* -2,147,483,648 <= dez < 0 converted to 2-complement:
* dez' = 4,294,967,296 + dez
* -1 -> 4,294,967,295 etc.
*****************************************************************************
NULLNAME _D32
::
  %0 RNDXY                      ( d --- rounded to zero fractional digits )
  DUP %0 %<                     ( d d<0? )
  ITE
   ::                           ( d --- d<0 )
     DUP % -2147483648          ( d d minint )
     %< IT SETSIZEERR           ( d --- d<minint? )
     % 4294967296 %+            ( d' --- 2-complement )
   ;
   ::                           ( d --- d>= 0 )
     DUP % 4294967295 %>        ( d d>maxint? )
     IT SETSIZEERR              ( d )
   ;
  %2 _TOBASE                    ( s )
  DUPLEN$                       ( s lens )
  BINT32 SWAP#-                 ( s n0 --- number of zeros to be leftpadded )
  DUP#0=ITE                     ( s n0 )
    DROP                        ( s )
    ::                          ( s n0 --- n0 > 0 )
      #1+_ONE_DO (DO)           ( s --- leftpad with '0' to length 32 )
        CHR_0 >H$
      LOOP                      ( s' )
    ;
;                               ( s' )

***************************************************************************
* string_write_char_code
* write char(c) at position n in string s
* s n c -> s'
* n out of range does nothing
***************************************************************************
NULLNAME _SWC
::                              ( s #n #c )
ROT CKREF UNROT                 ( -- free up s )
CODE                            ( machine language begin )
*--------------------------------------------------------------------------
* Prolog
*--------------------------------------------------------------------------
        GOSBVL  =$jPOP#         ( pop system binary into A[A] )
        R3=A.F  A               ( R3 = c = charcode )
        GOSBVL  =$jPOP#         ( pop system binary into A[A] )
        R2=A.F  A               ( R2 = n = index )
        GOSBVL  =$jSAVPTR       ( save system pointers )
*--------------------------------------------------------------------------
* Core Code
*--------------------------------------------------------------------------
*        GOSBVL  =GetStrLenStk   ( now: C.A = length, D1 = body )
        C=DAT1  A               ( get adr of s )
        D1=C                    ( points to s )
        D1=D1+  5               ( skip prolog to get length )
        C=DAT1  A               ( get total length, incl. length itself )
        C=C-CON A,5             ( true length, number of char nibbles )
        D1=D1+  5               ( D1 points to first char of s )
*
        ?C=0    A               ( empty string? )
        GOYES   RausSWC         ( yes, do nothing )
        A=R2.F  A               ( A = n )
        ?A=0    A               ( n=0? )
        GOYES   RausSWC         ( yes, do nothing )
        A=A+A   A               ( n*2 for nibble address )
        A=A-CON A,2             ( n=1 points to nibble 0 )
        ?C<A    A               ( n > length? )
        GOYES   RausSWC         ( yes, do nothing )
        CD1EX                   ( calculate write address )
        C=C+A   A
        CD1EX
        C=R3.F  A               ( get char to write )
        DAT1=C  B               ( write byte )
*--------------------------------------------------------------------------
* Epilog
*--------------------------------------------------------------------------
RausSWC GOVLNG  =$jGETPTRLOOP   ( return to RPL )
ENDCODE                         ( machine language end )
;                               ( s )


***************************************************************************
* save and restore text screen
* for full screen functions
* to be used with stack balance!
* _SAVESCR   : -> poi'
* _RESTORESCR: poi' out -> out --- out is function output
***************************************************************************
RPL
NULLNAME _SAVESCR
::
  ABUFF                         ( poi --- pointer to current screen )
  TOTEMPOB                      ( poi' --- make a copy ) 
  RECLAIMDISP                   ( poi' --- get and clear text grob )
  TURNMENUOFF                   ( poi' --- remove menu keys )
;

RPL
NULLNAME _RESTORESCR
::                              ( poi' out --- pointer to saved screen in tmp )
  SWAP                          ( out poi' )
  ZEROZERO                      ( poi' 0 0 )
  ROT                           ( 0 0 poi' )
  XYGROBDISP                    ( --- current screen restored )
* does not work, and SysDisplay and ClrDAsOK not in entry points
*  ClrDA1OK                      ( --- redraw )
*  ClrDA2OK                      ( --- redraw )
*  ClrDA3OK                      ( --- redraw )
  TURNMENUOFF                   ( --- remove ineffective menues at least )
;

*****************************************************************************
* Revision
*****************************************************************************
ASSEMBLE
        CON(3)  8
RPL
xNAME MALFUNCT
::
  CK0
  $ "MAL/20140404"
;

*****************************************************************************
* End
*****************************************************************************
