*****************************************************************************
* L1540 RPL Standalone Library for HP39/40G                 M.A.L./13.03.2003
*****************************************************************************
*
* History of changes
*
* 20.11.2001  creation
* 22.07.2002  first release
* 25.01.2003  fixes and enhancements
* 03.03.2003  pre-release for comments
* 13.03.2003  final release
*
* Library number, make sure it's consistent everywhere
xROMID 604

    TITLE       MAL RPL Standalone Library

*****************************************************************************
* Aux Routines Declaration
*****************************************************************************
EXTERNAL _DUMMY
EXTERNAL _DTNR
EXTERNAL _CDTNR
EXTERNAL _NRDT
EXTERNAL _BRENT
EXTERNAL _LKCHK
EXTERNAL _RCP
EXTERNAL _BINO
EXTERNAL _MEX
EXTERNAL _GETLIST
EXTERNAL _AZL
EXTERNAL _LAZ
EXTERNAL _PGMRUN
EXTERNAL _PGMSRUN

EXTERNAL _GETHEX
EXTERNAL _FMBASE
EXTERNAL _TOBASE
EXTERNAL _BASELS
EXTERNAL _BASESL
EXTERNAL _CHKBASE
EXTERNAL _D32
EXTERNAL _SWC
EXTERNAL _BSL
EXTERNAL _BSR
EXTERNAL _BSHF
EXTERNAL _OM
EXTERNAL _PNAME
EXTERNAL _VAPP
EXTERNAL _CHKUSR

EXTERNAL _SAVESCR
EXTERNAL _RESTORESCR

*****************************************************************************
* Unsupported Entry Points
*****************************************************************************
ASSEMBLE
=ApNameFP       EQU #3F31B
=LockKey        EQU #36AB6
Ck&DoMsgBox     EQU #3F327      ( $ -> )

=TRAVERSE+      EQU     #08D0F
=GPPushT/FLp    EQU     #0DD87
=matchob?       EQU     #0ECD8
=FPointer       EQU     #177C7
=ListOfEqs!     EQU     #273C1
=NotesDisp      EQU     #3F71A
=NotesExit0     EQU     #3F71C
=NotesHKeys     EQU     #3F71D
=NotesInit0     EQU     #3F71F
=NotesSKeys     EQU     #3F7A3
=LEDone         EQU     #6C1B4 (3)
=LEQuit         EQU     #6C1D2 (3)
=EndChooseOK    EQU     #6C385 (3)
*=ApNameFP       EQU     #7D03F (3)
=ApNameEdSKey   EQU     #7D076 (3)
=USEROB         EQU     #80711

=ListToArry	EQU     #3F90A
=UNCOERCE2	EQU     #112B7
=la>COL		EQU     #3F771
=CRUNCH{}	EQU     #3F01E
=COERCE2	EQU     #112A3
=LineB		EQU     #3F862

=^XEQGET2	EQU     #255002
=^XEQGET4	EQU     #256002
=^XEQGETID	EQU     #257002

=PurgeLib#      EQU     #3F422
=AtUserStack    EQU     #24EE3

*****************************************************************************
* Program to initialize the library at warmstart
*****************************************************************************
RPL
NULLNAME MALcfg
:: # 604 TOSRRP ;

*****************************************************************************
* Dummy to shift all the nibbles
* adjust the number of DUPs to make download work
* seems SWAPDROPs in certain file positions make download fail
*****************************************************************************
RPL
NULLNAME _DUMMY
::
  DUP                           ( --- 5 nibbles per DUP )
;

*****************************************************************************
* KeyCodes returned by WaitForKey
*****************************************************************************
DEFINE kcSYMB           SEVEN
DEFINE kcPLOT           EIGHT
DEFINE kcNUM            NINE
DEFINE kcHOME           ELEVEN
DEFINE kcAPLET          TWELVE
DEFINE kcVIEWS          THIRTEEN

DEFINE kcUpArrow        TEN
DEFINE kcLeftArrow      FOURTEEN
DEFINE kcDownArrow      FIFTEEN
DEFINE kcRightArrow     SIXTEEN

DEFINE kcA              SEVENTEEN
DEFINE kcB              EIGHTEEN
DEFINE kcC              NINETEEN
DEFINE kcD              TWENTY
DEFINE kcE              TWENTYTWO
DEFINE kcF              TWENTYTHREE

DEFINE kc0              FORTYEIGHT
DEFINE kc1              FORTYTHREE
DEFINE kc2              FORTYFOUR
DEFINE kc3              FORTYFIVE
DEFINE kc4              THIRTYEIGHT
DEFINE kc5              THIRTYNINE
DEFINE kc6              FORTY
DEFINE kc7              THIRTYTHREE
DEFINE kc8              THIRTYFOUR
DEFINE kc9              THIRTYFIVE

DEFINE kcOn             FORTYSEVEN
DEFINE kcDEL            TWENTYONE
DEFINE kcENTER          FIFTYONE

*****************************************************************************
* Help
*****************************************************************************
ASSEMBLE
        CON(3)  8               ( a command )
RPL
xNAME AA                        ( --- easy to type )
::
CK0                             ( has no args )
  $ "L1540 HELP"
  { 
*        12345678901234         ---- 1*14 chars in list, 6*22 chars in text
* 1234567890123456789012
*--------------------------------------------------------------------------
    { $ "*** Base Conv"
$ "\0A\0A" }
    { $ "HD hex->dec"
$ "HexDec conversion\0AHD->:hex:dec\0A prompts for hex" }
    { $ "DH(dec)->{hob}"
$ "DecHex conversion\0ADH(dec)->{hex,oct,bin}" }
    { $ "BC(d,b)->{}"
$ "Base Conversion\0ABC(dec,base)->{digits}\0ABC({digits},base)->dec\0A base 2200\0A digits 0199" }
*--------------------------------------------------------------------------
    { $ "*** Bit Ops"
$ "\0A\0A" }
    { $ "BIT(x,n,p)->b"
$ "32BIT ops on real\0ABIT(x,n,p)->b\0An=0(LSB)31(MSB)\0Ap: -1/0/1/2 =\0A   tog/clr/set/test" }
    { $ "BCNT(x,p)->k"
$ "32 Bit CouNT\0ABCNT(x,p)->k\0Ap: 0=LSB?\0A   1=num bits set\0A   2=MSB index\0A-1(none), 0(LSB)31" }
    { $ "BSL(x,n,p)->x'"
$ "32Bit Shift Left ops\0ABSL(x,n,p)->x'\0An=-32(rite)+32(left)\0An=0,p=0/1: NOT/mirror\0An<>0,p=-1/0/1/2: pull\0A LSB,MSB/0/1/rotate" }
    { $ "BOP(x,y,p)->z"
$ "logical Bit OPerations\0ABOP(x,y,p)->z\0Ap: -1/0/1 =\0A XOR/AND/OR" }
*--------------------------------------------------------------------------
    { $ "*** Cons&Units"
$ "\0A\0A" }
    { $ "CO(n)->const"
$ "COnstants\0ACO(0)->const\0A ChooseList\0ACO(143)->const" }
    { $ "CV(n)->conv"
$ "ConVersions\0A CV(0)->conv\0A ChooseList\0ACV(150)->conv\0A *CV() converts to SI\0A /CV() converts back" }
    { $ "CF(C)->F"
$ "CelsiusFahrenheit\0A CF(C)->F\0A absolute scale" }
    { $ "CK(C)->K"
$ "CelsiusKelvin\0A CK(C)->K\0A absolute scale" }
    { $ "FC(F)->C"
$ "FahrenheitCelsius\0A FC(F)->C\0A absolute scale" }
    { $ "KC(K)->C"
$ "KelvinCelsius\0A KC(K)->C\0A absolute scale" }
*--------------------------------------------------------------------------
    { $ "*** Time&Date"
$ "\0A\0A" }
    { $ "HP(h,h')->h+"
$ "Hours Plus\0AHP(hh.mmss,hh.mmss')->\0A hh.mmss+hh.mmss'" }
    { $ "HM(h,h')->h-"
$ "Hours Minus\0AHM(hh.mmss,hh.mmss')->\0A hh.mmss-hh.mmss'" }
    { $ "SD(d,t)->s"
$ "SetDate and time\0ASD(date,time)->sec\0A sec since 1.1.1991\0A format see DT" }
    { $ "DD(d1,d2)->"
$ "DeltaDays\0ADD(date1,date2)->ddays\0A date fmt see DT" }
    { $ "DP(d1,)->d2"
$ "DatePlus\0ADP(date1,days)->date2\0A date fmt see DT" }
    { $ "DT ->{d,t}"
$ "Date&Time\0ADT->{d,t} & MsgBox\0A uses European date\0A & time fmt:\0A dd.mmyyyy 24hrs" }
    { $ "UHR ->$dt"
$ "Clock loop\0AUHR ->$dt\0A goes off\0A ON turns on and off\0A any other key exits" }
    { $ "TN(d,t)->s"
$ "TimeNumber\0ATN(date,time)->sec\0ATN(0,any)->curr sec\0A sec since 01.01.1991" }
    { $ "NT(s)->{d,t}"
$ "NumberTime\0ANT(s)->{date,time}\0A sec since 01.01.1991" }
    { $ "DY(d)->17"
$ "Day of week\0ADY(date)->{17,$day}\0A date fmt see DT" }
    { $ "YW(y,w)->d"
$ "date of Year's Week\0AYW(year,week)->\0A dd.mmyyyy\0A (1st day of week)" }
    { $ "TT ->dels"
$ "TimeTimer\0ATT ->sec\0A RunTime Display" }
    { $ "AL(d,t)->s"
$ "ALarm\0AAL(date,time)->sec\0A beeps at date,time\0AAL(0,delt)->sec\0A beeps in delt sec" }
    { $ "CA(d)->.my"
$ "CAlendar\0ACA(.mmyyyy)->.mmyyyy\0ACA(0)->current month\0A  months,  years\0A ENTER current month\0A ON exits" }
    { $ "DL(d)->h.m"
$ "DayLight length hh.mm\0ADL(date,lat)->dl(date)\0ADL(0,lat)->dl(today)\0A precise to some min\0A latitude in deg" }
    { $ "MP(d)->mp"
$ "MoonPhase\0AMP(date)->mp(date)\0AMP(0)->mp(today)\0A 0  0.5  1 =\0A Full  New  Full" }
*--------------------------------------------------------------------------
    { $ "*** Finance"
$ "\0A\0A" }
    { $ "TV ->tvm-equ"
$ "TimeValue of money\0ATV ->TVM-equation\0AP=PV,R=PMT,N=NPER,F=FV\0AB 10=BegEnd,I=I/PER\0A COPY and STOE09\0A solve in Solve Aplet" }
    { $ "TVM({},k)->K"
$ "TimeValue of Money\0ATVM({p,r,n,b,i,f},k)\0A -> k'th var,k=16\0Ap=PV,r=PMT,n=NPER,f=FV\0Ab 10=BegEnd,i=I/PER" }
*--------------------------------------------------------------------------
    { $ "*** Probabil."
$ "\0A\0A" }
    { $ "BINO(nwdw1w2)"
$ "BINOmial probability\0ABINO(n,w,d,w1,w2)->p\0AProb to draw w1w2\0A white balls in d draw\0A ings fm box with n\0A balls (w white ones)" }
    { $ "BINOR(nwdw1w2)"
$ "BINOmial probability R\0ABINOR(n,w,d,w1,w2)->p\0Aas BINO, but:\0A after each drawing,\0A ball returned to box" }
    { $ "SAMC(n,c,d)->p"
$ "SAMe Color probability\0ASAMC(n,c,d)->p\0AProb d balls having\0A same color in box of\0A n balls, with c\0A possible colors" }
*--------------------------------------------------------------------------
    { $ "*** Mat&List"
$ "\0A\0A" }
    { $ "MEX([])->\7Bm,M\7D"
$ "Matrix EXtrema\0AMEX([])->\7Bmin max\7D\0A1D/2D matrix" }
    { $ "GN({},n)->obn"
$ "Get N'th element\0AGN({}|[]|[[]],n|{ij})\0A -> el_n|el_ij" }
    { $ "NUL(n)->{}"
$ "NUll List\0ANUL(n)->{00}\0A list with n zeros\0A n=0: empty list" }
*--------------------------------------------------------------------------
    { $ "*** Graphics"
$ "\0A\0A" }
    { $ "MBP([])->\7Bm,M\7D"
$ "Matrix Bar Plot\0AMBP([])->\7Bmin max\7D\0A scaled bar plot for\0A 1D/2D matrix" }
    { $ "MSP([])->\7Bm,M\7D"
$ "Matrix Slope Plot\0AMSP([[]])->\7Bmin max\7D\0Aslopefield plot for\0A 2D matrix" }
*--------------------------------------------------------------------------
    { $ "*** Programs"
$ "\0A\0A" }
    { $ "SF(n,s)->s_old"
$ "get and Set Flag state\0ASF(n,s)->s_old (0|1)\0An=1128, n<0: system\0As: -1/0/1/2 =\0A   tog/clr/set/keep\0An=0 clr flags 1128" }
    { $ "OFF->"
$ "programmable OFF\0AOFF ->\0A ON turns on again" }
    { $ "WFK->keynum"
$ "Wait For Key\0AWFK ->keynum (151)\0A prompts user and\0A cont's after any key" }
    { $ "RKEY->keynum"
$ "Read Key on the fly\0ARKEY->0|keynum\0A 0=no key pressed\0Aalso flushes keybuffer" }
    { $ "PR(n,arg)->"
$ "Program Run\0APR(n,arg)->Ans\0A runs pgm Pn as fct\0A arg passed in Ans\0A arg may be any obj" }
    { $ "PS(n,arg)->"
$ "Pgm run with AZ Save\0APS(n,arg)->Ans\0A see PR(n,arg), plus:\0A AZ local vars" }
    { $ "PSROOT(n)->x0"
$ "Pgm Save ROOT\0APSROOT(n,xl,xh,xs)->x0\0A root x0 of pgm Pn\0A args: xlo,xhi,xstart\0A AZ local vars" }
    { $ "PSRM(n)->x0"
$ "Pgm Save Real Matrix\0APSRM(n,xl,xh,dx)->[]\0A MAKELIST for pgm Pn\0A args: xlo,xhi,xstart\0A AZ local vars" }
*--------------------------------------------------------------------------
    { $ "*** Save"
$ "\0A\0A" }
    { $ "AZL->{AZ}"
$ "make AZ List\0AAZL ->{A,B,,Z}\0A PUSHL(AZL) saves reals" }
    { $ "LAZ({})->(AZ)"
$ "put List in AZ\0ALAZ({})->(A,B,,Z)\0A {} must be 26 reals\0A LAZ(POPL) gets reals" }
    { $ "PUSHL(ob)->"
$ "Push ob into L0\0APUSHL(ob)->Ans\0A L0={ob,L0}\0APUSHL  POPL for\0A local vars" }
    { $ "POPL->ob"
$ "Pop ob from L0\0APOPL -> ob\0A ob=L0(1),\0A then L0(1) deleted\0Asee PUSHL" }
    { $ "PUSHR(ob)->"
$ "Push right ob into L0\0APUSHR(ob)->Ans\0A L0={L0,ob}\0APUSHR  POPR to\0A save Ans" }
    { $ "POPR->ob"
$ "Pop right ob from L0\0APOPR -> ob\0A ob=L0(N),\0A then L0(N) deleted\0Asee PUSHR" }
*--------------------------------------------------------------------------
    { $ "*** System"
$ "\0A\0A" }
    { $ "KEYTIME(n)->o"
$ "read/set key debounce\0AKEYTIME(new)->old\0A unit 122us\0A new=0 sets dflt 1365" }
    { $ "LOBAT->03"
$ "Low Battery check\0ALOBAT -> 03\0A 0=ok, else low batt" }
    { $ "BYEFUNCT"
$ "deletes L1540 fm calc\0Abyefunct\0A use CAPITAL letters\0A ignore error messages" }
    { $ "PURGELIB(n)"
$ "purges a library\0APURGELIB(n)->n\0A does not delete L1540" }
*--------------------------------------------------------------------------
    { $ "*** Math"
$ "\0A\0A" }
    { $ "DEQ()->[[]]"
$ "Diff. EQ sys solver\0ADEQ(n,x0,x1,dx,[y0])->\0A[[y0y1]],Pn:{x,[y]}->\0A[y'],x=x0(dx)x1,dx=\0Astepsize,[y0]=init=\0A[y(x0)], . stops" }
    { $ "NLOP()->{c[]}"
$ "NonLinear OPtimization\0ANLOP(n,h0,hm,mx,[x0])\0A->{c,f,[x]},Pn:[x]->y\0Ah0/hm=init/min xstep\0A[x0]=init,c=0/1: fail/\0Aconv,mx=maxit, . stops" }
    { $ "DFT([],d)->[]"
$ "Discr. Fourier Transf.\0ADFT([],dir)->[]\0A dir<0: inverse DFT\0A . stops" }
*--------------------------------------------------------------------------
    { $ "*** EE ***"
$ "\0A\0A" }
    { $ "FLC({},k)->K"
$ "LC Resonant Circuit\0AFLC({f,L,C},k)\0A -> k'th var, k=13" }
    { $ "FLX({},k)->K"
$ "L Reaktance\0AFLX({f,L,X},k)\0A -> k'th var, k=13" }
    { $ "FCX({},k)->K"
$ "C Reaktance\0AFCX({f,C,X},k)\0A -> k'th var, k=13" }
    { $ "QP({},k)->K"
$ "Q of Parallel res\0AQP({Qp,Rp,Lp,Cp},k)\0A -> k'th var, k=14" }
    { $ "QS({},k)->K"
$ "Q of Series res\0AQS({Qs,Rs,Ls,Cs},k)\0A -> k'th var, k=14" }
    { $ "PAR({},k)->K"
$ "PARallel resistors\0APAR({R1,R2,Rp},k)\0A -> k'th var, k=14\0A or parallel L\0A or series C" }
    { $ "VD({},k)->K"
$ "Voltage Divider\0AVD({V1,V2,R1,R2},k)\0A -> k'th var, k=14" }
    { $ "ID({},k)->K"
$ "Current Divider\0AID({U,R0,R1,R2,I2},k)\0A -> k'th var, k=15" }
    { $ "DB(x,n)->x'"
$ "dB conversions\0ADB(x,0)->x'\0A ChooseList\0ADB(x,112)->x'\0Alc letter: ratio\0ARref = 50 Ohms" }
    { $ "ZEL(f,Z)->{}"
$ "Impedance Series Elems\0AZEL(f,Z)->{Rs,Ls|Cs}\0A Z=(Re,Im)" }
    { $ "YEL(f,Z)->{}"
$ "Admittance paral Elems\0AYEL(f,Y)->{Rp,Lp|Cp}\0A Y=(Re,Im)" }
    { $ "RLZ(f,R,L)->Z"
$ "RL Series Impedance\0ARLZ(f,Rs,Ls)->Z" }
    { $ "RLY(f,R,L)->Y"
$ "RL Paral Admittance\0ARLY(f,Rp,Lp)->Y" }
    { $ "RCZ(f,R,C)->Z"
$ "RC Series Impedance\0ARCZ(f,Rs,Cs)->Z" }
    { $ "RCY(f,R,C)->Y"
$ "RC Paral Admittance\0ARCY(f,Rp,Cp)->Y" }
*--------------------------------------------------------------------------
  }
  ChooseSimple
  ITE
    ::
*      _SAVESCR SWAP                 ( poi $ )
      RECLAIMDISP               ( --- clear alpha display )
      TURNMENUOFF               ( --- remove menu keys )
* return 2nd line of help text
      DUPDUP                    ( $ $ $ )
      NEWLINE$ ONE POS$         ( $ $ posnl )
      #1+LAST$                  ( $ $' )
      DUP NEWLINE$ ONE POS$     ( $ $' posnl )
      1_#1-SUB$                 ( $ $'' )
*      ONE {}N                   ( {$''} )
      SWAP                      ( $' $ )
      DUPNULL$? ITE
      DROP                      ( $' )
      ::
        ONE SIX Disp5x7
        $ "Any Key continues " DISPROW7
        WaitForKey 2DROP        ( poi $'' )
      ;
*      _RESTORESCR               ( $'' )
    ;
  %0                            ( need to return something )
;

***************************************************************************
* constants
* 0 -> select from list
* n -> constant value
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CO
::
CK1&Dispatch
#00001                          ( %n )
::
  COERCE                        ( n )
  DUP#0= IT                     ( n )
    ::
  DROP                          ( )
  $ "COnstants"
  { 
*    12345678901234
{ $ " 1 c0 sp light"   BINT1 }
{ $ " 2 0 permeabi"   BINT2 }
{ $ " 3 0 permitti"   BINT3 }
{ $ " 4 Z0 wave imp"   BINT4 }
{ $ " 5 k0 Boltzman"   BINT5 }
{ $ " 6 h0 Planck"     BINT6 }
{ $ " 7 qe e charge"   BINT7 }
{ $ " 8 me e mass"     BINT8 }
{ $ " 9 2 2*"        BINT9 }
{ $ "10 e0 e Euler"    BINT10 }
{ $ "11 0 finestru"   BINT11 }
{ $ "12 c3 Wien dis"   BINT12 }
{ $ "13 F0 Faraday"    BINT13 }
{ $ "14 g0 earth gr"   BINT14 }
{ $ "15 p gyromagn"   BINT15 }
{ $ "16 G0 gravity"    BINT16 }
{ $ "17 c e Compto"   BINT17 }
{ $ "18  myon Com"   BINT18 }
{ $ "19 n neut Com"   BINT19 }
{ $ "20 p prot Com"   BINT20 }
{ $ "21 m alpha ma"   BINT21 }
{ $ "22 m myon mas"   BINT22 }
{ $ "23 mn neut mas"   BINT23 }
{ $ "24 mp prot mas"   BINT24 }
{ $ "25 B Bohr mag"   BINT25 }
{ $ "26 e e mag mo"   BINT26 }
{ $ "27  myon mmo"   BINT27 }
{ $ "28 n neut mmo"   BINT28 }
{ $ "29 N nucl mmo"   BINT29 }
{ $ "30 p prot mmo"   BINT30 }
{ $ "31 n0 Loschmid"   BINT31 }
{ $ "32 NA Avogadro"   BINT32 }
{ $ "33 0 mag flux"   BINT33 }
{ $ "34 RH Rydbg. H"   BINT34 }
{ $ "35 R Rydberg"    BINT35 }
{ $ "36 Rm mol gas"    BINT36 }
{ $ "37 Rq qnt Hall"   BINT37 }
{ $ "38   Stef-Bol"   BINT38 }
{ $ "39 SP std pres"   BINT39 }
{ $ "40 ST std temp"   BINT40 }
{ $ "41 u0 atom mas"   BINT41 }
{ $ "42 Vm mol vol"    BINT42 }
{ $ "43 C0 Euler"      BINT43 }
  }
  ChooseSimple                  ( n T | F )
  ?SKIP ZERO                    ( n | 0 )
    ;
* now on stack: #0 or #1..
  DUP#0= ITE                    ( n )
    ::
      DROP %0                   ( return 0 )
     ;
    ::
      DUP FORTYTHREE #> ITE
        SETSIZEERR              ( bad argument value )
*      ::
*        # 203                   ( bad argument value )
*        DO#EXIT
*       ;
      ::
* now on stack: #1..43
ARRY
[
% 2.99792458E8                  (  1 c0 sp light )
% 1.25663706144E-6              (  2 0 permeabi )
% 8.854187817E-12               (  3 0 permitti )
% 3.76730313461E2               (  4 Z0 wave imp )
% 1.380650324E-23               (  5 k0 Boltzman )
% 6.6260687652E-34              (  6 h0 Planck   )
% 1.60217646263E-19             (  7 qe e charge )
% 9.1093818872E-31              (  8 me e mass"  )
% 6.28318530718                 (  9 2 2*      )
% 2.71828182846                 ( 10 e0 e Euler  )
% 7.29735253327E-3              ( 11 0 finestru )
% 2.897768651E-3                ( 12 c3 Wien dis )
% 9.6485341539E4                ( 13 F0 Faraday  )
% 9.80665                       ( 14 g0 earth gr )
% 4.2577482518E7                ( 15 p gyromagn )
% 6.6731E-11                    ( 16 G0 gravity  )
% 2.42631021518E-12             ( 17 c e Compto )
% 1.17344419735E-14             ( 18  myon Com )
% 1.3195908981E-15              ( 19 n neut Com )
% 1.3214098471E-15              ( 20 p prot Com )
% 6.6446559852E-27              ( 21 m alpha ma )
% 1.8835310916E-28              ( 22 m myon mas )
% 1.6749271613E-27              ( 23 mn neut mas )
% 1.6726215813E-27              ( 24 mp prot mas )
% 9.2740089937E-24              ( 25 B Bohr mag )
% -9.2847636237E-24             ( 26 e e mag mo )
% -4.4904481322E-26             ( 27  myon mmo )
% -9.662364023E-27              ( 28 n neut mmo )
% 5.050783172E-27               ( 29 N nucl mmo )
% 1.41060663358E-26             ( 30 p prot mmo )
% 2.686777547E25                ( 31 n0 Loschmid )
% 6.0221419947E23               ( 32 NA Avogadro )
% 2.06783363681E-15             ( 33 0 mag flux )
% 1.0967758E7                   ( 34 RH Rydbg. H )
% 1.09737315685E7               ( 35 R Rydberg  )
% 8.31447215                    ( 36 Rm mol gas  )
% 2.5812807573E4                ( 37 Rq qnt Hall )
% 5.6704004E-8                  ( 38   Stef-Bol )
% 1.01325E5                     ( 39 SP std pres )
% 2.7315E2                      ( 40 ST std temp )
% 1.6605387313E-27              ( 41 u0 atom mas )
% 2.241399639E-2                ( 42 Vm mol vol  )
% 5.77215664902E-1              ( 43 C0 Euler    )
]
        GETATELN
        ?SKIP %0
    ;
      ;
;
;

***************************************************************************
* conversions
* 0 -> select from list
* n -> constant value
* multiply with return value to convert TO metric/SI
* divide thru return value to convert FROM metric/SI
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CV
::
CK1&Dispatch
#00001                          ( %n )
::
  COERCE                        ( n )
  DUP#0= IT                     ( n )
    ::
  DROP                          ( )
  $ "ConVersions"
  { 
*    12345678901234
{ $ " 1 m/"       BINT1  }
{ $ " 2 m/AU"      BINT2  }
{ $ " 3 m/ft"      BINT3  }
{ $ " 4 m/in"      BINT4  }
{ $ " 5 m/lyr"     BINT5  }
{ $ " 6 m/mi"      BINT6  }
{ $ " 7 m/mil"     BINT7  }
{ $ " 8 m/"       BINT8  }
{ $ " 9 m/nmi"     BINT9  }
{ $ "10 m/pc"      BINT10 }
{ $ "11 m/yd"      BINT11 }
{ $ "12 m/ar"     BINT12 }
{ $ "13 m/acr"    BINT13 }
{ $ "14 m/ft"    BINT14 }
{ $ "15 m/ha"    BINT15 }
{ $ "16 m/in"    BINT16 }
{ $ "17 m/mi"    BINT17 }
{ $ "18 m/yd"    BINT18 }
{ $ "19 m^3/barrel"    BINT19 }
{ $ "20 m^3/cup"    BINT20 }
{ $ "21 m^3/ft^3"    BINT21 }
{ $ "22 m^3/gal"    BINT22 }
{ $ "23 m^3/in^3"    BINT23 }
{ $ "24 m^3/ltr"    BINT24 }
{ $ "25 m^3/ozfl"   BINT25 }
{ $ "26 m^3/pt"     BINT26 }
{ $ "27 m^3/qt"     BINT27 }
{ $ "28 s/day"     BINT28 }
{ $ "29 s/hr"      BINT29 }
{ $ "30 s/min"     BINT30 }
{ $ "31 s/yr"      BINT31 }
{ $ "32 mps/ftps"  BINT32 }
{ $ "33 mps/knots" BINT33 }
{ $ "34 mps/kph"   BINT34 }
{ $ "35 mps/mph"   BINT35 }
{ $ "36 kg/carat"  BINT36 }
{ $ "37 kg/lb"     BINT37 }
{ $ "38 kg/oz"     BINT38 }
{ $ "39 N/dyn"     BINT39 }
{ $ "40 J/erg"     BINT40 }
{ $ "41 J/eV"      BINT41 }
{ $ "42 J/cal"     BINT42 }
{ $ "43 W/hp"      BINT43 }
{ $ "44 W/PS"      BINT44 }
{ $ "45 Pa/atm"    BINT45 }
{ $ "46 Pa/bar"    BINT46 }
{ $ "47 Pa/mmHg"   BINT47 }
{ $ "48 Pa/psi"    BINT48 }
{ $ "49 Pa/torr"   BINT49 }
{ $ "50 As/Fdy"    BINT50 }
  }
  ChooseSimple                  ( n T | F )
  ?SKIP ZERO                    ( n | 0 )
    ;
* now on stack: #0 or #1..
* TBD: special cases: abs temp conv, C<->F C<->K

  DUP#0= ITE                    ( n )
    ::
      DROP %0                   ( return 0 )
     ;
    ::
      DUP FIFTY #> ITE
        SETSIZEERR              ( bad argument value )
*      ::
*        # 203                   ( bad argument value )
*        DO#EXIT
*       ;
      ::
* now on stack: #1..50
ARRY
[
% 1E-10 ( 1 )
% 1.495979E11 ( 2 )
% 0.3048 ( 3 )
% 0.0254 ( 4 )
% 9.46052840488E15 ( 5 )
% 1609.344 ( 6 )
% 2.54E-5 ( 7 )
% 1E-6 ( 8 )
% 1852 ( 9 )
% 3.08567818585E16 ( 10 )
% 0.9144 ( 11 )
% 100 ( 12 )
% 4046.87260987 ( 13 )
% 0.09290304 ( 14 )
% 10000 ( 15 )
% 0.00064516 ( 16 )
% 2589988.11034 ( 17 )
% 0.83612736 ( 18 )
% 0.158987294928 ( 19 )
% 2.365882365E-4 ( 20 )
% 0.028316846592 ( 21 )
% 0.003785411784 ( 22 )
% 0.000016387064 ( 23 )
% 0.001 ( 24 )
% 2.95735295625E-5 ( 25 )
% 0.000473176473 ( 26 )
% 0.000946352946 ( 27 )
% 86400 ( 28 )
% 3600 ( 29 )
% 60 ( 30 )
% 31556925.9747 ( 31 )
% 0.3048 ( 32 )
% 0.5144444444444 ( 33 )
% 0.2777777777778 ( 34 )
% 0.44704 ( 35 )
% 0.0002 ( 36 )
% 0.45359237 ( 37 )
% 0.028349523125 ( 38 )
% 1E-5 ( 39 )
% 1E-7 ( 40 )
% 1.60217733E-19 ( 41 )
% 4.1868 ( 42 )
% 745.699871582 ( 43 )
% 735.5 ( 44 )
% 101325 ( 45 )
% 1E5 ( 46 )
% 133.322368421 ( 47 )
% 6894.75729317 ( 48 )
% 133.322368421 ( 49 )
% 96487 ( 50 )
]
        GETATELN
        ?SKIP %0
    ;
      ;
;
;


***************************************************************************
* absolute temperature conversions
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME FC                        ( F->C )
::
CK1&Dispatch
#00001                          ( real )
::
  % 32 %- % 5 %* % 9 %/
;
;
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME KC                        ( K->C )
::
CK1&Dispatch
#00001                          ( real )
::
  % 273.15 %-
;
;
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CF                        ( C->F )
::
CK1&Dispatch
#00001                          ( real )
::
  % 9 %* % 5 %/ % 32 %+
;
;
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CK                        ( C->K )
::
CK1&Dispatch
#00001                          ( real )
::
  % 273.15 %+
;
;

***************************************************************************
* HMS+
* hh.mmss1 hh.mmss2 -> hh.mmss
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME HP
::
CK2&Dispatch
#00011                          ( %date1 %date2 )
::
  %HMS+
;
;

***************************************************************************
* HMS-
* hh.mmss1 hh.mmss2 -> hh.mmss
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME HM
::
CK2&Dispatch
#00011                          ( %date1 %date2 )
::
  %HMS-
;
;

***************************************************************************
* ddays
* date1 date2 -> ddays
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DD
::
CK2&Dispatch
#00011                          ( %date1 %date2 )
::
* =~xDDAYS        EQU     #0021004
  ROMPTR 004 021                ( ddmmyyyy )
;
;

***************************************************************************
* date plus
* date days -> date'
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DP
::
CK2&Dispatch
#00011                          ( %date %days )
::
* =~xDATE+        EQU     #0022004
  ROMPTR 004 022                ( ddmmyyyy )
;
;

***************************************************************************
* date and time
* -> {date time} & msgbox
***************************************************************************
ASSEMBLE
        CON(3)  8
RPL
xNAME DT
::
CK0
::
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
* =~xDATE         EQU     #001B004 ( d ) 
  ROMPTR 004 01B
* =~xTIME         EQU     #001A004
  ROMPTR 004 01A
  2DUP                          ( d t d t)
* =~xTSTR         EQU     #0020004
  ROMPTR 004 020                ( $data&time )
  Ck&DoMsgBox
  TWO{}N                        ( { d t } )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* day of week
* date -> { 1..7 $day }
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DY
::
CK1&Dispatch
#00001                          ( %date )
::
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
*  DUP DO>STR $ ":\0A" &$
*  SWAP
  %0                            ( --- dummy time )
* =~xTSTR         EQU     #0020004
  ROMPTR 004 020                ( $date&time )
  FOUR 1_#1-SUB$                ( $date $day )
  $ "MONTUEWEDTHUFRISATSUN"     ( $date $day $search )
  OVER ONE                      ( $date $day $search $find 1 )
  POS$                          ( $date $day 1,4,7,... --- must be 1,2,3,... )
  THREE #/ SWAPDROP #1+         ( $date $day 1,2,3,... )
  UNCOERCE                      ( $date $day d )
*  UNROT                         ( d $date $day )
*  &$
*  Ck&DoMsgBox                   ( d )
  SWAP
  TWO{}N                        ( d $day )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* date of (first day of) week of year
* y w -> dd.mmyyyy
* always a monday
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME YW
::
CK2&Dispatch
#00011                          ( %y %w )
::
  FORTYTWO SetSysFlag           ( y w --- EU date format, else err )
  % 7 %* % 4 %-                 ( y 7*w-4 )
  SWAP
  % 1.0E6 %/ % 1.01 %+          ( w' 1.01yyyy )
  SWAP                          ( d1 w' )
  % 15.101582                   ( d1 w' d0 --- reference date )
  3PICK                         ( d1 w' d0 d1 )
  ROMPTR 004 021                ( d1 w' dd --- DDAYS )
  % 7 %MOD %-                   ( d1 d1' )
  ROMPTR 004 022                ( dd.mmyyyy --- DATE+ )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* set date and time
* date time -> time_number [sec since 1.1.1991]
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME SD
::
CK2&Dispatch
#00011                          ( d t )
::
  FORTYONE SetSysFlag           ( n --- EU clock format )
  FORTYTWO SetSysFlag           ( n --- EU date format )
  2DUP                          ( d t d t )
* =~xSETTIME      EQU     #001E004
  ROMPTR 004 01E                ( d t d )
* =~xSETDATE      EQU     #001D004
  ROMPTR 004 01D                ( d t )
  _DTNR
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* time number
* date time -> time_number [sec since 1.1.1991]
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME TN
::
CK2&Dispatch
#00011                          ( d t  )
::
  FORTYONE SetSysFlag           ( d t --- EU clock format )
  FORTYTWO SetSysFlag           ( d t --- EU date format )
  OVER %0<> ITE
    _DTNR
    :: 2DROP _CDTNR ;
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* inverse of time number
* time_number -> { date time }
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME NT
::
CK1&Dispatch
#00001                          ( s )
::
  FORTYONE SetSysFlag           ( s --- EU clock format )
  FORTYTWO SetSysFlag           ( s --- EU date format )
  _NRDT                         ( date time )
  TWO{}N                        ( {date time} )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

*****************************************************************************
* continuous date and time display, with stop watch
*****************************************************************************
ASSEMBLE
        CON(3)  8
RPL
xNAME TT
::
CK0
::
  _SAVESCR                      ( poi )
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
*  RECLAIMDISP                   ( --- clear alpha display )
*  TURNMENUOFF                   ( --- remove menu keys )
*
  $ "Any Key starts ..."
  DISPROW7
  WaitForKey 2DROP
*
  $ "Any Key stops ..."
  DISPROW7
  _CDTNR                        ( t0)
  BEGIN
    DUP                         ( t0 t0 )
    ROMPTR 004 01B              ( t0 t0 date )
    ROMPTR 004 01A              ( t0 t0 date time )
    2DUP                        ( t0 t0 date time date time )
    _DTNR                       ( t0 t0 date time t1 )
    UNROT                       ( t0 t0 t1 date time )
    ROMPTR 004 020              ( t0 t0 t1 $date&t1 )
    DISPROW1                    ( t0 t0 t1 )
    SWAP %-                     ( t0 t1-t0 )
    DO>STR                      ( t0 $dt )
    DISPROW3                    ( t0 )
    KEYINBUFFER?                ( t0 T|F )
  UNTIL                         ( t0 ) 
  FLUSHKEYS                     ( t0 )
  _CDTNR                        ( t0 t1 )
  SWAP %-                       ( t1-t0 --- return seconds passed )
  FORTYONE ClrSysFlag           ( poi dt --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( poi dt --- OS expects flag clear )
  _RESTORESCR                   ( dt )
;
;

*****************************************************************************
* clock with alarm
* d t -> dt
* 0 dt -> dt
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME AL
::
CK2&Dispatch
#00011                          ( d t )
::
  _SAVESCR                      ( d t poi )
  UNROT                         ( poi d t )
*
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
*  RECLAIMDISP                   ( --- clear alpha display )
*  TURNMENUOFF                   ( --- remove menu keys )
  OVER                          ( d t d )
  #0=ITE
    ::                          ( 0 dt )
      SWAPDROP                  ( dt )
      _CDTNR                    ( dt now )
      %+ DUP                    ( t2 t2 )
      _NRDT                     ( t2 d t )
      ROMPTR 004 020            ( t2 $date&t2 )
      $ "Alarm:"
      DISPROW2
      DISPROW3                  ( t2 )

*      SWAPDUP                   ( 0 now dt dt )
*      $ "Runtime:"
*      DISPROW2
*      DO>STR DISPROW3           ( 0 now dt )
*      %+                        ( 0 t2 )
*      SWAPDROP                  ( t2 )
    ;
    ::                          ( d t )
  2DUP                          ( d t d t )
  ROMPTR 004 020                ( d t $date&t2 )
  $ "Alarm:"
  DISPROW2
  DISPROW3                      ( d t )
  _DTNR                         ( t2 )
    ;
  $ "Any Key stops ..."
  DISPROW7
  _CDTNR                        ( t2 t0)
  BEGIN
    ROMPTR 004 01B              ( t2 t0 date )
    ROMPTR 004 01A              ( t2 t0 date time )
    2DUP                        ( t2 t0 date time date time )
    _DTNR                       ( t2 t0 date time t1 )
    UNROT                       ( t2 t0 t1 date time )
    ROMPTR 004 020              ( t2 t0 t1 $date&t1 )
    DISPROW1                    ( t2 t0 t1 )
    DUP 3PICK                   ( t2 t0 t1 t1 t0)
    %-                          ( t2 t0 t1 t1-t0 )
    DO>STR                      ( t2 t0 t1 $dt )
    DISPROW5                    ( t2 t0 t1 )
    3PICK                       ( t2 t0 t1 t2 )
    %>= ITE                     
      ::                        ( t2 t0 --- alarm )
        $ "*** Alarm ***"
        DISPROW2
        ROMPTR 004 01B          ( ... date )
        ROMPTR 004 01A          ( ... date time )
        ROMPTR 004 020          ( ... $d&t2 )
        DISPROW3
        BEGIN
          %1 dowait             ( --- beeps every sec )
          ROMPTR 004 01B        ( ... date )
          ROMPTR 004 01A        ( ... date time )
          ROMPTR 004 020        ( ... $d&t )
          DISPROW1              ( --- continue to show current time )
          BINT50 # 2000         ( --- ms Hz )
          setbeep
          KEYINBUFFER?          ( t2 t0 T|F )
        UNTIL
        FLUSHKEYS
        TRUE
      ;
      ::                        ( t2 t0 --- no alarm )
        VERYSLOW                ( --- have a readable display )
        KEYINBUFFER?            ( t2 t0 T|F )
      ;
  UNTIL                         ( t2 t0 ) 
  FLUSHKEYS                     ( t2 t0 )
  _CDTNR                        ( t2 t0 t1 )
  SWAP %-                       ( t2 t1-t0 )
  SWAPDROP                      ( t1-t0 --- return seconds passed )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
  _RESTORESCR                   ( out )
;
;

***************************************************************************
* CAL
* arg 0 -> current month
* arg dd.mmyyyy -> go there
* calendar with menu
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME CA
::
CK1&Dispatch
#00001                          ( 0 or mm.yyyy )
::                              ( arg )
  _SAVESCR                      ( poi arg )
  SWAP                          ( arg poi )
*
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
  DUP %0= IT
    ::                          ( provide current mm.yyyy )
      DROP
      ROMPTR 004 01B            ( dd.mmyyyy )
    ;
  %FP % 100 %*                  ( mm.yyyy )
  DUP %IP                       ( %mm.yyyy %m )
  SWAP                          ( %m %mm.yyyy )
  %FP % 10000 %*                ( %m %y )
*  COERCESWAP COERCESWAP         ( #m #y )
  COERCE2
* menu loop top
  BEGIN                         ( #m #y )
****************************************************************************
  # 0630 #MAX                   ( --- 1584 )
  # 270F #MIN                   ( --- 9999 )
  SWAP
  ONE #MAX
  TWELVE #MIN
  SWAP                          ( #m #y --- range checked )
*
  2DUP                          ( #m #y #m #y )
*  UNCOERCE SWAP UNCOERCE SWAP   ( #m #y %m %y )
  UNCOERCE2
  % 10000 %/ %+
*
  % 100
  %/
  %1 %+
  %0
  ERRSET
  ROMPTR 004 022                ( --- DATE+DAYS )
  ERRTRAP
  ::
    ERRJMP
  ;
  BINT49 ClrSysFlag BINT50 ClrSysFlag           ( --- DOSTD)
  DUP
  BEGIN
  DUP
  % 1E-2
  %MOD
  % 1.01
  %+
  % 1.01199
  OVER
  ROMPTR 004 021                ( --- DDAYS )
  %7
  %MOD
  DUP
  %3
  %>
  IT
  ::
    %7
    %-
  ;
*  UNROT SWAP
  SWAPROT
  ROMPTR 004 021                ( --- DDAYS )
  %+
  %7
  %/
  %FLOOR
  %1 %+
  DUP%0=
  WHILE
  ::
    DROPDUP
    % 3.0109999E1
    %+
  ;
  REPEAT
  OVER
  %FP
  % 100
  %*
  DUP
  %IP COERCE
  ARRY [
    $ "Jan"
    $ "Feb"
    $ "Mar"
    $ "Apr"
    $ "Mai"
    $ "Jun"
    $ "Jul"
    $ "Aug"
    $ "Sep"
    $ "Okt"
    $ "Nov"
    $ "Dez"
  ]

  GETATELN
  DROP
  APPEND_SPACE
  SWAP
  %FP
  % 1E4
  %*
  DO>STR
*  DUPLEN$
*  1_#1-SUB$
  &$
* add day number of first day of month
* stack now: flags 2.01 #m #y 1.mmyyyy wk
* use for display of number of first day of month
  CHR_:
  >T$
  5PICK 5PICK
*  2OVER                         ( ... #m #y )
*  UNCOERCE SWAP UNCOERCE SWAP   ( ... %m %y )
  UNCOERCE2
  % 1000000 %/                  ( ... %m .00yyyy )
  DUP                           ( ... %m .00yyyy .00yyyy )
  % 1.01 %+                     ( ... %m .00yyyy 1.01yyyy )
  SWAP                          ( ... %m 1.01yyyy .00yyyy )
  ROT                           ( ... 1.01yyyy .00yyyy %m )
  % 100 %/                      ( ... 1.01yyyy .00yyyy .mm )
  %1 %+ %+                      ( ... 1.01yyyy .00yyyy+1.mm )
  ROMPTR 004 021                ( --- DDAYS )
  %1 %+
  DO>STR
*  DUPLEN$
*  1_#1-SUB$                     ( --- remove decimal dot )
  &$
*
* use ABUFF
*  ClrDA1IsStat
  RECLAIMDISP
  TURNMENUOFF                   ( --- remove menu keys )
*
  $>grob
  ABUFF
  ZEROZERO
  GROB!
*
* put a date and time string in the upper right corner
*
  ROMPTR 004 01B                ( --- DATE )
  ROMPTR 004 01A                ( --- TIME )
  ROMPTR 004 020                ( --- TIMESTR )
*  FIVE NINETEEN SUB$
*  TWENTY                       ( --- TBD: cut off sec? )
*  1_#1-SUB$
  $>grob
  ABUFF
*  BINT72
  BINT50                        ( --- was FIFTYSIX, BINT54, BINT51, BINT50 )
  ZERO
  GROB!
*
  ZERO SEVEN
  BINT130
  BINT7
  LINEON

  $ "Mo Di Mi Do Fr Sa So"
  $>GROB
  ABUFF
  BINT11
  BINT9
  GROB!
  OVERDUP
  % 1E-2
  %+
  DUP
  % 1.13
  %>=
  IT
  ::
    % 1.19999E-1
    %-
  ;
  ROMPTR 004 021                ( --- DDAYS )
  COERCE
  $ " 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31"
  SWAP
  BINT3
  #*
  1_#1-SUB$
  % 1.01199
  4ROLL
  ROMPTR 004 021                ( --- DDAYS )
  %7
  %MOD
  COERCE
  BINT3
  #*
*    1234567890123456789012
  $ "                      "    ( --- Blank$ replacement )
  SWAP #1+ 1_#1-SUB$
  SWAP&$
  BINT17
  BEGIN
  3PICK
  % 100
  %+
  DO>STR
  CDR$
*  DUPLEN$
*  1_#1-SUB$
  $>grob
  ABUFF
  BINT0
  4PICK
  #1+
  GROB!
  BINT17
  OVER#=
  4PICK
  % 5.2E1
  %>=
  AND
  IT
  ::
    ROTDROP
    %0
    3UNROLL
  ;
  OVER
  BINT21
  1_#1-SUB$
  $>GROB
  ZEROZERO
  3PICK
  GROBDIM
  SWAP#1-
  SUBGROB
  ABUFF
  BINT11
  4PICK
  GROB!
  ROT
  %1 %+
  ROT
  BINT22
  LAST$
  ROT
  #8+
  OVER LEN$
  #0=
  UNTIL
  3DROP
****************************************************************************
*                               ( #m #y )
*  FLUSHKEYS                     ( m y )
  WaitForKey                    ( m y #c #p )
  DROP                          ( m y #c --- ignore plane for now )
  TURNMENUOFF
  ::
  kcRightArrow #=casedrop       ( --- M+ )
  ::
    SWAP#1+                     ( y m' )
    TWELVE OVER#<               ( y m' m'>12? )
    ITE
     ::                         ( y m' --- m'>12 )
       DROPONE                  ( y 1 )
       SWAP#1+                  ( 1 y+1 )
     ;
     SWAP                       ( m' y )
     FALSE
  ;
  kcLeftArrow #=casedrop        ( --- M- )
  ::
    SWAP                        ( y m )
    DUP#1=                      ( y m m=1? )
    ITE
      ::                        ( y m --- m=1 )
        DROP TWELVE             ( y 12 )
        SWAP#1-                 ( 12 y-1 )
      ;
      ::                        ( y m --- m>1 )
        #1-                     ( y m-1 )
        SWAP                    ( m y )
      ;
    FALSE
  ;
  kcDownArrow #=casedrop        ( --- Y+ )
    :: #1+ FALSE ;
  kcUpArrow #=casedrop          ( --- Y- )
    :: #1- FALSE ;
  kcENTER #=casedrop            ( --- NOW )
  ::                            ( m y )
    2DROP                       
    ROMPTR 004 01B              ( dd.mmyyyy --- DATE )
    %FP                         ( .mmyyyy )
    % 100 %*                    ( mm.yyyy )
    DUP %IP COERCE              ( mm.yyyy m )
    SWAP %FP % 10000 %*         ( m %yyyy )
    COERCE                      ( m y )
    FALSE
  ;
  kcOn #=casedrop :: TRUE ;     ( --- exit )
  DROP DoBadKey FALSE           ( any other key )
  ;
****************************************************************************
  UNTIL                         ( #m #y  )
  UNCOERCE % 1E6 %/
  SWAP UNCOERCE
  % 100 %/ %+                   ( .mmyyyy )

* footer begin
*  xMENU                         ( f )

*  DOSTOSYSF
*  ClrDAsOK
* footer end
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
*                               ( poi out )
  _RESTORESCR                   ( out )
;
;

***************************************************************************
* daylight duration
* 0 lat -> dl of today
* dd.mmyyyy lat -> dl of that date
*
*  DayLight := 0.1+acos(-tan(lat)*tan(23.5*sin(
*                                              (DayNum(d,m,y)-80)
*                                              /365*360)
*                                             )
*                      )/7.5;
*
* beyond polar circle abs(l) > 66.33 round towards 0/24
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DL
::
CK2&Dispatch
#00011                          ( 0|d lat )
::
  ROMPTR 004 02B                ( d l f --- xRCLF )
  FORTYTWO SetSysFlag           ( d l f --- EU date format )
  BINT17 ClrSysFlag             ( d l f --- force 360 degree system )
  BINT18 ClrSysFlag
  UNROT                         ( f d l )
  DUP %ABS                      ( f d l abs{l} )
  BINT4 ClrSysFlag              ( --- borrow this flag )
  % 66.32 %> IT                 ( f d l --- abs{lat} > 66.32 deg? )
    ::                          ( f d l --- beyond polar circle )
      % 66.32                   ( f d l l_lim --- prevent error )
      SWAP %0>= ?SKIP %CHS      ( f d l_lim --- with correct sign )
      BINT4 SetSysFlag          ( --- needed below )
    ;
  SWAP                          ( f l d )
  DUP %0= IT
    ::                          ( provide current mm.yyyy )
      DROP                      ( f l )
      ROMPTR 004 01B            ( f l d --- DATE )
    ;
  DUP                           ( f l d d )
  % 100 %* %FP                  ( f l d .yyyy )
  % 100 %/ % 1.01 %+            ( f l d 1.01yyyy --- 1st day of year )
  SWAP                          ( f l d1 d )
  ROMPTR 004 021                ( f l dd --- DDAYS )
  %1 %+                         ( f l dn --- day number in year )
  % 80 %-                       ( f l dn' )
  % 365 %/ %360 %*              ( f l dn'' )
  %SIN % 23.5 %* %TAN           ( f l dn''' )
  SWAP %TAN %CHS %*
  %ACOS % 7.5 %/
  % 0.1 %+                      ( f h )
  BINT4 TestSysFlag IT          ( --- undo l_lim? )
    ::
      %10 %< ITE %0 % 24        ( --- round towards 0/24 )
    ;
  %>HMS %2 RNDXY                ( f hh.mm )
  SWAP                          ( hh.mm f )
  ROMPTR 004 02C                ( f --- xSTOF )
;
;

***************************************************************************
* moon phase
* 0|date -> 0 .. 0.5 .. 1 = Voll .. Neu .. Voll
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME MP
::
CK1&Dispatch
#00001                          ( 0|d )
::
  FORTYTWO SetSysFlag           ( d --- EU date format )
  DUP %0= IT
    ::                          ( provide current mm.yyyy )
      DROP
      ROMPTR 004 01B            ( d --- DATE )
    ;
  % 28.0416                     ( d d0 --- reference date )
  SWAP
  ROMPTR 004 021                ( dd --- DDAYS )
  % 29.53058868                 ( dd moon_period )
  %/ %FP
  %3 RNDXY
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;
;

***************************************************************************
* returns TVM equation for editing and solving
* -> $eq
***************************************************************************
ASSEMBLE
        CON(3)  8
RPL
xNAME TV
::
CK0
::
* this returns a thing that can be COPYied and STOred in En or Ans
* Value of Ans can be used to copy eq in Pgm source
  $ "'P*(1+I)^N+R*(1+I*B)*((1+I)^N-1)/I+F'"
;
;

***************************************************************************
* TVM
* { PV Rate nper beg i FV } k
* { p  r    n    b   i f }
*   beg 1..0 = Begin..End of period
*   k = which var to solve for = 1..6
* p*{1+i}^n+r*{1+i*b}^n*{{1+i}^n-1}/i+f = 0
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME TVM
::
CK2&Dispatch
#00051                          ( {p r n b i f} real )
::
  COERCE                        ( {p r n b i f} k )
  SIX OVER #<                   ( {p r n b i f} k k>6? )
  OVER#0=                       ( {p r n b i f} k k>6? k=0? )
  OR IT
    SETSIZEERR              ( bad argument value )
*    ::
*      # 203                     ( bad argument value )
*      DO#EXIT
*    ;
*                               ( {p r n b i f} k )
  SWAP DUPLENCOMP               ( k {p r n b i f} len )
  SIX #<> IT
    ::
      # 128                     ( wrong argument count )
*      DO#EXIT
      ERROROUT
    ;
*                               ( k {p r n b i f} )
  INCOMPDROP SIX reversym DROP  ( k f i b n r p )
  7ROLL                         ( f i b n r p k )
  ::
     BINT1 #=casedrop           ( f i b n r p --- calc p )
     ::
       DROP                     ( f i b n r )
       ROT                      ( f i n r b )
       4PICK                    ( f i n r b i )
       %*                       ( f i n r bi )
       %1 %+ %*                 ( f i n r{1+ib} )
       3PICK                    ( f i n r{1+ib} i )
       %/                       ( f i n r{1+ib}/i )
*       UNROT SWAP               ( f r{1+ib}/i n i )
       SWAPROT                  ( f r{1+ib}/i n i )
       %1 %+                    ( f r{1+ib}/i n 1+i )
       SWAP %^                  ( f r{1+ib}/i {1+i}^n )
       ROTOVER                  ( r{1+ib}/i {1+i}^n f {1+i}^n )
       %/                       ( r{1+ib}/i {1+i}^n f/{1+i}^n )
       %1 ROT %/ %1 %-          ( r{1+ib}/i f/{1+i}^n 1/{1+i}^n-1 )
       ROT %* SWAP %-           ( p --- done )
       %2 RNDXY
     ;   
     BINT2 #=casedrop           ( f i b n r p --- calc r )
     ::
       SWAPDROP                 ( f i b n p )
       4PICK                    ( f i b n p i )
       %1 %+                    ( f i b n p 1+i )
       ROT                      ( f i b p 1+i n )
       %^                       ( f i b p {1+i}^n )
       DUPROT                   ( f i b {1+i}^n {1+i}^n p )
       %*                       ( f i b {1+i}^n p{{1+i}^n} )
       5ROLL                    ( i b {1+i}^n p{{1+i}^n} f )
       %+                       ( i b {1+i}^n f+p{{1+i}^n} )
       4PICK                    ( i b {1+i}^n f+p{{1+i}^n} i )
       %*                       ( i b {1+i}^n i{f+p{{1+i}^n}} )
       4UNROLL                  ( i{f+p{{1+i}^n}} i b {1+i}^n )
       %1 SWAP %-               ( i{f+p{{1+i}^n}} i b 1-{1+i}^n )
       UNROT                    ( i{f+p{{1+i}^n}} 1-{1+i}^n i b )
       %* %1 %+                 ( i{f+p{{1+i}^n}} 1-{1+i}^n 1+ib )
       %* %/                    ( r --- done )
       %2 RNDXY
     ;   
     BINT3 #=casedrop           ( f i b n r p --- calc n )
     ::
       ROTDROP                  ( f i b r p )
       4UNROLL                  ( f p i b r )
       SWAP3PICK                ( f p i r b i )
       %*                       ( f p i r bi )
       %1 %+ %*                 ( f p i r{1+bi} )
       OVER %/                  ( f p i r{1+bi}/i )
       DUP                      ( f p i r{1+bi}/i r{1+bi}/i )
       5ROLL                    ( p i r{1+bi}/i r{1+bi}/i f )
       %-                       ( p i r{1+bi}/i r{1+bi}/i-f )                
       SWAP4ROLL                ( i r{1+bi}/i-f r{1+bi}/i p )
       %+                       ( i r{1+bi}/i-f r{1+bi}/i+p )
       %/ %LN                   ( i ln{{r{1+bi}/i-f}/{r{1+bi}/i+p})
       SWAP %1 %+ %LN %/        ( n --- done )
       %0 RNDXY
     ;   
     BINT4 #=casedrop           ( f i b n r p --- calc b )
     ::
       4ROLL DROP               ( f i n r p )
       4PICK %*                 ( f i n r ip )
       OVER %+                  ( f i n r r+ip )
       4PICK %1 %+              ( f i n r r+ip 1+i )
       4ROLL                    ( f i r r+ip 1+i n )
       %^ %1 OVER %-            ( f i r r+ip {1+i}^n 1-{1+i}^n )
       UNROT                    ( f i r 1-{1+i}^n r+ip {1+i}^n )
       %*                       ( f i r 1-{1+i}^n {{1+i}^n}{r+ip} )
       5ROLL                    ( i r 1-{1+i}^n {{1+i}^n}{r+ip} f )
       5PICK                    ( i r 1-{1+i}^n {{1+i}^n}{r+ip} f i )
       %* %+                    ( i r 1-{1+i}^n {{1+i}^n}{r+ip}+fi )
       3PICK                    ( i r 1-{1+i}^n {{1+i}^n}{r+ip}+fi r )
       %-                       ( i r 1-{1+i}^n {{1+i}^n}{r+ip}+fi-r )
       4UNROLL                  ( {{1+i}^n}{r+ip}+fi-r i r 1-{1+i}^n )
       %* %*                    ( {{1+i}^n}{r+ip}+fi-r {1-{1+i}^n}ri )
       %/                       ( b --- done )
       %2 RNDXY
     ;   
     BINT5 #=casedrop           ( f i b n r p --- calc i )
     ::
       5ROLL DROP               ( f b n r p )
       FIVE ::N                 ( :: f b n r p ; )
       '                        ( --- quote routine to be zeroed )
       ::                       ( i f b n r p --- i provided by _BRENT )
       6ROLL                    ( f b n r p i )
       DUP %0<> ITE
         ::                     ( f b n r p i --- i<>0 )
       5UNROLL                  ( f i b n r p )
       OVER                     ( f i b n r p r )
       5PICK                    ( f i b n r p r b )
       %* %+                    ( f i b n r br+p )
       5PICK %*                 ( f i b n r i{br+p} )
       OVER %+                  ( f i b n r i{br+p}+r )
       5PICK %1 %+              ( f i b n r i{br+p}+r 1+i )
       4ROLL %^                 ( f i b r i{br+p}+r {1+i}^n )
       %*                       ( f i b r {{1+i}^n}{i{br+p}+r} )
       SWAPROT                  ( f i {{1+i}^n}{i{br+p}+r} r b )
       4PICK                    ( f i {{1+i}^n}{i{br+p}+r} r b i )
       %* %1 %+ %*              ( f i {{1+i}^n}{i{br+p}+r} r{1+ib} )
       SWAP %-                  ( f i r{1+ib}-{{1+i}^n}{i{br+p}+r} )
       SWAP %/                  ( f {r{1+ib}-{{1+i}^n}{i{br+p}+r}}/i )
       %-                       ( f-f )
         ;
         ::                     ( f b n r p i --- i=0 )
           DROP                 ( f b n r p )
           UNROT                ( f b p n r )
           %*                   ( f b p r*n )
           %+                   ( f b p+r*n )
           SWAPDROP             ( f p+r*n )
           %-                   ( f-{p+r*n} )
         ;
       ;
       &COMP                    ( :: ... ; )
*       % -9999999999            ( pgm xlo )
       % -0.9999999999          ( pgm xlo )
       % 9999999999             ( pgm xlo xhi )
       % 0.005                  ( pgm xlo xhi xguess )
       _BRENT                   ( x0 )
       %4 RNDXY
     ;   
     BINT6 #=casedrop           ( f i b n r p --- calc f )
     ::
       OVER                     ( f i b n r p r )
       5PICK                    ( f i b n r p r b )
       %* %+                    ( f i b n r br+p )
       5PICK %*                 ( f i b n r i{br+p} )
       OVER %+                  ( f i b n r i{br+p}+r )
       5PICK %1 %+              ( f i b n r i{br+p}+r 1+i )
       4ROLL %^                 ( f i b r i{br+p}+r {1+i}^n )
       %*                       ( f i b r {{1+i}^n}{i{br+p}+r} )
       SWAPROT                  ( f i {{1+i}^n}{i{br+p}+r} r b )
       4PICK                    ( f i {{1+i}^n}{i{br+p}+r} r b i )
       %* %1 %+ %*              ( f i {{1+i}^n}{i{br+p}+r} r{1+ib} )
       SWAP %-                  ( f i r{1+ib}-{{1+i}^n}{i{br+p}+r} )
       SWAP %/                  ( f {r{1+ib}-{{1+i}^n}{i{br+p}+r}}/i )
       SWAPDROP                 ( f --- done )
       %2 RNDXY
     ;   
* else: should never occur
   ;
;
;

*****************************************************************************
* Wait For Key
* -> keynum
*****************************************************************************
ASSEMBLE
        CON(3)  8               ( a command )
RPL
xNAME WFK
::
CK0                             ( has no args )
::
  TURNMENUOFF
  $ "Any Key continues " DISPROW7
  WaitForKey
  DROP
  UNCOERCE
;
;

***************************************************************************
* FLC
* { F L C } k
* L*C=1/(2*pi*F)^2
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME FLC
::
CK2&Dispatch
#00051                          ( {f l c} %k )
::
  BINT3 _LKCHK                  ( f l c k )
  ::
     BINT1 #=casedrop           ( f l c --- calc f )
     ::
       ROTDROP                  ( l c )
       %* %SQRT _OM
       _RCP
     ;   
     BINT2 #=casedrop           ( f l c --- calc l )
     ::
       UNROTDROP                ( c f )
       _OM DUP %* %*
       _RCP
     ;   
     BINT3 #=casedrop           ( f l c --- calc c )
     ::
       DROPSWAP                 ( l f )
       _OM DUP %* %*
       _RCP
     ;   
   ;
;
;

***************************************************************************
* FLX
* { F L X } k
* X = 2*pi*F*L
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME FLX
::
CK2&Dispatch
#00051                          ( {f l x} %k )
::
  BINT3 _LKCHK                  ( f l x k )
  ::
     BINT1 #=casedrop           ( f l x --- calc f )
     ::
       ROTDROPSWAP              ( x l )
       _OM %/
     ;   
     BINT2 #=casedrop           ( f l x --- calc l )
     ::
       UNROTDROP                ( x f )
       _OM %/
     ;   
     BINT3 #=casedrop           ( f l x --- calc x )
     ::
       DROPSWAP                 ( l f )
       _OM %*
     ;   
   ;
;
;

***************************************************************************
* FCX
* { F C X } k
* X = 1/{2*pi*F*C}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME FCX
::
CK2&Dispatch
#00051                          ( {f c x} %k )
::
  BINT3 _LKCHK                  ( f c x k )
  ::
     BINT1 #=casedrop           ( f c x --- calc f )
     ::
       ROTDROPSWAP              ( x c )
       _OM %*
       _RCP
     ;   
     BINT2 #=casedrop           ( f c x --- calc c )
     ::
       UNROTDROP                ( x f )
       _OM %*
       _RCP
     ;   
     BINT3 #=casedrop           ( f c x --- calc x )
     ::
       DROPSWAP                 ( c f )
       _OM %*
       _RCP
     ;   
   ;
;
;

***************************************************************************
* QP
* { Q R L C } k
* Q = R*sqrt{C/L}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME QP
::
CK2&Dispatch
#00051                          ( {q r l c} %k )
::
  BINT4 _LKCHK                  ( q r l c k )
  ::
     BINT1 #=casedrop           ( q r l c --- calc q )
     ::
       SWAP %/ %SQRT %*
       SWAPDROP                 ( --- SWAPDROP here made download fail!!! )
     ;   
     BINT2 #=casedrop           ( q r l c --- calc r )
     ::
       %/ %SQRT SWAPDROP %*
     ;   
     BINT3 #=casedrop           ( q r l c --- calc l )
     ::
       SWAPDROP                 ( q r c )
       SWAPROT                  ( c r q )
       %/ DUP %* %*
     ;   
     BINT4 #=casedrop           ( q r l c --- calc c )
     ::
       DROP UNROT               ( l q r )
       %/ DUP %* %*
     ;   
   ;
;
;

***************************************************************************
* QS
* { Q R L C } k
* Q = 1/R*sqrt{L/C}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME QS
::
CK2&Dispatch
#00051                          ( {q r l c} %k )
::
  BINT4 _LKCHK                  ( q r l c k )
  ::
     BINT1 #=casedrop           ( q r l c --- calc q )
     ::
       %/ %SQRT SWAP %/
       SWAPDROP
     ;   
     BINT2 #=casedrop           ( q r l c --- calc r )
     ::
       %/ %SQRT UNROTDROP %/
     ;   
     BINT3 #=casedrop           ( q r l c --- calc l )
     ::
       SWAPDROP                 ( q r c )
       SWAPROT                  ( c r q )
       %* DUP %* %*
     ;   
     BINT4 #=casedrop           ( q r l c --- calc c )
     ::
       DROP UNROT               ( l q r )
       %* DUP %* SWAP %/
     ;   
   ;
;
;

***************************************************************************
* PAR
* { C1 C2 C } k
* 1/C = 1/C1 + 1/C2
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PAR
::
CK2&Dispatch
#00051                          ( {c1 c2 c} %k )
::
  BINT3 _LKCHK                  ( c1 c2 c k )
  ::
     BINT1 #=casedrop           ( c1 c2 c --- calc c1 )
     ::
       _RCP                     ( c1 c2 1/c )
       SWAP                     ( c1 1/c c2 )
       _RCP                     ( c1 1/c 1/c2 )
       %- SWAPDROP              ( 1/c-1/c2 )
       _RCP                     ( c1 )
     ;   
     BINT2 #=casedrop           ( c1 c2 c --- calc c2 )
     ::
       SWAPDROP                 ( c1 c )
       _RCP                     ( c1 1/c )
       SWAP                     ( 1/c c1 )
       _RCP                     ( 1/c 1/c1 )
       %- _RCP                  ( c2 )
     ;   
     BINT3 #=casedrop           ( c1 c2 c --- calc c )
     ::
       DROP
       _RCP SWAP _RCP
       %+ _RCP
     ;   
   ;
;
;

***************************************************************************
* VD
* voltage divider
* { V1 V2 R1 R2 } k
* V2 = V1*R2/(R1+R2)
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME VD
::
CK2&Dispatch
#00051                          ( {v1 v2 r1 r2} %k )
::
  BINT4 _LKCHK                  ( v1 v2 r1 r2 k )
  ::
     BINT1 #=casedrop           ( v1 v2 r1 r2 --- calc v1 )
     ::
       DUPROT                   ( v1 v2 r2 r2 r1 )
       %+ SWAP %/ %*
       SWAPDROP                 ( v1 )
     ;   
     BINT2 #=casedrop           ( v1 v2 r1 r2 --- calc v2 )
     ::
       DUPROT                   ( v1 v2 r2 r2 r1 )
       %+ %/                    ( v1 v2 r2/{r1+r2} )
       SWAPDROP %*              ( v2 )
     ;   
     BINT3 #=casedrop           ( v1 v2 r1 r2 --- calc r1 )
     ::
       SWAPDROP                 ( v1 v2 r2 --- another SWAPDROP dnld fail )
       UNROT                    ( r2 v1 v2 )
       %/ %1 %- %*
     ;   
     BINT4 #=casedrop           ( v1 v2 r1 r2 --- calc r2 )
     ::
       DROP                     ( v1 v2 r1 )
       UNROT                    ( r1 v1 v2 )
       %/ %1 %- %/
     ;   
   ;
;
;

***************************************************************************
* ID
* current divider
* { U R0 R1 R2 I2 } k
* I2 = U*R1/{R0*R1+R1*R2+R0*R2}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME ID
::
CK2&Dispatch
#00051                          ( {u r0 r1 r2 i2} %k )
::
  BINT5 _LKCHK                  ( u r0 r1 r2 i2 k )
  ::
     BINT1 #=casedrop           ( u r0 r1 r2 i2 --- calc u )
     ::
       4UNROLL                  ( u i2 r0 r1 r2 )
       2DUP %*                  ( u i2 r0 r1 r2 r1r2 )
       SWAP4PICK                ( u i2 r0 r1 r1r2 r2 r0 )
       %*                       ( u i2 r0 r1 r1r2 r0r2 )
       %+                       ( u i2 r0 r1 r1r2+r0r2 )
       UNROT                    ( u i2 r1r2+r0r2 r0 r1 )
       DUPUNROT                 ( u i2 r1r2+r0r2 r1 r0 r1 )
       %*                       ( u i2 r1r2+r0r2 r1 r0r1 )
       ROT                      ( u i2 r1 r0r1 r1r2+r0r2 )
       %+                       ( u i2 r1 r0r1+r1r2+r0r2 )
       UNROT                    ( u r0*r1+r1r2+r0r2 i2 r1 )
       %/ %* SWAPDROP
     ;   
     BINT2 #=casedrop           ( u r0 r1 r2 i2 --- calc r0 )
     ::
       4ROLL DROP               ( u r1 r2 i2 )
       UNROT                    ( u i2 r1 r2 )
       2DUP                     ( u i2 r1 r2 r1 r2 )
       %+                       ( u i2 r1 r2 r1+r2 )
       4PICK %*                 ( u i2 r1 r2 i2{r1+r2} )
       5UNROLL                  ( i2{r1+r2} u i2 r1 r2 )
       SWAP                     ( i2{r1+r2} u i2 r2 r1 )
       4UNROLL                  ( i2{r1+r2} r1 u i2 r2 )
       %* %- %*                 ( i2{r1+r2} r1{u-i2r2} )
       SWAP %/
     ;   
     BINT3 #=casedrop           ( u r0 r1 r2 i2 --- calc r1 )
     ::
       ROTDROP                  ( u r0 r2 i2 )
       THREE NDUP               ( u r0 r2 i2 r0 r2 i2 )
       %* %*                    ( u r0 r2 i2 i2r0r2 )
       5UNROLL                  ( i2r0r2 u r0 r2 i2 )
       UNROT                    ( i2r0r2 u i2 r0 r2 )
       %+ %* %-                 ( i2r0r2 u-i2{r0+r2} )
       %/
     ;   
     BINT4 #=casedrop           ( u r0 r1 r2 i2 --- calc r2 )
     ::
       SWAPDROP                 ( u r0 r1 i2 )
       THREE NDUP               ( u r0 r1 i2 r0 r1 i2 )
       UNROT                    ( u r0 r1 i2 i2 r0 r1 )
       %+ %*                    ( u r0 r1 i2 i2{r0+r1} )
       5UNROLL                  ( i2{r0+r1} u r0 r1 i2 )
       ROT %*                   ( i2{r0+r1} u r1 i2r0 )
       ROTSWAP                  ( i2{r0+r1} r1 u i2r0 )
       %- %*                    ( i2{r0+r1} r1{u-i2r0} )
       SWAP %/
     ;   
     BINT5 #=casedrop           ( u r0 r1 r2 i2 --- calc i2 )
     ::
       DROP                     ( u r0 r1 r2 )
       2DUP %*                  ( u r0 r1 r2 r1r2 )
       4UNROLL                  ( u r1r2 r0 r1 r2 )
       UNROT                    ( u r1r2 r2 r0 r1 )
       2DUP %*                  ( u r1r2 r2 r0 r1 r0r1 )
       4UNROLL                  ( u r1r2 r0r1 r2 r0 r1 )
       UNROT                    ( u r1r2 r0r1 r1 r2 r0 )
       %*                       ( u r1r2 r0r1 r1 r0r2 )
       SWAP                     ( u r1r2 r0r1 r0r2 r1 )
       4UNROLL                  ( u r1 r1r2 r0r1 r0r2 )
       %+ %+                    ( u r1 r1r2+r0r1+r0r2 )
       UNROT                    ( r1r2+r0r1+r0r2 u r1 )
       %*                       ( r1r2+r0r1+r0r2 u*r1 )
       SWAP %/
     ;   
   ;
;
;

***************************************************************************
* dB conversions back and forth
* x 0 -> select from list
* x n -> perform conversion n  {too many for single commands}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DB
::
CK2&Dispatch
#00011                          ( x %n )
::
  COERCE                        ( x n )
  DUP#0= IT                     ( x n )
    ::
  DROP                          ( )
  $ "dB Conv"
  { 
*    12345678901234
{ $ " 1 dBm  P"    BINT1 }
{ $ " 2 dBm  Vp"   BINT2 }
{ $ " 3 dBm  dB"   BINT3 }
{ $ " 4 dB   p"    BINT4 }
{ $ " 5 dB   v"    BINT5 }
{ $ " 6 dB   dBm"  BINT6 }
{ $ " 7 P    dBm"  BINT7 }
{ $ " 8 Vp   dBm"  BINT8 }
{ $ " 9 p    dB"   BINT9 }
{ $ "10 v    dB"   BINT10 }
{ $ "11 P    Vp"   BINT11 }
{ $ "12 Vp   P"    BINT12 }
  }
  ChooseSimple                  ( x n T | F )
  ?SKIP ZERO                    ( x n | 0 )
    ;
* now on stack: #0 or #1..
  DUP#0= ITE                    ( x n )
    DROP                        ( x )
    ::
      DUP BINT12 #> ITE
      SETSIZEERR                ( bad argument value )
*      ::
*        # 203                   ( bad argument value )
*        DO#EXIT
*       ;
      ::
* now on stack: #1..12
        ::
          BINT1 #=casedrop      ( x --- dBm -> P )
          ::
            %10 %/ %ALOG % 1000 %/
          ;
          BINT2 #=casedrop      ( x --- dBm -> Vp )
          ::
            %10 %/ %ALOG % 1000 %/              ( P )
            %2 %* % 50 %* %SQRT                 ( sqrt{2PR} --- R=50Ohm )
          ;
          BINT3 #=casedrop      ( x --- dBm -> dB )
          ::
            % 30 %-
          ;
          BINT4 #=casedrop      ( x ---  dB -> p )
          ::
            %10 %/ %ALOG
          ;
          BINT5 #=casedrop      ( x ---  dB -> v )
          ::
            % 20 %/ %ALOG
          ;
          BINT6 #=casedrop      ( x --- dB -> dBm )
          ::
           % 30 %+
          ;
          BINT7 #=casedrop      ( x --- P -> dBm )
          ::
            % 1000 %* %LOG %10 %*
          ;
          BINT8 #=casedrop      ( x --- Vp -> dBm )
          ::
            DUP %* %10 %*       ( mW )
            %LOG %10 %*
          ;
          BINT9 #=casedrop      ( x --- p -> dB )
          ::
            %LOG %10 %*
          ;
          BINT10 #=casedrop      ( x --- v -> dB )
          ::
            %LOG % 20 %*
          ;
          BINT11 #=casedrop      ( x --- P -> Vp )
          ::
            % 100 %* %SQRT
          ;
          BINT12 #=casedrop      ( x --- Vp -> P )
          ::
            DUP %* % 100 %/
          ;
        ;
      ;
    ;
;
;
*****************************************************************************
* New 26.01.2003
*****************************************************************************
***************************************************************************
* flag test and optional change
* flag_no new_state -> old_state
* flag_no = 1..128 for user flags, -1..-128 for system flags
* flag_no = 0: clr all user flags, independent of new_state
* old_state = 0|1
* new_state: -1/0/1/2 = toggle/clear/set/keep
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME SF
::
CK2&Dispatch
#00011                          ( real real )
::                              ( %flag %new )
  OVER %0= ITE                  ( %flag %new --- %flag=0? )
  ::                            ( --- yes, clr all user flags )
    DROP                        ( %0 )
    BINT128
    #1+_ONE_DO (DO)             ( s )
      INDEX@
      ClrUserFlag
    LOOP                        ( %0 )
  ;
  ::                            ( --- no, handle individual flags )
  %1 %+ COERCE                  ( %flag new --- mapped to 0/1/2/else )
  SWAPDUP                       ( new %flag %flag )
  %0< ITE                       ( new %flag )
  ::                            ( < 0: system flag )
    %ABSCOERCE                  ( new flag' )
    DUP TestSysFlag             ( new flag old)
    UNROT SWAP                  ( old flag new )
    ::
      BINT0 OVER#=case
      :: 3PICK ITE                              ( --- toggle )
        :: OVER ClrSysFlag ;
        :: OVER SetSysFlag ;
      ;
      BINT1 OVER#=case :: OVER ClrSysFlag ;     ( --- clr )
      BINT2 OVER#=case :: OVER SetSysFlag ;     ( --- set )
    ;                           ( old flag new )
  ;
  ::                            ( >= 0: user flag )
    COERCE                      ( new flag )
    DUP TestUserFlag            ( new flag old)
    UNROT SWAP                  ( old flag new )
    ::
      BINT0 OVER#=case
      :: 3PICK ITE                              ( --- toggle )
        :: OVER ClrUserFlag ;
        :: OVER SetUserFlag ;
      ;
      BINT1 OVER#=case :: OVER ClrUserFlag ;    ( --- clr )
      BINT2 OVER#=case :: OVER SetUserFlag ;    ( --- set )
    ;                           ( old flag new )
  ;
  2DROP                         ( old )
  ITE %1 %0                     ( %old )
  ;
;
;

***************************************************************************
* BINOmial probability
* k w z g1 g2 -> p
* p = probability to draw g1..g2 white balls within z drawings
*     from a cup with k balls, among these w white balls
* drawn balls _not_ returned into the cup
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BINO
::                              ( k w z g1 g2 --- 5 reals )
CK5&Dispatch
#11111
::
  FALSE
  _BINO
;
;

***************************************************************************
* BINOmial probability with balls Returned to cup
* k w z g1 g2 -> p
* p = probability to draw g1..g2 white balls within z drawings
*     from a cup with k balls, among these w white balls
* drawn balls _are_ returned into the cup
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BINOR
::                              ( k w z g1 g2 --- 5 reals )
CK5&Dispatch
#11111
::
  TRUE
  _BINO
;
;

***************************************************************************
* SAMe Color probability
* n c d -> p
* prob of d balls having same color in box of n balls, c possible colors
* birthday problem: (23,365,2) -> 0.5
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL

DEFINE RCLnz    4GETLAM
DEFINE STOnz    4PUTLAM
DEFINE RCLcf    3GETLAM
DEFINE STOcf    3PUTLAM
DEFINE RCLdk    2GETLAM
DEFINE STOdk    2PUTLAM
DEFINE RCLpp    1GETLAM
DEFINE STOpp    1PUTLAM

xNAME SAMC
::
CK3&Dispatch
#00111                          ( z f k )
::
  %.5                           ( z f k p )
  {
    NULLLAM NULLLAM NULLLAM NULLLAM
  }
  BIND                          ( --- local vars created )
*
  RCLdk %1 %< IT SETSIZEERR     ( --- bad argument value )
*
  RCLnz %2 %<
  RCLnz RCLdk %1 %- RCLcf %* %>
    OR
  RCLcf %2 %<
    OR
  ITE
    %1
    ::
      RCLdk RCLnz %>
      ITE
        %0
        ::
* precompute most of the expression --- cannot use local vars with _BRENT
  RCLnz DUP %CHS RCLcf RCLdk %* %/ %EXP %*      ( L --- LHS )
*
  RCLcf RCLdk %1 %- %^                          ( L f1 --- factor1 )
  RCLdk %NFACT                                  ( L f1 f2 --- factor2 )
    %*                                          ( L f1*f2 )
  %1 RCLnz RCLdk %1 %+ RCLcf %* %/ %-           ( L f1*f2 f4 --- factor4 )
    %*                                          ( L f1*f2*f4 )
  %1 RCLdk %/ SWAP                              ( L froot ff )
*
* left to be done in passed routine: L-{ff*factor3}^froot
* factor3 = ln{1/{1-p}}
*
  THREE ::N                     ( :: L froot ff ; )
*
'                               ( --- quote routine to be zeroed )
::                              ( p L froot ff --- p provided by _BRENT )
  4ROLL                         ( L froot ff p  )
  %1 DUPROT                     ( L froot ff 1 1 p  )
  %- %/ %LN                     ( L froot ff factor3  )
  %*                            ( L froot ff*factor3 )
  SWAP %^                       ( LHS RHS )
  %-                            ( LHS-RHS )
;
          &COMP                 ( :: ... ; --- put it all together )
*
          %0 % .99999  %.5      ( pgm xlo xhi xguess )
          _BRENT                ( x0 )
          %2 RNDXY              ( --- two fractional digits )
        ;
    ;
  ABND
;
;

*****************************************************************************
* Matrix EXtrema
* matrix min and max
* [] -> { min max }
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME MEX
::
CK1&Dispatch
#00004                          ( matrix )
::
  DUP TYPERARRY?                
  ?SKIP SETTYPEERR
  _MEX
;
;

*****************************************************************************
* Matrix Slope Plotter (Slopefield Plot)
* [[..]] -> { mat_min mat_max }
* pseudo code:
* // get drawing parameters
* m -> rows,cols
* bxs = 131 div cols  // boxsize
* bys = 64 div rows
* p = {min{bxs,bys} div 2}-1  // line length
* x0 = bxs div 2  // center of upper left box
* y0 = bys div 2
* // go thru matrix elements
* i = 1
* y = y0
* for r = 1 to rows
*   x = x0
*   for c = 1 to cols
*     // center is {x,y}
*     a = arctan m_i  // array is organized row-wise
*     xx = p*cos a
*     yy = p*sin a
*     line{x-xx,y+yy,x+xx,y-yy}
*     x = x+bxs
*     i = i+1
*   end
*   y = y+bys
* end
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL

DEFINE RCLmy   10GETLAM
DEFINE STOmy   10PUTLAM
DEFINE RCLmx    9GETLAM
DEFINE STOmx    9PUTLAM
DEFINE RCLidx   8GETLAM
DEFINE STOidx   8PUTLAM
DEFINE RCLby0   7GETLAM
DEFINE STOby0   7PUTLAM
DEFINE RCLbx0   6GETLAM
DEFINE STObx0   6PUTLAM
DEFINE RCLpoi   5GETLAM
DEFINE STOpoi   5PUTLAM
DEFINE RCLbys   4GETLAM
DEFINE STObys   4PUTLAM
DEFINE RCLbxs   3GETLAM
DEFINE STObxs   3PUTLAM
DEFINE RCLcols  2GETLAM
DEFINE STOcols  2PUTLAM
DEFINE RCLrows  1GETLAM
DEFINE STOrows  1PUTLAM

xNAME MSP
::
CK1&Dispatch
#00004                          ( matrix )
::
  _SAVESCR SWAP                 ( poi matrix )
*
  DUP TYPERARRY?                
  ?SKIP SETTYPEERR
*
  DUP MDIMS                     ( m, r c T|c F )
  ?SKIP SETTYPEERR
*                               ( m rows cols --- 2D real array )
  BINT0 BINT10 NDUPN DROP       ( --- init values for local vars )
  {
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
  }
  BIND
*
  STOcols STOrows                               ( m )
  BINT131 RCLcols #/ SWAPDROP DUP STObxs        ( m bxs )
  BINT64  RCLrows #/ SWAPDROP DUP STObys        ( m bxs bys )
  #MIN #2/ #1- UNCOERCE STOpoi                  ( --- %poi saved )
  RCLbxs #2/ STObx0
  RCLbys #2/ STOby0
*
  BINT1 STOidx
  RCLby0 STOmy
*
*  RECLAIMDISP
*  TURNMENUOFF                   ( --- remove menu keys )
*
  RCLrows
  #1+_ONE_DO (DO)
    RCLbx0 STOmx
    RCLcols
    #1+_ONE_DO (DO)                             ( m )
      DUP RCLidx SWAP GETATELN DROP             ( m %m_i )
      %ATAN DUP %COS SWAP %SIN                  ( m %cos %sin )
      RCLpoi DUP                                ( m %cos %sin %p %p )
      ROT %*                                    ( m %cos %p %yy )
      UNROT %*                                  ( m %yy %xx )
*
      RCLmx UNCOERCE DUP                        ( m %yy %xx %x %x )
      3PICK %- COERCE                           ( m %yy %xx %x x-xx )
      UNROT %+ COERCE                           ( m %yy x-xx x+xx )
      ROT                                       ( m x-xx x+xx %yy )
      RCLmy UNCOERCE                            ( m x-xx x+xx %yy %y )
      2DUP                                      ( m x-xx x+xx %yy %y %yy %y )
      %+ COERCE                                 ( m x-xx x+xx %yy %y y+yy )
      4UNROLL                                   ( m x-xx y+yy x+xx %yy %y )
      SWAP %- COERCE                            ( m x-xx y+yy x+xx y-yy )
      LINEON                                    ( m )
*
      RCLmx RCLbxs #+ STOmx
      RCLidx #1+ STOidx
    LOOP
    RCLmy RCLbys #+ STOmy
  LOOP
*
  ABND                         ( m )
  _MEX                         ( { min max } )
  WaitForKey 2DROP             ( poi { min max } )
  _RESTORESCR                  ( { min max } ) 
;
;

***************************************************************************
* null list
* n -> { 0 0 0 ... } --- n elements, n >= 0
* {} cannot be created directly on HP40
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME NUL
::
CK1&Dispatch
#00001                          ( n )
::
  COERCE                        ( n )
  DUP#0=ITE
    ::
      DROP NULL{}               ( {} --- empty list )
    ;
    ::
      %0 SWAP NDUPN {}N
    ;
;
;

*****************************************************************************
* Matrix Bar Plot
* [] -> { mat_min mat_max }
* shows up to 131 first real values
* scaling: y = 63*{1-{y-min}/{max-min}} = 63..0 for ymin..ymax
* scaling: y = 63*{y-min}/{max-min} = 0..63 for ymin..ymax
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME MBP
::
CK1&Dispatch
#00004                          ( matrix )
::
  DUP TYPERARRY?                
  ?SKIP SETTYPEERR
  _SAVESCR SWAP                 ( poi m )
  DUP _MEX SWAP                 ( poi {min max} m )
  OVER INCOMPDROP               ( p {} m %max %min )
  ROTDUP                        ( p {} %max %min m m )
  ARSIZE                        ( p {} %max %min m n --- treat as flat array )
  BINT130 #MIN                  ( --- limit to screen width )
  #1+_ONE_DO (DO)               ( p {} %max %min m )
    INDEX@ OVER                 ( p {} %max %min m i m )
    GETATELN                    ( p {} %max %min m %y T )
    DROP                        ( p {} %max %min m %y )
*
* scaling: y = 63*{1-{y-min}/{max-min}} = 63..0 for ymin..ymax
*
    3PICK %-                    ( p {} %max %min m %y-%min )
    4PICK 4PICK                 ( p {} %max %min m %y-%min %max %min )
    %- %/                       ( p {} %max %min m {%y-%min}/{%max-%min} )
*    %1 SWAP %-                  ( p {} %max %min m %1-{%y-%min}/{%max-%min} )
    % 63 %* COERCE              ( p {} %max %min m #y )
*
* version dot
*    INDEX@ #1- SWAP             ( p {} %max %min m #x #y )
*    PIXON                       ( p {} %max %min m )
*
* version line
    INDEX@ #1- SWAP             ( p {} %max %min m #x #y )
    OVER BINT63                 ( p {} %max %min m #x #y #x 0 )
    LINEON                      ( p {} %max %min m )
*
  LOOP                          ( p {} %max %min m )
*
  3DROP                         ( p {} )
  WaitForKey 2DROP              ( p { min max } )
  _RESTORESCR                   ( { min max } ) 
;
;

***** MXL.SUB removed --- use AXL from ROM *****

***************************************************************************
* Get N'th obj from list or array
* src: GETOBJ from simulation aplet by JYA
* {..} n -> obn
* {..} {n} -> obn
* [..] n -> obn
* [[..]] n -> obn
* [[..]] {mn} -> obmn
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME GN
:: CK2&Dispatch 
   ARRYLIST   ( DOFLASHP ASSEMBLE ^XEQGET2 RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #255
     RPL
   ARRYREAL   ( DOFLASHP ASSEMBLE ^XEQGET2 RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #255
     RPL
   2LIST
     _GETLIST
   LISTREAL   ( DOFLASHP ASSEMBLE ^XEQGET4 RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #256
     RPL
   IDLIST     ( DOFLASHP ASSEMBLE ^XEQGETID RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #257
     RPL
   LAMLIST    ( DOFLASHP ASSEMBLE ^XEQGETID RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #257
     RPL
   IDREAL     ( DOFLASHP ASSEMBLE ^XEQGETID RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #257
     RPL
   LAMREAL    ( DOFLASHP ASSEMBLE ^XEQGETID RPL )
     ASSEMBLE
       CON(5)  =DOFLASHP
       CON(3)  #2
       CON(4)  #257
     RPL
;

***************************************************************************
* utility for GN, by JYA
***************************************************************************
NULLNAME _GETLIST
::
  DUPTYPEREAL? ?SKIP
  ::
   SWAPDUP                              ( {} ob ob )
   CRUNCH{} 3GETLAM 1GETABND            ( ob {crunched} )
  ;
  ( {} {}' --> {} # )
( {} % --> {} # )
* Reports PUFR error "Bad Argument Size" if (1) the binary integer
* coercion of % is zero, or (2) the binary integer coercion of
* % exceeds the length of {}. {} is dropped if an error is
* generated. Else, # is the binary integer coercion of %.

  DUP1LAMBIND
  DUPTYPEREAL? ?SKIP
  ::
    INNERCOMP DUP#1= caseDROP
    #2= NcaseSIZEERR
    ABND
    COERCE2
    UNROT NTHELCOMP NcaseSIZEERR
    DUPTYPELIST? NcaseSIZEERR
    SWAP NTHELCOMP NcaseSIZEERR
    RDROP
  ;
  COERCE DUP#0=case SETSIZEERR
  OVER LENCOMP OVER#< caseSIZEERR
  ABND NTHCOMPDROP
;

***************************************************************************
* AZL
* put contents of variables A..Z in a list
* -> {A B .. Z}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME AZL
::
  CK0
  _AZL
;

***************************************************************************
* LAZ
* get contents of variables A..Z from a list
* {A B .. Z} ->
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME LAZ
::
CK1&Dispatch    #00005          ( list )
::
  DUPLENCOMP                    ( l n )
  BINT26
  #=ITE
    _LAZ
    ::                          ( l --- invalid dimension )
      1281
      ERROROUT
    ;
;
;

***************************************************************************
* PUSHL
* make arg the first ob in L0
* ob -> Ans
* L0: {...} -> {ob ...}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PUSHL
::
CK1&Dispatch    #00000          ( any )
::
  xAns SWAP                     ( Ans ob  )
  xl0                           ( Ans ob {...} )
  SWAP                          ( Ans {...} ob )
  >HCOMP                        ( Ans {ob ...} )
  ' xl0 UserSto                 ( Ans --- return old Ans )
;
;

***************************************************************************
* POPL
* return first ob in L0 and delete it from L0
* L0: {ob ...}->{...} -> ob
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME POPL
::
  CK0
  xl0                           ( {} )
  DUPNULL{}? ITE
  ::                            ( {} --- invalid dimension )
    1281
    ERROROUT
  ;
  ::                            ( {} )
    DUP CARCOMP                 ( {} ob )
    SWAP                        ( ob {} )
    CDRCOMP                     ( ob {}' )
    ' xl0 UserSto               ( ob )
  ;
;

***************************************************************************
* PUSHR
* make arg the last ob in L0
* ob -> Ans
* L0: {...} -> {... ob}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PUSHR
::
CK1&Dispatch    #00000          ( any )
::
  xAns SWAP                     ( Ans ob  )
  xl0                           ( Ans ob {...} )
  SWAP                          ( Ans {...} ob )
  >TCOMP                        ( Ans {ob ...} )
  ' xl0 UserSto                 ( Ans --- return old Ans )
;
;

***************************************************************************
* POPR
* return last ob in L0 and delete it from L0
* L0: {... ob}->{...} -> ob
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME POPR
::
  CK0
  xl0                           ( {} )
  DUPNULL{}? ITE
  ::                            ( {} --- invalid dimension )
    1281
    ERROROUT
  ;
  ::                            ( {} )
    DUP DUPLENCOMP              ( {} {} n --- n>0 guaranteed here )
    NTHCOMPDROP                 ( {} ob --- get last obj )
    SWAP                        ( ob {} )
    DUPLENCOMP                  ( ob {} n )
    #1- ONESWAP                 ( ob {} 1 n-1 )
    SUBCOMP                     ( ob {}' --- last obj removed )
    ' xl0 UserSto               ( ob )
  ;
;

***************************************************************************
* Program Run
* PR(n,arg) -> Ans
* call pgm as subroutine
* arg can be any obj type: real, list, matrix, ...
*  but symb view will not accept X inside a list or matrix
* Ex: P99: Ans>L1:L1(1)^2>Ans --- just squares the first arg
*     PR(99,{3,4}) -> 9
* recursive call is ok
* call from within a program is ok, even recursive
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PR
::
CK2&Dispatch
#00010                          ( n any --- pgm number )
_PGMRUN
;

***************************************************************************
* Program run with A..Z Save
* PS(n,arg) -> Ans
* see PR
* A..Z are saved and restored =>
* A..Z can be used in Pn, but changes in A..Z will have no effect =>
* A..Z are local vars
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PS
::
CK2&Dispatch
#00010                          ( n any --- pgm number )
_PGMSRUN                       ( Ans )
;

***************************************************************************
* Program Save Real Matrix
* PSRM(n,xlo,xhi,dx) -> []
* input for MBP
* see PR
* A..Z are saved and restored, but not between Pn invocations
* and not if error
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PSRM
::
CK4&Dispatch
#01111                          ( n xlo xhi dx )
::
  _AZL                          ( n xlo xhi dx {A..Z} )
  1LAMBIND                      ( n xlo xhi dx --- A..Z in LAM1 )
*
  4ROLL                         ( xlo xhi dx n )
  _PNAME                        ( xlo xhi dx "Pn" )
  ' StoAns@Drp                  ( xlo xhi dx "Pn" 'Sto --- put args in Ans )
  SWAP                          ( xlo xhi dx 'Sto "Pn" )
  TWO ::N                       ( xlo xhi dx :: Sto "Pn" ; )
  '
  ::
    ROMPTR 701 029              ( --- ~xxRUNPGM )
    xAns                        ( ans --- return result )
    DUPTYPEREAL?
    ?SKIP SETTYPEERR            ( --- output array is real )
  ;
*                               ( xlo xhi dx :: Sto "Pn" ; 'Pgm )
  &COMP                         ( xlo xhi dx :: Sto "Pn" Pgm ; )
  4UNROLL                       ( :: Sto "Pn" Pgm ; xlo xhi dx )
* array loop                    ( p xl xh dx )
  UNROT                         ( p dx xl xh )
  OVER                          ( p dx xl xh xl )
  %-                            ( p dx xl xh-xl )
  3PICK                         ( p dx xl xh-xl dx )
  %/ COERCE #1+                 ( p dx xl n --- number of steps )
  DUP ONE {}N                   ( p dx xl n {n} )
  %0 MAKEARRY                   ( p dx xl n [0..0] --- output real array initialized )
  SWAP                          ( p dx xl [0..0] n )
*
  #1+_ONE_DO (DO)               ( p dx xl [] )
    OVER                        ( p dx xl [] xl )
    5PICK                       ( p dx xl [] xl p )
    EVAL                        ( p dx xl [] xi )
    INDEX@                      ( p dx xl [] xi i )
    PUTEL                       ( p dx xl []' )
    SWAP                        ( p dx []' xl )
    3PICK                       ( p dx []' xl dx )
    %+                          ( p dx []' xl' )
    SWAP                        ( p dx xl' []' )
  LOOP                          ( p dx xl' []' )
  4UNROLL3DROP                  ( []' )
*
  1GETABND                      ( [] {A..Z} --- LAM1 deleted )
  _LAZ                          ( [] --- A..Z restored )
;
;

***************************************************************************
* Program Save numerical ROOT finder
* PSROOT(n,xlo,xhi,xguess) -> xroot
* see PR
* A..Z are saved and restored, but not between Pn invocations
* and not if error
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PSROOT
::
CK4&Dispatch
#01111                          ( n xlo xhi xguess )
::
  _AZL                          ( n xlo xhi xguess {A..Z} )
  1LAMBIND                      ( n xlo xhi xguess --- A..Z in LAM1 )
*
  4ROLL                         ( xlo xhi xguess n )
  _PNAME                        ( xlo xhi xguess "Pn" )
  ' StoAns@Drp                  ( xlo xhi xguess "Pn" 'Sto --- put args in Ans )
  SWAP                          ( xlo xhi xguess 'Sto "Pn" )
  TWO ::N                       ( xlo xhi xguess :: Sto "Pn" ; )
  '
  ::
    ROMPTR 701 029              ( --- ~xxRUNPGM )
    xAns                        ( ans --- return result )
    DUPTYPEREAL?
    ?SKIP SETTYPEERR            ( --- else wrong error message from _BRENT )
  ;
*                               ( xlo xhi xguess :: Sto "Pn" ; 'Pgm )
  &COMP                         ( xlo xhi xguess :: Sto "Pn" Pgm ; )
  4UNROLL                       ( :: Sto "Pn" Pgm ; xlo xhi xguess )
  _BRENT                        ( xroot )
*
  1GETABND                      ( xroot {A..Z} --- LAM1 deleted )
  _LAZ                          ( xroot --- A..Z restored )
;
;

***************************************************************************
* OFF
* programmable OFF
* ON key turns on again
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME OFF
::
  CK0
  TurnOff
  %0
;

***************************************************************************
* purge lib from calc
* no args
* MALFUNCT is internal name of lib --- see memory library view
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BYEFUNCT                  ( not easily or accidentally typed in )
::
  CK0                           ( no args )
  '                             ( put pgm on stack )
  ::
    AtUserStack                 ( clear last saved command name )
    # 604 PurgeLib#             ( purge lib 1540 )
  ;
  TOTEMPOB                      ( copy pgm to TEMPOB ... )
  COLA_EVAL                     ( ... and run from there without returning )
;

***************************************************************************
* purge any lib from calc
* libno -> libno
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME PURGELIB
::
CK1&Dispatch
#00001                          ( n )
::
  COERCE                        ( #n )
  DUP 1540 #=?SKIP              ( --- do not delete this lib with this cmd )
    ::
      DUP                       ( #n #n )
      PurgeLib#                 ( #n )
    ;
  UNCOERCE                      ( n )
;
;

***************************************************************************
* readkey (on the fly)
* -> keycode (0 for none pressed; includes shift states)
* also flushes key buffer
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME RKEY
::
  CK0                           ( no args )
  CHECKKEY ITE
  ::                            ( #kc )
    UNCOERCE                    ( kc )
    FLUSHKEYS
  ;
  %0                            ( return 0 for no key pressed )
;

***************************************************************************
* hex -> dez
* (prompt) -> %
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME HD
::
  CK0
  _GETHEX                       ( s )
  DUP                           ( s s )
  % 16 _FMBASE                  ( s % )
  SWAP                          ( % s )
  ROMPTR 004 08A                ( s:% --- TAG )
;

***************************************************************************
* %dez -> {$hex,oct,bin}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DH
::
CK1&Dispatch
#00001                          ( real )
::                              ( d )
  DUP % 16                      ( d d 16 )
  _TOBASE                       ( d b16 )
  CHR_h >H$                     ( d b16 )
  SWAPDUP %8 _TOBASE            ( b16 d b8 )
  CHR_o >H$                     ( b16 d b8 )
  SWAP %2 _TOBASE               ( b16 b8 b2 )
  CHR_b >H$                     ( b16 b8 b2 )
  THREE {}N
;
;

***************************************************************************
* Base Conversion
* { msbyte .. lsbyte} %b -> %d
* %d %b -> { %msbyte .. %lsbyte }
* % 2 <= b <= 200 (because chars 9 < c < A not used for hex compatibility )
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BC
::
CK2&Dispatch
#00051                          ( {} %b )
::
  _CHKBASE
  SWAP _BASELS                  ( %b s_b )
  SWAP _FMBASE                  ( %d )
;
#00011                          ( %d %b )
::
  _CHKBASE
  _TOBASE _BASESL
;
;

***************************************************************************
* bit ops on single real
* %v %n %p ->
* n = 0 (LSB) .. 31 (MSB)
* p = 0: v[n] = 0
* p = 1: v[n] = 1
* p = -1: v[n] = toggled
* p = 2: v[n] set? (0/1)
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BIT
::
CK3&Dispatch
#00111
::                              ( v n p )
  %1 %+ COERCE                  ( v n #p' --- p mapped to 0/1/2/3 )
  UNROT                         ( #p v n )
  COERCE                        ( #p v #n )
  BINT31 #MIN                   ( #p v #n --- force n = 0..31 )
  BINT31 SWAP#- #1+             ( #p v #n --- 32..1 )
  UNROT                         ( #n #p v )
  _D32                          ( n p s --- make v a binary string )
  UNROT                         ( s n p )
  ::
    BINT0 #=casedrop
      ::                        ( s n --- toggle )
        2DUP                    ( s n s n )
        SUB$1#                  ( #s[n] --- charcode )
        BINT48 #=ITE            ( --- 0 oder nicht )
          BINT49                ( s n --- s[n] = 0 -> 1 )
          BINT48                ( s n --- s[n] = 1 -> 0 )
        _SWC %2 _FMBASE
      ;
    BINT1 #=casedrop
      ::                        ( s n --- clr )
        BINT48 _SWC
        %2 _FMBASE
      ;
    BINT2 #=casedrop
      ::                        ( s n --- set )
        BINT49 _SWC
        %2 _FMBASE
      ;
    BINT3 #=casedrop
      ::                        ( s n --- state )
        SUB$1#                  ( #s[n] --- charcode )
        BINT48 #=ITE %0 %1      ( --- 0 oder nicht )
      ;
    SETSIZEERR                  ( --- bad arg value )
  ;
;
;

***************************************************************************
* bit count
* v p -> k
* p = 0: LSB state (0/1)
*     1: number of bits set
*     2: MSB index (0..31)
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BCNT
::
CK2&Dispatch
#00011
::                              ( v p )
  COERCE                        ( v #p )
  SWAP _D32 SWAP                ( s p )
  ::
    BINT0 #=casedrop
      ::                        ( s --- LSB? )
        BINT32 SUB$1#
        BINT48 #=ITE %0 %1
      ;
    BINT1 #=casedrop
      ::                        ( s --- num bits set )
        BINT0                   ( s k --- count initialized )
        BINT32
        #1+_ONE_DO (DO)         ( s k )
          OVERINDEX@            ( s k s i )
          SUB$1#                ( s k s[i] )
          BINT48 #=?SKIP #1+    ( s k' )
        LOOP                    ( s k' )
        SWAPDROP                ( k' )
        UNCOERCE                ( %k )
      ;
    BINT2 #=casedrop
      ::                        ( s --- MSB index )
        BINT0                   ( s 0 --- no bit set value )
        BINT32
        #1+_ONE_DO (DO)         ( s 0 )
          OVERINDEX@            ( s 0 s i )
          SUB$1#                ( s 0 s[i] )
          BINT48 #<> IT         ( s 0 s[i]<>0? )
          ::                    ( s 0 --- yes )
            INDEX@              ( s 0 i )
            ZEROISTOPSTO        ( s 0 i --- exit loop at next LOOP )
          ;
        LOOP                    ( s 0 | s 0 i )
        DUP#0=ITE
          ::                    ( s 0 )
            2DROP
            %-1                 ( -1 )
          ;
          ::                    ( s 0 i )
            UNROT 2DROP         ( i )
            BINT32 SWAP#-       ( k --- k = 32-i = 31..0 )
            UNCOERCE                ( %k )
          ;
      ;
    SETSIZEERR                  ( --- bad arg value )
  ;
;
;

***************************************************************************
* shift ops on single real
* %v %n %p ->
*
* n =  1 ..  32: shift left
* n = -1 .. -32: shift right
*
* p =  0: pull in 0 (logic shift )
* p =  1: pull in 1 (fill with ones)
* p =  2: pull in shifted-out bit (rotate)
* p = -1: pull in LSB (shift left) or MSB (shift right) (arithmetic shift)
*
* n = 0, p  = 0 : BNOT, invert all bits
*        p <> 0: mirror 32bit
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BSL
::
CK3&Dispatch
#00111
::                              ( v n p )
  %1 %+ COERCE                  ( v n #p' --- p mapped to 0/1/2/3 )
  ROT                           ( n p v )
  _D32                          ( n p s )
  ROT                           ( p s n )
  DUP %0>= ITE
    ::                          ( p s n --- n >= 0 )
      COERCE                    ( p s n )
      BINT32 #MIN               ( p s n --- prevent excessive calc time )
      DUP #0=ITE
        ::                      ( p s n --- n = 0 )
          DROPSWAP              ( s p )
          ONE #=ITE
          ::                    ( s --- p = 0: BNOT )
            BINT32              ( s --- loop thru all chars )
            #1+_ONE_DO (DO)     ( s )
              DUPINDEX@         ( s s i )
              SUB$1#            ( s s[i] )
              BINT48 #=ITE
                BINT49 BINT48   ( s 1/0 )
              INDEX@ SWAP       ( s i 1/0 )
              _SWC              ( s' )
            LOOP                ( s' )
          ;
          ::                    ( s --- reverse/mirror )
            NULL$               ( s t --- init reversal )
            BINT32
            #1+_ONE_DO (DO)     ( s t --- loop thru all chars )
              OVERINDEX@        ( s t s i )
              SUB$1#            ( s t s[i] )
              #>CHR >H$         ( s t' )
            LOOP                ( s t' )
            SWAPDROP            ( t' --- reversed )
          ;
        ;
        ::                      ( p s n --- n > 0 )
          TRUE 4UNROLL          ( T p s n --- shift n left according to p )
          #1+_ONE_DO (DO)       ( T p s )
            _BSHF               ( T p s' )
          LOOP                  ( T p s' )
          UNROT 2DROP           ( s' )
        ;
    ;
    ::                          ( p s n --- n < 0 )
      %ABSCOERCE                ( p s abs{n} )
      BINT32 #MIN               ( p s n --- prevent excessive calc time )
      FALSE 4UNROLL             ( F p s n --- shift n right according to p )
      #1+_ONE_DO (DO)           ( F p s )
        _BSHF                   ( F p s' )
      LOOP                      ( F p s' )
      UNROT 2DROP               ( s' )
    ;
  %2 _FMBASE                    ( d --- back to decimal )
;
;

***************************************************************************
* bit logic ops on two reals
* %a %b %p ->
* p = 0: AND
* p = 1: OR
* p = -1: XOR
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME BOP
::
CK3&Dispatch
#00111
::                              ( a b p )
  %1 %+ COERCE                  ( a b p --- p mapped to 0/1/2 )
  UNROT                         ( p a b )
  _D32                          ( p a b )
  UNROT                         ( b p a )
  _D32                          ( b p a )
  UNROT                         ( a b p --- a,b string[32], #p )
  ::                            ( a b p )
    BINT0 #=casedrop
      ::                        ( a b --- XOR )
        BINT32                  ( --- loop thru all chars )
        #1+_ONE_DO (DO)         ( a b )
          DUPINDEX@             ( a b b i )
          SUB$1#                ( a b b[i] )
          3PICK                 ( a b b[i] a )
          INDEX@                ( a b b[i] a i )
          SUB$1#                ( a b b[i] a[i] )
          #=ITE
            BINT48 BINT49
          INDEX@ SWAP           ( a b 0/1 i )
          _SWC                  ( a b' )
        LOOP                    ( a b' )
      ;
    BINT1 #=casedrop
      ::                        ( s n --- AND )
        BINT32                  ( --- loop thru all chars )
        #1+_ONE_DO (DO)         ( a b )
          DUPINDEX@             ( a b b i )
          SUB$1#                ( a b b[i] )
          3PICK                 ( a b b[i] a )
          INDEX@                ( a b b[i] a i )
          SUB$1#                ( a b b[i] a[i] )
          BINT49 #=
          SWAP
          BINT49 #=
          ANDITE
            BINT49 BINT48
          INDEX@ SWAP           ( a b 0/1 i )
          _SWC                  ( a b' )
        LOOP                    ( a b' )
      ;
    BINT2 #=casedrop
      ::                        ( s n --- OR )
        BINT32                  ( --- loop thru all chars )
        #1+_ONE_DO (DO)         ( a b )
          DUPINDEX@             ( a b b i )
          SUB$1#                ( a b b[i] )
          3PICK                 ( a b b[i] a )
          INDEX@                ( a b b[i] a i )
          SUB$1#                ( a b b[i] a[i] )
          BINT49 #=
          SWAP
          BINT49 #=
          OR ITE
            BINT49 BINT48
          INDEX@ SWAP           ( a b 0/1 i )
          _SWC                  ( a b' )
        LOOP                    ( a b' )
      ;
    SETSIZEERR                  ( --- bad arg value )
  ;                             ( a b' )
  SWAPDROP                      ( b' )
  %2 _FMBASE                    ( dez )
;
;

***************************************************************************
* ZEL
* Z -> {Rs Ls} | {Rs Cs}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME ZEL
::
CK2&Dispatch
#00012                          ( f z --- complex number )
::
  C%>%                          ( f re im )
  DUP %0>= ITE
  ::                            ( f r im --- im>0 )
    ROT                         ( r im f )
    _OM                         ( r im w )
    %/                          ( r l )
    $ "Ls"                      ( r l tag )
  ;
  ::                            ( f r im --- im<0 )
    %ABS                        ( f r im )
    ROT                         ( r im f )
    _OM                         ( r im w )
    %* _RCP                     ( r c )
    $ "Cs"                      ( r c tag )
  ;
  SWAP                          ( r tag x )
  ROT                           ( tag x r )
  $ "Rs" SWAP                   ( tag x tag r )
  2SWAP                         ( tag r tag x )
  FOUR {}N                      ( {tag r tag x} )
;
;

***************************************************************************
* YEL
* Y -> {Rp Lp} | {Rp Cp}
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME YEL
::
CK2&Dispatch
#00012                          ( f y --- complex number )
::
  C%>%                          ( f re im )
  DUP %0>= ITE
  ::                            ( f g im --- im>0 )
    ROT                         ( g im f )
    _OM                         ( g im w )
    %/                          ( g c )
    $ "Cp"                      ( g c tag )
  ;
  ::                            ( f g im --- im<0 )
    %ABS                        ( f g im )
    ROT                         ( g im f )
    _OM                         ( g im w )
    %* _RCP                     ( g l )
    $ "Lp"                      ( g l tag )
  ;
  SWAP                          ( g tag b )
  ROT _RCP                      ( tag b r --- r=1/g )
  $ "Rp" SWAP                   ( tag b tag r )
  2SWAP                         ( tag r tag b )
  FOUR {}N                      ( {tag r tag b} )
;
;

***************************************************************************
* RLZ
* f Rs Ls -> z
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME RLZ
::
CK3&Dispatch
#00111                          ( f r l )
::
  ROT                           ( r l f )
  _OM                           ( r l w )
  %*                            ( r x )
  %>C%                          ( z )
;
;

***************************************************************************
* RLY
* f Rp Lp -> y
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME RLY
::
CK3&Dispatch
#00111                          ( f r l )
::
  ROT                           ( r l f )
  _OM                           ( r l w )
  %*                            ( r x )
  _RCP %CHS                     ( r b )
  SWAP _RCP SWAP                ( g b )
  %>C%                          ( y )
;
;

***************************************************************************
* RCZ
* f Rs Cs -> z
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME RCZ
::
CK3&Dispatch
#00111                          ( f r c )
::
  ROT                           ( r c f )
  _OM                           ( r c w )
  %*                            ( r b )
  _RCP %CHS                     ( r x )
  %>C%                          ( z )
;
;

***************************************************************************
* RCY
* f Rp Cp -> y
***************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME RCY
::
CK3&Dispatch
#00111                          ( f r c )
::
  ROT                           ( r c f )
  _OM                           ( r c w )
  %*                            ( r b )
  SWAP _RCP SWAP                ( g b )
  %>C%                          ( y )
;
;

*****************************************************************************
* Discrete Fourier Transform
* [..] dir -> [..]
* dir >= 0: DFT, else inverse DFT
* [..] real or complex, any dimension; result is always complex
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DFT
::
CK2&Dispatch
#00041                          ( matrix real )
::                              ( f dir )
  %0>=                          ( f d --- d true: DFT, else IDFT )
  OVER ARSIZE DUPONE {}N        ( f d n {n} )
  %0 DUP %>C% MAKEARRY          ( f d n F --- result matrix initialized )
  4UNROLL                       ( F f d n )
  DUP                           ( F f d n n )
  %2 %PI %*                     ( F f d n n 2pi )
  OVER UNCOERCE %/              ( F f d n n 2pi/n -- precalced expon factor )
  SWAP                          ( F f d n p n )
*------- loops --------
  #1+_ONE_DO (DO)               ( F f d n p --- loop over F{i}, i=1..n )
*
    INDEX@ UNCOERCE
    DO>STR DISPROW1             ( --- progress indicator )
    _CHKUSR IT ZEROISTOPSTO     ( --- user wants to exit )
*
    %0 DUP %>C%                 ( F f d n p 0 --- sum initialized )
    3PICK                       ( F f d n p s n )
    #1+_ONE_DO (DO)             ( F f d n p s --- loop over f{j}, j=1..n )
      OVER                      ( F f d n p s p --- exponent initialized  )
      INDEX@ #1-                ( F f d n p s p i-1 )
      JINDEX@ #1-               ( F f d n p s p i-1 j-1 )
      #* UNCOERCE %*            ( F f d n p s pij )
      5PICK                     ( F f d n p s pij d )
      IT %CHS                   ( F f d n p s pij' --- imag negated for DFT )
      %0 SWAP %>C%              ( F f d n p s expon --- cplx exponent )
      xEXP                      ( F f d n p s exp --- cplx exponentiation )
      INDEX@                    ( F f d n p s exp j --- INDEX@ is current loop index )
      7PICK GETATELN DROP       ( F f d n p s exp f{j} )
      ROMPTR 002 00D            ( F f d n p s f{j}*exp --- x* )
      x+                        ( F f d n p s' --- x+ )
    LOOP                        ( F f d n p s )
    6ROLL                       ( f d n p s F )
    SWAP                        ( f d n p F s )
    5PICK                       ( f d n p F s d )
    ?SKIP                       ( --- divide by N for IDFT )
    ::                          ( f d n p F s )
      4PICK UNCOERCE            ( f d n p F s n )
      x/                        ( f d n p F s/n --- x/ )
    ;
    INDEX@                      ( f d n p F s i )
    PUTEL                       ( f d n p F' )
    5UNROLL                     ( F' f d n p )
  LOOP                          ( F f d n p )
  4DROP                         ( F )
;
;

*****************************************************************************
* 1st order Differential EQuation system numerical solver
* n x0 x1 dx [y0] -> [[]], cols are y step results
* Pn: {x [y]} -> [y']
* uses 4th order Runge-Kutta single step procedure (Herrmann p. 115)
* with fixed stepsize
* continually displays x in row 1
* dot key terminates
*
* Notes:
* see PR
* A..Z are saved and restored, but not between Pn invocations
* and not if error
*
* Ex.: Solve y'=x+y in x=0..1, y(0) = 0
* Sol: P99: Ans\>L1:L1(2)\>M1:[L1(1)+M1(1)]\>Ans
*      DEQ(99,0,1,.1,[0])\>M2 yields an end value of y(1)=0.718279...
*      correct is 0.718281.., from y(x) = exp(x)-x-1
*      => with 0.1 steps here accurate to 0.00001
*
* Ex.: Solve y''=2y'^2y^3 in x=0..1,y(0)=1,y'(0)=-1
* Sol: P88: Ans\>L1:L1(2)\>M1:[M1(2),2*(M1(2)^2/M1(1)-M1(1)^2)]\>Ans
*      Subst y1' = y2, y2'=2y2^2/y1-2y1^2
*      DEQ(88,0,1,.1,[1,-1])\>M2 yields end values [0.333,-0.333]
*      correct is y(x)=1/(x^2+x+1) => precise soln.
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME DEQ
::
CK5&Dispatch
#11114                          ( n x0 x1 dx [y0] )
::
  DUP TYPERARRY?                ( --- Y0 must be real )
  ?SKIP SETTYPEERR
*
  _AZL                          ( n x0 x1 dx Y0 {A..Z} )
  1LAMBIND                      ( n x0 x1 dx Y0 --- A..Z in LAM1 )
*
  DUP ARSIZE                    ( n x0 x1 dx Y0 m )
  6UNROLL                       ( m n x0 x1 dx Y0 )
  5ROLL                         ( m x0 x1 dx Y0 n )
  _PNAME                        ( m x0 x1 dx Y0 "Pn" )
  ' StoAns@Drp                  ( m x0 x1 dx Y0 "Pn" 'Sto --- put args in Ans )
  SWAP                          ( m x0 x1 dx Y0 'Sto "Pn" )
  TWO ::N                       ( m x0 x1 dx Y0 :: Sto "Pn" ; )
  '
  ::
    ROMPTR 701 029              ( --- ~xxRUNPGM )
    xAns                        ( ans --- return result )
    DUP TYPERARRY?
    ?SKIP SETTYPEERR            ( --- output array is real )
  ;
*                               ( m x0 x1 dx Y0 :: Sto "Pn" ; 'Pgm )
  &COMP                         ( m x0 x1 dx Y0 :: Sto "Pn" Pgm ; )
  5UNROLL                       ( m :: Sto "Pn" Pgm ; x0 x1 dx Y0 )
* array loop                    ( m p x0 x1 dx Y0 )
  SWAP                          ( m p x0 x1 Y0 dx )
  4UNROLL                       ( m p dx x0 x1 Y0 )
  SWAP                          ( m p dx x0 Y0 x1 )
  3PICK                         ( m p dx x0 Y0 x1 x0 )
  %-                            ( m p dx x0 Y0 x1-x0 )
  4PICK                         ( m p dx x0 Y0 x1-x0 dx )
  %/ COERCE                     ( m p dx x0 Y0 n )
  OVERSWAP                      ( m p dx x0 Y0 YR n --- result matrix init )
  DUP#0=ITE
  ::                            ( m p dx x0 Y0 YR n --- no RK-step )
    DROP 6UNROLL 5DROP          ( [] )
  ;
  ::                            ( m p dx x0 Y0 YR n --- at least one RK-step )
  #1+_ONE_DO (DO)               ( m p dx x0 Y0 YR )
    3PICK                       ( m p dx x0 Y0 YR x0 )
*
    DUP DO>STR DISPROW1         ( --- show current x as progress indicator )
    _CHKUSR IT ZEROISTOPSTO     ( --- . key exits )
*
    3PICK                       ( m p dx x0 Y0 YR x0 Y0 )
    TWO {}N                     ( m p dx x0 Y0 YR {x Y0} )
    6PICK                       ( m p dx x0 Y0 YR {x Y0} p )
    EVAL                        ( m p dx x0 Y0 YR dYdX )
    5PICK                       ( m p dx x0 Y0 YR dYdX dx )
    ROMPTR 002 00D              ( m p dx x0 Y0 YR K1 --- x*, Runge-Kutta )
*
    4PICK                       ( m p dx x0 Y0 YR K1 x0 )
    6PICK %2 %/ %+              ( m p dx x0 Y0 YR K1 x0+dx/2 )
    OVER %2 x/                  ( m p dx x0 Y0 YR K1 x0+dx/2 K1/2 )
    5PICK x+                    ( m p dx x0 Y0 YR K1 x0+dx/2 Y0+K1/2 )
    TWO {}N                     ( m p dx x0 Y0 YR K1 {} )
    7PICK                       ( m p dx x0 Y0 YR K1 {} p )
    EVAL                        ( m p dx x0 Y0 YR K1 dYdx )
    6PICK                       ( m p dx x0 Y0 YR K1 dYdx dx )
    ROMPTR 002 00D              ( m p dx x0 Y0 YR K1 K2 )
*
    5PICK                       ( m p dx x0 Y0 YR K1 K2 x0 )
    7PICK %2 %/ %+              ( m p dx x0 Y0 YR K1 K2 x0+dx/2 )
    OVER %2 x/                  ( m p dx x0 Y0 YR K1 K2 x0+dx/2 K2/2 )
    6PICK x+                    ( m p dx x0 Y0 YR K1 K2 x0+dx/2 Y0+K2/2 )
    TWO {}N                     ( m p dx x0 Y0 YR K1 K2 {} )
    8PICK                       ( m p dx x0 Y0 YR K1 K2 {} p )
    EVAL                        ( m p dx x0 Y0 YR K1 K2 dydx )
    7PICK
    ROMPTR 002 00D              ( m p dx x0 Y0 YR K1 K2 K3 )
*
    6PICK                       ( m p dx x0 Y0 YR K1 K2 K3 x0 )
    8PICK %+                    ( m p dx x0 Y0 YR K1 K2 K3 x0+dx )
    OVER                        ( m p dx x0 Y0 YR K1 K2 K3 x0+dx/2 K3 )
    7PICK x+                    ( m p dx x0 Y0 YR K1 K2 K3 x0+dx/2 Y0+K3 )
    TWO {}N                     ( m p dx x0 Y0 YR K1 K2 K3 {} )
    9PICK                       ( m p dx x0 Y0 YR K1 K2 K3 {} p )
    EVAL                        ( m p dx x0 Y0 YR K1 K2 K3 dydx )
    8PICK
    ROMPTR 002 00D              ( m p dx x0 Y0 YR K1 K2 K3 K4 )
*
    UNROT                       ( m p dx x0 Y0 YR K1 K4 K2 K3 )
    x+ %2
    ROMPTR 002 00D              ( m p dx x0 Y0 YR K1 K4 2{K2+K3} )
    x+ x+                       ( m p dx x0 Y0 YR K1+2{K2+K3}+K4 )
    %6 x/                       ( m p dx x0 Y0 YR K/6 )
    ROT x+                      ( m p dx x0 YR Y0+K/6 )
    SWAP OVER                   ( m p dx x0 Y0' YR Y0' )
    _VAPP                       ( m p dx x0 Y0' YR' )
    ROT                         ( m p dx Y0' YR' x0 )
    4PICK                       ( m p dx Y0' YR' x0 dx )
    %+                          ( m p dx Y0' YR' x0' )
    UNROT                       ( m p dx x0' Y0' YR' )
  LOOP                          ( m p dx x0' Y0' YR' )
  5UNROLL                       ( m YR' p dx x0' Y0' )
  4DROP                         ( m YR' )
  OVER #1= ITE
    SWAPDROP                    ( [] --- single deq )
    ::
  DUP ARSIZE                    ( m YR n )
  3PICK #/ SWAPDROP             ( m YR n/m )
  ROT TWO {}N                   ( YR {n/m m} )
  MATREDIM                      ( YR --- one col per y )
    ;
  ;
*
  1GETABND                      ( YR {A..Z} --- LAM1 deleted )
  _LAZ                          ( YR --- A..Z restored )
;
;

*****************************************************************************
* Hooke-Jeves multidimensional nonlinear optimization
* n h0 hmin maxit [x0] -> {flag f [xmin]} so far, possibly error msg
* Pn: [x] -> y
* [] 1D-vectors
* minimizes y, starting at [x0] with stepwidth h0,
* until either result change or stepwidth below acc
* early termination at maxit iterations,
* flag = 1 for normal termination (incl. no change)
* flag = 0 for maxit exceeded or user interrupt
* A..Z local, but not between invocations or if error
* continually displays f([x]) in row 1
* dot key terminates
*
* if convergence checks were included:
* ... until either result change or stepwidth below acc
* ... or if no change in y(x) after 16 successive iterations
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL

DEFINE RCL_d   15GETLAM
DEFINE STO_d   15PUTLAM
DEFINE RCL_acc 14GETLAM
DEFINE STO_acc 14PUTLAM
DEFINE RCL_f   13GETLAM
DEFINE STO_f   13PUTLAM
DEFINE RCL_max 12GETLAM
DEFINE STO_max 12PUTLAM
DEFINE RCL_k   11GETLAM
DEFINE STO_k   11PUTLAM
DEFINE RCL_h   10GETLAM        
DEFINE STO_h   10PUTLAM        
DEFINE RCL_fx   9GETLAM        
DEFINE STO_fx   9PUTLAM        
DEFINE RCL_ff   8GETLAM        
DEFINE STO_ff   8PUTLAM        
DEFINE RCL_lf   7GETLAM        
DEFINE STO_lf   7PUTLAM        
DEFINE RCL_ex   6GETLAM        
DEFINE STO_ex   6PUTLAM        
DEFINE RCL_mcnt 5GETLAM
DEFINE STO_mcnt 5PUTLAM
DEFINE RCL_scnt 4GETLAM
DEFINE STO_scnt 4PUTLAM
DEFINE RCL_stop 3GETLAM
DEFINE STO_stop 3PUTLAM
DEFINE RCL_ok   2GETLAM
DEFINE STO_ok   2PUTLAM
DEFINE RCL_AZ   1GETLAM
DEFINE STO_AZ   1PUTLAM

xNAME NLOP
::
CK5&Dispatch
#11114                          ( n h0 acc maxit [x0] )
::
  DUP TYPERARRY?                ( --- [x0] must be real )
  ?SKIP SETTYPEERR
*
  DUP ARSIZE                    ( n h0 acc maxit XA d --- dimension of problem )
  6UNROLL                       ( d n h0 acc maxit XA )
  6UNROLL                       ( XA d n h0 acc maxit )
  4ROLL                         ( XA d h0 acc maxit n )
  _PNAME                        ( XA d h0 acc maxit "Pn" )
  ' StoAns@Drp                  ( XA d h0 acc maxit "Pn" 'Sto --- put args in Ans )
  SWAP                          ( XA d h0 acc maxit 'Sto "Pn" )
  TWO ::N                       ( XA d h0 acc maxit ::'Sto "Pn"; )
  '
  ::
    ROMPTR 701 029              ( --- ~xxRUNPGM )
    xAns                        ( ans --- return result )
    DUPTYPEREAL?                ( --- output must be single real f{XA} )
    ?SKIP SETTYPEERR
  ;
*                               ( XA d h0 acc maxit ::'Sto "Pn"; 'Pgm )
  &COMP                         ( XA d h0 acc maxit ::'Sto "Pn" Pgm; )
  SWAP                          ( XA d h0 acc f maxit )
  COERCE                        ( XA d h0 acc f #maxit )
  BINT1 #MAX                    ( XA d h0 acc f #maxit --- force maxit >= 1 )
  %.5                           ( XA d h0 acc f #maxit k )
  5ROLL                         ( XA d acc f #maxit k h0 )
  %0 DUPDUP                     ( XA d acc f #maxit k h0 fx ff lastf )
  '                             ( ... --- local embedded routine )
  ::                            ( XA -> XA' --- procedure explore )
    RCL_d                       ( XA n1 )
    #1+_ONE_DO (DO)             ( XA )
      INDEX@ OVER GETATELN DROP ( XA XA[i] )
      SWAP                      ( XA[i] XA )
      OVER %0<> ITE
      ::                        ( XA[i] XA --- XA[i] <> 0 )
        OVER %1 RCL_h %+ %*     ( XA[i] XA XA[i]' )
        INDEX@ PUTEL            ( XA[i] XA' )
*
        DUP RCL_f EVAL          ( XA[i] XA' fy )
        DUP RCL_ff %< ITE
        STO_ff                  ( XA[i] XA' --- fy < ff, fwd success )
        ::                      ( XA[i] XA' fy )
          DROP                  ( XA[i] XA' )
          OVER %1 RCL_h %- %*   ( XA[i] XA' XA[i]' --- bwd )
          INDEX@ PUTEL          ( XA[i] XA'' )
*
          DUP RCL_f EVAL        ( XA[i] XA' fy )
          DUP RCL_ff %< ITE
          STO_ff                ( XA[i] XA' --- fy < ff, bwd success )
          ::                    ( XA[i] XA' fy )
            DROP                ( XA[i] XA' )
            OVERINDEX@ PUTEL    ( XA[i] XA --- original restored, no change )
          ;
        ;
      ;
      ::                        ( XA XA[i] --- XA[i]=0, stuck in zero )
        OVER RCL_h %+           ( XA[i] XA XA[i]' )
        INDEX@ PUTEL            ( XA[i] XA' )
*
        DUP RCL_f EVAL          ( XA[i] XA' fy )
        DUP RCL_ff %< ITE
        STO_ff                  ( XA[i] XA' --- fy < ff, fwd success )
        ::                      ( XA[i] XA' fy )
          DROP                  ( XA[i] XA' )
          OVER RCL_h %-         ( XA[i] XA' XA[i]' --- bwd )
          INDEX@ PUTEL          ( XA[i] XA'' )
*
          DUP RCL_f EVAL        ( XA[i] XA' fy )
          DUP RCL_ff %< ITE
          STO_ff                ( XA[i] XA' --- fy < ff, bwd success )
          ::                    ( XA[i] XA' fy )
            DROP                ( XA[i] XA' )
            OVERINDEX@ PUTEL    ( XA[i] XA --- original restored, no change )
          ;
        ;
      ;
*                               ( XA[i] XA' )
      SWAPDROP                  ( XA' )
    LOOP                        ( XA' )
    RCL_ff DO>STR DISPROW1      ( XA' --- tell user about progress )
    _CHKUSR STO_stop            ( --- user wants to terminate )
  ;
  ZEROZERO FalseFalse           ( XA d acc f #maxit k h0 fx ff lastf ex mcnt scnt stop ok )
  _AZL                          ( XA d acc f #maxit k h0 fx ff lastf ex mcnt scnt stop ok {A..Z} )
*                                    1 2   3 4      5 6  7  8  9     10 11   12   13   14 15
  {
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
  }
  BIND                          ( XA --- locals created )
*
* main program
*
  DUP RCL_f EVAL DUP            ( XA f{XA} f{XA} )
  STO_fx STO_lf                 ( XA --- fx and lastf initialized )
  DUP                           ( X XA --- X initialized )
* 
* main loop
*
  BEGIN                         ( X XA )
    RCL_fx STO_ff               ( X XA )
    DROPDUP                     ( X XA --- XA := X )
    RCL_ex EVAL                 ( X XA' )
    RCL_ff RCL_fx %< ITE
    ::                          ( X XA' --- ff < fx )
      BEGIN                     ( X XA )
        OVER                    ( X XA Z ---  Z := X )
        UNROT                   ( Z X XA )
        SWAPDROPDUP             ( Z X XA --- X := XA )
        %2
        ROMPTR 002 00D          ( Z X 2XA --- x* )
        ROT x-                  ( X XA --- XA := 2XA-Z )
        RCL_ff STO_fx           ( X XA )
        DUP RCL_f EVAL          ( X XA f )
        STO_ff                  ( X XA )
        RCL_ex EVAL             ( X XA' )
*
* max iterations check
*
        RCL_mcnt #1+            ( X XA' maxitcnt+1 )
        DUP STO_mcnt            ( X XA' maxitcnt+1 )
        RCL_max #>ITE
        ::                      ( X XA' --- maxit exceeded )
          TRUE STO_stop         ( X XA' --- force termination )
        ;
        ::                      ( X XA' --- still within maxit )
*
* convergence etc checks --- could as well be (and are) left out
*

*          RCL_ff RCL_lf
*          %= ITE
*          ::                    ( X XA' --- no change )
*            RCL_scnt #1+
*            DUP STO_scnt        ( X XA' scnt --- 'same' counter incremented )
*            BINT16 #> IT        ( --- arbitrary choice: 16 times same causes termination )
*            ::                  ( X XA' scnt --- seems stuck/constant, exit )
*              TRUE STO_stop
*            ;
*          ;
*          ::                    ( X XA --- there was a change )
*            BINT0 STO_scnt      ( X XA --- reset 'same' counter )
*          ;
*          RCL_stop ?SKIP        ( X XA' --- still searching? )
*          ::                    ( X XA' --- yes, still searching )
*            RCL_ff RCL_lf
*            %- %ABS             ( X XA' abs{ff-lastf} )
*            RCL_acc %< ITE
*            ::                  ( X XA' --- found min with desired accuracy )
*              TrueTrue          ( X XA' --- converged, we are done )
*              STO_stop
*              STO_ok
*            ;
*            ::                  ( X XA' --- min not yet found )
*              RCL_ff STO_lf     ( --- TBD: causes premature termination? )
*            ;
*          ;

*
* end of convergence checks
*
        ;
*
* end of max iterations checks
*
        RCL_ff DO>STR DISPROW1  ( X XA' --- tell user about progress )
        _CHKUSR                 ( X XA' key? --- user wants to terminate? )
        RCL_stop                ( X XA' key? stop? --- algorithm wants to terminate? )
        RCL_ff RCL_fx %>=       ( X XA' key? stop? nextit? )
        OR OR
      UNTIL                     ( X XA )
    ;
    ::                          ( X XA' --- ff >= fx )
      RCL_h RCL_acc %> ITE
      ::
        RCL_h RCL_k %* STO_h    ( --- contraction )
      ;
      ::
        TrueTrue                ( --- reached min with desired accuracy )
        STO_stop
        STO_ok
      ;
    ;
    _CHKUSR                     ( --- user wants to terminate? )
    RCL_stop                    ( --- algorithm wants to terminate? )
    OR                          ( --- someone wants to terminate? )
  UNTIL                         ( X XA )
*
  SWAPDROP                      ( XA )
  RCL_ok ITE %1 %0              ( XA 0/1 --- tell user about normal/abnormal termination )
  RCL_ff                        ( XA 0/1 fmin )
  ROT                           ( 0/1 fmin XA )
  THREE {}N                     ( {0/1 fmin XA} )
  RCL_AZ                        ( {0/1 fmin XA} {A..Z} )
  ABND                          ( {0/1 fmin XA} {A..Z} --- locals deleted )
  _LAZ                          ( {0/1 fmin XA} --- A..Z restored )
;
;

*****************************************************************************
* clock
* use calc as watch
* ON..ON.. turns on and off, showing date and time
* any other key exits the loop
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME UHR
::
  CK0
  FORTYONE SetSysFlag           ( --- EU clock format )
  FORTYTWO SetSysFlag           ( --- EU date format )
  RECLAIMDISP                   ( --- get and clear text grob )
  TURNMENUOFF                   ( --- remove menu keys )
  BEGIN
    TurnOff
    ROMPTR 004 01B              ( d --- xDATE)
    ROMPTR 004 01A              ( d t --- xTIME )
    ROMPTR 004 020              ( $dt --- xTSTR )
    DUP                         ( dt dt )
    DISPROW2                    ( dt )
    $ " ON=Off"
    DISPROW6
    WaitForKey                  ( dt #c #p )
    DROP                        ( dt #c )
    kcOn #=ITE                  ( --- any key but ON exits the loop )
    DROPFALSE
    TRUE
  UNTIL                         ( dt --- return this string )
  FORTYONE ClrSysFlag           ( --- OS expects flag clear )
  FORTYTWO ClrSysFlag           ( --- OS expects flag clear )
;

*****************************************************************************
* read/set keytime
* new_keytime -> old_keytime
* unit [122us]
* 0 sets default 1365 = 166.6ms
* default 1365
* ms: default 166.6, better 75, allowed 0..400
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME KEYTIME
::
CK1&Dispatch
#00001                          ( new )
::
                                ( new )
* read old keytime
CODE
        GOSBVL  =$jSAVPTR
        D0=(5)  #86051
        A=DAT0  A
        GOSBVL  =$jPUSH#ALOOP
ENDCODE
  UNCOERCE                      ( new old )
  SWAP COERCE                   ( old new )
* write new keytime
CODE
        GOSBVL  =$jPOP#
        ?A#0    A
        GOYES   kt2
        LA(5)   #00555          ( default 1365d = 555h )
kt2     LC(5)   #01000          ( max value, damn slow )
        ?C>A    A
        GOYES   kt1
        A=C     A
kt1     CD0EX
        D0=(5)  #86051
        DAT0=A  A
        CD0EX
        A=DAT0  A
        D0=D0+  5
        PC=(A)
ENDCODE
*                               ( old )
;
;

*****************************************************************************
* HW low battery flags
* -> 0..3, bit0 = VLBI, bit1=LB0
*****************************************************************************
ASSEMBLE
        CON(3)  0
RPL
xNAME LOBAT
::
  CK0                           ( --- no args )

*CODE
*        GOSBVL  =$jSAVPTR
*        D0=(5)  #0010B
*        A=DAT0  B
*        LC(5)   #00008          ( get MSB of LS nibble = alarm bit )
*        A=A&C   A
*        GOSBVL  =$jPUSH#ALOOP
*ENDCODE

CODE
        GOSBVL  =$jSAVPTR
        D0=(5)  #00108          ( nibble: LB2 LB1 LB0 VLBI )
        A=DAT0  B
        LC(5)   #00003          ( get LB0 and VLBI )
        A=A&C   A
        GOSBVL  =$jPUSH#ALOOP
ENDCODE
  UNCOERCE                      ( 0..3 )
;

*****************************************************************************
* Auxiliary Routines
*****************************************************************************
*****************************************************************************
* Brent root finder
* pgm xlo xhi xguess -> x0
* pgm: x -> f(x)
* strictly stack based
* algo: numrep 285
*****************************************************************************
RPL

*DEFINE eps % 3E-10
*DEFINE tol %0

DEFINE RCLf    22GETLAM
DEFINE STOf    22PUTLAM
DEFINE RCLx1   21GETLAM
DEFINE STOx1   21PUTLAM
DEFINE RCLx2   20GETLAM
DEFINE STOx2   20PUTLAM
DEFINE RCLxx   19GETLAM
DEFINE STOxx   19PUTLAM

DEFINE RCLa    18GETLAM
DEFINE STOa    18PUTLAM
DEFINE RCLb    17GETLAM
DEFINE STOb    17PUTLAM
DEFINE RCLc    16GETLAM
DEFINE STOc    16PUTLAM
DEFINE RCLd    15GETLAM
DEFINE STOd    15PUTLAM
DEFINE RCLe    14GETLAM
DEFINE STOe    14PUTLAM
DEFINE RCLmin1 13GETLAM
DEFINE STOmin1 13PUTLAM
DEFINE RCLmin2 12GETLAM
DEFINE STOmin2 12PUTLAM
DEFINE RCLmin  11GETLAM
DEFINE STOmin  11PUTLAM
DEFINE RCLfa   10GETLAM
DEFINE STOfa   10PUTLAM
DEFINE RCLfb    9GETLAM
DEFINE STOfb    9PUTLAM
DEFINE RCLfc    8GETLAM
DEFINE STOfc    8PUTLAM
DEFINE RCLp     7GETLAM
DEFINE STOp     7PUTLAM
DEFINE RCLq     6GETLAM
DEFINE STOq     6PUTLAM
DEFINE RCLr     5GETLAM
DEFINE STOr     5PUTLAM
DEFINE RCLs     4GETLAM
DEFINE STOs     4PUTLAM
DEFINE RCLtol1  3GETLAM
DEFINE STOtol1  3PUTLAM
DEFINE RCLxm    2GETLAM
DEFINE STOxm    2PUTLAM
DEFINE RCLiter  1GETLAM
DEFINE STOiter  1PUTLAM

NULLNAME _BRENT
::                              ( f x1 x2 xx )
  %0 BINT17 NDUPN DROP          ( ... a .. xm --- initialize local vars )
  BINT200                       ( ... itmax --- now 22 obs on stack )

*  NULLLAM BINT22 NDUPN DOBIND   ( --- create local vars, does not work )
  {
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM  ( this stupid method works )
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
    NULLLAM NULLLAM
  }
  BIND

  RCLx1 DUP STOa RCLf EVAL DUP STOfa   ( fa )
  RCLx2 DUP STOb RCLf EVAL DUP STOfb   ( fa fb )
  %* %0> IT                            ( --- fa*fb > 0 ? )
    ::                          ( no sign reversal in given interval )
      # A01
*      DO#EXIT                   ( --- bad guesses )
      ERROROUT
     ;
  RCLfb STOfc
* main loop begin **************************************************
  BEGIN
    RCLiter #1-                 ( iter-1 )
    DUP#0=IT                    ( iter-1 )
      ::
        # C001
*        DO#EXIT          ( --- unable to find root=too many iterations )
        ERROROUT
      ;
    STOiter                     ( --- below: set iter to zero to force exit )
    RCLfb RCLfc %* %0> IT
      ::
        RCLa STOc
        RCLfa STOfc
        RCLb RCLa %- DUP STOd   ( b-a )
        STOe
      ;
    RCLfc %ABS RCLfb %ABS %< IT
      ::
        RCLb STOa
        RCLc STOb
        RCLa STOc
        RCLfb STOfa
        RCLfc STOfb
        RCLfa STOfc
      ;
    % 6E-10 RCLb %ABS %* STOtol1     ( --- tol=0, 2*eps=6E-10 )
    RCLc RCLb %- %.5 %* DUP STOxm  ( {c-b}/2 )
    %ABS RCLtol1 %<=
    RCLfb %0= OR
*
    RCLb DO>STR DISPROW1        ( --- inform user about progress )
    _CHKUSR OR                  ( --- user wants to exit )
*
    ITE
      ::
        ZERO STOiter            ( --- force exit )
      ;
      ::
        RCLe %ABS RCLtol1 %>=
        RCLfa RCLfb %>
        ANDITE
          ::                    ( --- inverse quadratic interpolation )
            RCLfb RCLfa %/ STOs
            RCLa RCLc %= ITE
              ::
                %2 RCLxm %* RCLs %* STOp
                %1 RCLs %- STOq
              ;
              ::
                RCLfa RCLfc %/ STOq
                RCLfb RCLfc %/ STOr

                %2 RCLxm %* RCLq %*    ( 2*xm*q )
                RCLq RCLr %- %*        ( {2*xm*q}*{q-r} )
                RCLb RCLa %-           ( {2*xm*q}*{q-r} b-a )
                RCLr %1 %- %* %-       ( {2*xm*q}*{q-r}-{b-a}*{r-1})
                RCLs %* STOp           ( --- {{2*xm*q}*{q-r}-{b-a}*{r-1}}*s )

                RCLq %1 %-             ( q-1 )
                RCLr %1 %- %*          ( {q-1}*{r-1} )
                RCLs %1 %- %*          ( {q-1}*{r-1}*{s-1} )
                STOq
              ;
            RCLp DUP %0> IT :: RCLq %CHS STOq ;  ( p )
            %ABS STOp

            %3 RCLxm %* RCLq %*                 ( 3*xm*q )
            RCLtol1 RCLq %* %ABS                ( 3*xm*q abs{tol1*q} )
            %- DUP STOmin1                      ( min1 )
            RCLe RCLq %* %ABS DUP STOmin2       ( min1 min2 )
            %MIN DUP STOmin                     ( min )

            RCLp %2 %* %> ITE                   ( --- min > 2*p ? )
              ::                                ( --- accept interpolation )
                RCLd STOe
                RCLp RCLq %/ STOd
              ;
              ::                                ( --- use bisection )
                RCLxm DUP STOd STOe
              ;
          ;
          ::                    ( --- bisection )
            RCLxm DUP STOd STOe
          ;
        RCLb STOa               ( --- move last best guess ... )
        RCLfb STOfa
        RCLd %ABS RCLtol1 %>
        ITE
          ::
            RCLb RCLd %+ STOb
          ;
          ::
            RCLb RCLtol1 %ABS
            RCLxm %0>= ITE %+ %-
            STOb
          ;
        RCLb RCLf EVAL STOfb
      ;

** for debugging
*        $ "UNTIL" NEWLINE$&$
*        RCLiter UNCOERCE DO>STR NEWLINE$&$ &$
*        DEPTH UNCOERCE DO>STR &$
*        Ck&DoMsgBox

    RCLiter #0=
  UNTIL
* main loop end ****************************************************
  RCLb
  ABND                          ( --- delete local vars )
;

*****************************************************************************
* conversion hex -> decimal
* s -> %
* s expected to contain valid and upcase hex chars
*****************************************************************************
RPL
NULLNAME _HEXDEZ
::
  DUPNULL$?
  ITE
    %0                          ( 0 --- result for empty string )
    ::                          ( s --- nonempty, do the conversion )
      %0 %1                     ( s 0 1 --- initialize sum and factor )
      ROT                       ( sum fac s )
      DUPLEN$                   ( sum fac s lens )
      #1+_ONE_DO (DO)           ( sum fac s )
        DUP DUPLEN$             ( sum fac s s lens )
        #1+                     ( sum fac s s lens+1 )
        INDEX@#-                ( sum fac s s lens-i+1 --- lens,lens-1,... )
        SUB$1#                  ( sum fac s #s[j] )
* 0..9 = 48..57, A..F = 65..70
        FORTYEIGHT #-           ( sum fac s c )
* 0..9 = 0..9, A..F = 17..22
        DUP NINE #>
        IT :: SEVEN #- ;        ( sum fac s 0..15 )
        UNCOERCE                ( sum fac s %0..15 )
        ROT                     ( sum s %c fac )
        DUP % 16 %*             ( sum s %c fac fac' )
        4UNROLL                 ( sum fac' s %c fac )
        %*                      ( sum fac' s %f )
        4ROLL                   ( fac' s %f sum )
        %+                      ( fac' s sum' )
        UNROT                   ( sum' fac' s )
      LOOP                      ( sum fac s )
      2DROP                     ( %sum )
    ;
;

*****************************************************************************
* unique number for each date and time, based on 1.1.1991
* date time -> dtnr [sec]
*****************************************************************************
RPL
NULLNAME _DTNR
::                              ( dd tt )
  %HMS>                         ( dd h )
  % 3600 %*                     ( dd hsec )
  % 1.011991                    ( dd hsec ref)
  ROT                           ( hsec ref dd )
  ROMPTR 004 021                ( hsec ddays --- ddays )
  % 86400 %*                    ( hsec dsec )
  %+                            ( dhsec )
;

*****************************************************************************
* current _DTNR
* -> cdtnr [sec]
*****************************************************************************
RPL
NULLNAME _CDTNR
::
  ROMPTR 004 01B                ( dd )
  ROMPTR 004 01A                ( tt )
  _DTNR                         ( sec )
;

*****************************************************************************
* converse of _DTNR
* dtnr -> date time
*****************************************************************************
RPL
NULLNAME _NRDT
::                              ( s )
  % 86400 2DUP                  ( s 86400 s 86400 )
  %/ %IP                        ( s 86400 dd )
  % 1.011991 OVER               ( s 86400 dd refdate dd )
  ROMPTR 004 022                ( s 86400 dd date --- DATEPLUS )
  4UNROLL                       ( date s 86400 dd )
  %* %-                         ( date dt )
  % 3600 %/                     ( date h )
  %>HMS                         ( date time )
;

***************************************************************************
* check list and k for equation solving routines
* {v1 v2 ...} %k kmax -> v1 v2 ... #k
***************************************************************************
RPL
NULLNAME _LKCHK
::                              ( {vi} %k kmax )
  SWAP                          ( {vi} kmax %k )
  COERCE                        ( {vi} kmax k )
  2DUP #<                       ( {vi} kmax k kmax<k? )
  OVER#0=                       ( {vi} kmax k k>kmax? k=0? )
  OR IT
    SETSIZEERR                  ( bad argument value )
*    ::
*      # 203                     ( bad argument value )
*      DO#EXIT
*    ;
*                               ( {vi} kmax k )
  SWAPROT                       ( k kmax {vi} )
  DUPLENCOMP                    ( k kmax {vi} len )
  ROT #<> IT
    ::
      # 128                     ( wrong argument count )
*      DO#EXIT
      ERROROUT
    ;
*                               ( k {vi} )
  INNERCOMP                     ( k v1 v2 ... vkmax kmax )
  #1+ROLL                       ( v1 v2 ... vkmax k )
;

***************************************************************************
* Kehrwert
* % -> %1/%
***************************************************************************
RPL
NULLNAME _RCP
::
  %1 SWAP %/
;

*****************************************************************************
* New 26.01.2003
*****************************************************************************
***************************************************************************
* binomial probability
* k w z g1 g2 r -> p
* p = probability to draw g1..g2 white balls within z drawings
*     from a cup with k balls, among these w white balls
* r=T means drawn balls _are_ returned into the cup
***************************************************************************
RPL

DEFINE RCLk     6GETLAM
DEFINE STOk     6PUTLAM
DEFINE RCLw     5GETLAM
DEFINE STOw     5PUTLAM
DEFINE RCLz     4GETLAM
DEFINE STOz     4PUTLAM
DEFINE RCLg1    3GETLAM
DEFINE STOg1    3PUTLAM
DEFINE RCLg2    2GETLAM
DEFINE STOg2    2PUTLAM
DEFINE RCLv     1GETLAM
DEFINE STOv     1PUTLAM

NULLNAME _BINO
::
  6UNROLL                       ( r, k w z g1 g2 )
  %0                            ( r, k w z g1 g2 v )
  {
    NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM NULLLAM
  }
  BIND                          ( r --- local vars created )
*                               ( r )
  RCLg1 %ABS %IP STOg1
  RCLg2 %ABS %IP STOg2
  RCLz %ABS %IP STOz
  RCLw %ABS %IP STOw
  RCLk %ABS %IP STOk
*                               ( r )
  RCLk RCLz %MIN STOz
  RCLz RCLg2 %MIN STOg2
  RCLg1 RCLg2 %MIN STOg1
*                               ( r )
  ITE
    ::                          ( r true --- balls returned to cup )
      RCLw RCLk %/ STOv         ( --- v=w/k )
      %0                        ( s --- sum initialization )
      RCLg1                     ( s g --- loop variable, initialized  )
      BEGIN
        RCLz                    ( s g z )
        OVER                    ( s g z g )
        %COMB                   ( s g c )
        RCLv                    ( s g c v )
        3PICK                   ( s g c v g )
        %^                      ( s g c v^g )
        %*                      ( s g c*v^g )
        %1 RCLv %-              ( s g c*v^g 1-v )
        RCLz                    ( s g c*v^g 1-v z )
        4PICK                   ( s g c*v^g 1-v z g )
        %- %^                   ( s g c*v^g {1-v}^{z-g} )
        %*                      ( s g c*v^g*{1-v}^{z-g} )
        ROT                     ( g c*v^g*{1-v}^{z-g} s )
        %+                      ( g s' )
        SWAPDUP                 ( s' g g )
        RCLg2                   ( s' g g g2 )
        %>=                     ( s' g g>=g2? )
      UNTIL                     ( s' g )
      DROP                      ( s' )
    ;
    ::                          ( r false --- balls _not_ returned to cup )
      RCLk RCLw %- STOv         ( --- v=k-w )
      %0                        ( s --- sum initialization )
      RCLg1                     ( s g --- loop variable, initialized  )
      BEGIN                     ( s g )
        RCLw                    ( s g w )
        OVER                    ( s g w g )
        %COMB                   ( s g c1 )
        RCLv                    ( s g c1 k-w )
        RCLz                    ( s g c1 k-w z )
        4PICK                   ( s g c1 k-w z g )
        %-                      ( s g c1 {k-w} {z-g} )
        %COMB                   ( s g c1 c2 )
        %*                      ( s g c1*c2 )
        ROT                     ( g c1*c2 s )
        %+                      ( g s' )
        SWAPDUP                 ( s' g g )
        RCLg2                   ( s' g g g2 )
        %>=                     ( s' g g>=g2? )
      UNTIL                     ( s' g )
      SWAP                      ( g s )
      RCLk RCLz %COMB %/        ( g s' )
      SWAPDROP                  ( s' )
    ;
  ABND                          ( --- delete local vars )
;

***************************************************************************
* matrix min and max
* [] -> { min max }
* expects a _real_ matrix of arbitrary dimension{s}
***************************************************************************
RPL
NULLNAME _MEX
::                              ( m )
  DUP ARSIZE                    ( m n --- last index )
  %MAXREAL DUP %CHS             ( m n min max --- extrema initialized )
  ROT                           ( m min max n )
  #1+_ONE_DO (DO)               ( m min max )
    INDEX@                      ( m min max i )
    4PICK                       ( m min max i m )
    GETATELN                    ( m min max x T )
    DROP                        ( m min max x )
*
    DUP                         ( m min max x x )
    ROT                         ( m min x x max )
    %MAX                        ( m min x max' )
    SWAP                        ( m min max' x )
    ROT                         ( m max' x min )
    %MIN                        ( m max' min' )
    SWAP                        ( m min' max' )
  LOOP
  ROTDROP                       ( min max )
  TWO{}N                        ( { min max } )
;

***************************************************************************
* put contents of variables A..Z in a list
* -> {A B .. Z}
***************************************************************************
NULLNAME _AZL
::
  NULL{}
  xa >TCOMP
  xb >TCOMP
  xc >TCOMP
  xd >TCOMP
  xE >TCOMP
  xf >TCOMP
  xg >TCOMP
  xh >TCOMP
  xI >TCOMP
  xj >TCOMP
  xk >TCOMP
  xl >TCOMP
  xm >TCOMP
  xn >TCOMP
  xo >TCOMP
  xp >TCOMP
  xq >TCOMP
  xr >TCOMP
  xs >TCOMP
  xt >TCOMP
  xu >TCOMP
  xv >TCOMP
  xw >TCOMP
  xx >TCOMP
  xy >TCOMP
  xz >TCOMP
;

***************************************************************************
* get contents of variables A..Z from a list
* no dimension check
***************************************************************************
NULLNAME _LAZ
::                              ( {..} )
  INCOMPDROP                    ( a .. z --- hopefully )
  ' xz UserSto
  ' xy UserSto
  ' xx UserSto
  ' xw UserSto
  ' xv UserSto
  ' xu UserSto
  ' xt UserSto
  ' xs UserSto
  ' xr UserSto
  ' xq UserSto
  ' xp UserSto
  ' xo UserSto
  ' xn UserSto
  ' xm UserSto
  ' xl UserSto
  ' xk UserSto
  ' xj UserSto
  ' xI UserSto
  ' xh UserSto
  ' xg UserSto
  ' xf UserSto
  ' xE UserSto
  ' xd UserSto
  ' xc UserSto
  ' xb UserSto
  ' xa UserSto
;

***************************************************************************
* Program Run
* n arg  -> Ans
* call pgm as subroutine
* arg can be any obj type: real, list, matrix, ...
* PLOT, FNROOT, ... and other functions using a variable X don't work
*  (hang or warmstart). If hang, type ON-SK3
* exception:
* MAKELIST(PR(n,X),X,..) is ok with P99: Ans^2>Ans, but not X^2>Ans
*  because the global X is not used by MAKELIST
* for PLOT use MAKELIST, AXL, and array plotter
* for SOLVE or FNROOT use PSROOT
***************************************************************************
NULLNAME _PGMRUN
::                              ( n  any )
  StoAns@Drp                    ( n --- put args in Ans )
  _PNAME                        ( "Pn" )
  ::
    ERRSET                      ( --- only to have A..Z restored )
    ROMPTR 701 029              ( --- ~xxRUNPGM )
    ERRTRAP
    ::
      $ "Pgm Error:\0A"
      ERROR@                    ( errno )
      GETTHEMESG                ( $errmsg )
      &$
      Ck&DoMsgBox
      ERRORCLR
    ;
  ;
  xAns                          ( ans --- return result )
;

***************************************************************************
* Program Run with Save A..Z
* n arg  -> Ans
* see _PGMRUN
***************************************************************************
NULLNAME _PGMSRUN
::
  _AZL                          ( n any {A..Z} )
  1LAMBIND                      ( n any --- A..Z in LAM1 )
  _PGMRUN                       ( Ans )
  1GETABND                      ( Ans {A..Z} --- LAM1 deleted )
  _LAZ                          ( Ans --- A..Z restored )
;

*****************************************************************************
* lets user input a hex string and displays it
* keys:
*   A..F, 0..9   valid string chars
*   CANCEL       clears edit line, exits if already clear
*   DEL          deletes last char entered
*   ENTER        accepts string
*****************************************************************************
RPL
NULLNAME _GETHEX
::
  _SAVESCR                      ( poi )
*  RECLAIMDISP                   ( --- clear alpha display )
*  TURNMENUOFF                   ( --- remove menu keys )
  $ "Enter Hex:"
  DISPROW2
  FLUSHKEYS
  NULL$                         ( s --- initial user entry )
  BEGIN                         ( s )
    DUP CHR_UndScore >T$        ( s s_ )
    DISPROW4                    ( s )
    WaitForKey                  ( s #c #p )
    DROP                        ( s #c --- plane of no interest )
    ::
      kcA #=casedrop :: CHR_A >T$ FALSE ;
      kcB #=casedrop :: CHR_B >T$ FALSE ;
      kcC #=casedrop :: CHR_C >T$ FALSE ;
      kcD #=casedrop :: CHR_D >T$ FALSE ;
      kcE #=casedrop :: CHR_E >T$ FALSE ;
      kcF #=casedrop :: CHR_F >T$ FALSE ;

      kc0 #=casedrop :: CHR_0 >T$ FALSE ;
      kc1 #=casedrop :: CHR_1 >T$ FALSE ;
      kc2 #=casedrop :: CHR_2 >T$ FALSE ;
      kc3 #=casedrop :: CHR_3 >T$ FALSE ;
      kc4 #=casedrop :: CHR_4 >T$ FALSE ;
      kc5 #=casedrop :: CHR_5 >T$ FALSE ;
      kc6 #=casedrop :: CHR_6 >T$ FALSE ;
      kc7 #=casedrop :: CHR_7 >T$ FALSE ;
      kc8 #=casedrop :: CHR_8 >T$ FALSE ;
      kc9 #=casedrop :: CHR_9 >T$ FALSE ;

      kcOn #=casedrop ::
          DUPNULL$?
          ITE
            TRUE                ( s T --- exit if already cleared )
            ::
              DROPNULL$         ( s --- clear input )
              FALSE             ( s F )
            ;
        ;
      kcDEL #=casedrop ::
          DUPLEN$               ( --- delete last char )
          1_#1-SUB$
          FALSE
        ;
      kcENTER #=casedrop :: TRUE ;  ( --- exit )
      DROP DoBadKey FALSE       ( any other key )
    ;
  UNTIL                         ( poi s )
  _RESTORESCR                   ( s )
;

*****************************************************************************
* unsigned integer base conversion to decimal
* $s %b -> %d
* s expected to contain only valid and upcase chars
* uses 0..9, A..F..
*****************************************************************************
NULLNAME _FMBASE
::                              ( $s %b )
  SWAP                          ( b s )
  DUPNULL$?
  ITE
    ::                          ( b s ---  s empty )
      2DROP %0                  ( 0 --- result for empty string )
    ;
    ::                          ( b s --- nonempty, do the conversion )
      %0 %1                     ( b s 0 1 --- initialize sum and factor )
      ROT                       ( b sum fac s )
      DUPLEN$                   ( b sum fac s lens )
      #1+_ONE_DO (DO)           ( b sum fac s )
        DUP DUPLEN$             ( b sum fac s s lens )
        #1+                     ( b sum fac s s lens+1 )
        INDEX@#-                ( b sum fac s s lens-i+1 --- lens,lens-1,... )
        SUB$1#                  ( b sum fac s #s[j] )
* 0..9 = 48..57, A..F = 65..70
        FORTYEIGHT #-           ( b sum fac s c )
* 0..9 = 0..9, A..F = 17..22
        DUP NINE #>
        IT :: SEVEN #- ;        ( b sum fac s 0..15 )
        UNCOERCE                ( b sum fac s %0..15 )
        ROT                     ( b sum s %c fac )
        DUP                     ( b sum s %c fac fac )
        6PICK                   ( b sum s %c fac fac b )
        %*                      ( b sum s %c fac fac' )
        4UNROLL                 ( b sum fac' s %c fac )
        %*                      ( b sum fac' s %f )
        4ROLL                   ( b fac' s %f sum )
        %+                      ( b fac' s sum' )
        UNROT                   ( b sum' fac' s )
      LOOP                      ( b sum fac s )
      2DROP                     ( b %sum )
      SWAPDROP                  ( %d )
    ;
;

*****************************************************************************
* unsigned integer base conversion from decimal
* %d %b -> $s
* $s contains only valid and upcase chars
* uses 0..9, A..F..
*****************************************************************************
NULLNAME _TOBASE
::                              ( %d %b )
  SWAP                          ( b d )
  NULL$SWAP                     ( b s d --- dst string initialized )
  BEGIN                         ( b s d )
    3PICK 2DUP                  ( b s d b d b )
    %MOD                        ( b s d b %rem )
    COERCE                      ( b s d b rem )
    FORTYEIGHT #+               ( b s d b rem' )
    DUP FIFTYEIGHT #< ?SKIP     ( b s d b rem' )
      :: SEVEN #+ ;             ( b s d b rem'' )
    #>CHR                       ( b s d b sc )
    4ROLL                       ( b d b sc s )
    SWAP                        ( b d b s sc )
    >H$                         ( b d b s' )
    UNROT                       ( b s' d b )
    %/ %IP                      ( b s' d' )
    DUP %0=                     ( b s' d' T|F )
  UNTIL                         ( b s d )
  ROT2DROP                      ( $s )
;

*****************************************************************************
* byte list to base string
* { msbyte ... lsbyte } -> $s
* $s contains only valid and upcase chars
* uses 0..9, A..F..
*****************************************************************************
NULLNAME _BASELS
::                              ( {msbyte .. lsbyte} )
DUPNULL{}?
ITE                             ( {...} is_null )
  DROPNULL$                     ( return null_string for null_list )
  ::                            ( {...} )
    NULL$SWAP                   ( "" {...} )
    INNERCOMP                   ( "" ob1 ob2 ... obn #n )
    #1+                         ( "" ob1 ob2 ... obn #n+1 )
    reversym                    ( obn ... ob2 ob1 "" #n+1 )
    ONE_DO (DO)                 ( obn ... ob2 ob1 "" )
      SWAP                      ( obn ... ob2 "" ob1 )
      COERCE                    ( obn ... ob2 "" #ob1 )
      FORTYEIGHT #+             ( --- ord{0} )
      DUP FIFTYSEVEN #>         ( --- A..F? )
      IT :: SEVEN #+ ;
      #>CHR >T$                 ( obn ... ob2 ""b1 )
    LOOP                        ( obn bn-1 )
  ;
;

*****************************************************************************
* base string to byte list
* $s -> { msbyte lsbyte }
* $s contains only valid and upcase chars
* uses 0..9, A..F..
*****************************************************************************
NULLNAME _BASESL
::
NULL{}                          ( s {} )
OVER LEN$                       ( s {} lens )
DUP#0=ITE                       ( s {} lens lens=0? )
*                               ( s {} lens -- lens=0 )
  ROT2DROP                      ( {} )
  ::                            ( s {} lens -- lens>0 )
    #1+_ONE_DO (DO)             ( s {} )
      OVERINDEX@                ( s {} s i )
      SUB$1#                    ( s {} #s[i] )
      FORTYEIGHT #-             ( s {} #c )
      DUP NINE #>               ( s {} #c )
      IT :: SEVEN #- ;          ( s {} #c' )
      UNCOERCE                  ( s {} %c )
      >TCOMP                    ( s {}' )
    LOOP
    SWAPDROP                    ( {}' )
  ;
;

*****************************************************************************
* check base
* %b -> %b
* 2 <= b <= 200, else bad arg
*****************************************************************************
NULLNAME _CHKBASE
::
  DUP %2 %<
  OVER %200 %> OR
  IT SETSIZEERR
;

*****************************************************************************
* dez to 32bit string
* %d -> $s
* s[i] = 0 or 1, length(s) = 32 with leading zeros, if any
* for use with binary arithmetic
* unsigned integer 0..2^32-1 = 0 .. 4,294,967,295, dez checked for this
* -2,147,483,648 <= dez < 0 converted to 2-complement:
* dez' = 4,294,967,296 + dez
* -1 -> 4,294,967,295 etc.
*****************************************************************************
NULLNAME _D32
::
  %0 RNDXY                      ( d --- rounded to zero fractional digits )
  DUP %0 %<                     ( d d<0? )
  ITE
   ::                           ( d --- d<0 )
     DUP % -2147483648          ( d d minint )
     %< IT SETSIZEERR           ( d --- d<minint? )
     % 4294967296 %+            ( d' --- 2-complement )
   ;
   ::                           ( d --- d>= 0 )
     DUP % 4294967295 %>        ( d d>maxint? )
     IT SETSIZEERR              ( d )
   ;
  %2 _TOBASE                    ( s )
  DUPLEN$                       ( s lens )
  BINT32 SWAP#-                 ( s n0 --- number of zeros to be leftpadded )
  DUP#0=ITE                     ( s n0 )
    DROP                        ( s )
    ::                          ( s n0 --- n0 > 0 )
      #1+_ONE_DO (DO)           ( s --- leftpad with '0' to length 32 )
        CHR_0 >H$
      LOOP                      ( s' )
    ;
;                               ( s' )

***************************************************************************
* string_write_char_code
* write char(c) at position n in string s
* s n c -> s'
* n out of range does nothing
***************************************************************************
NULLNAME _SWC
::                              ( s #n #c )
ROT CKREF UNROT                 ( -- free up s )
CODE                            ( machine language begin )
*--------------------------------------------------------------------------
* Prolog
*--------------------------------------------------------------------------
        GOSBVL  =$jPOP#         ( pop system binary into A[A] )
        R3=A.F  A               ( R3 = c = charcode )
        GOSBVL  =$jPOP#         ( pop system binary into A[A] )
        R2=A.F  A               ( R2 = n = index )
        GOSBVL  =$jSAVPTR       ( save system pointers )
*--------------------------------------------------------------------------
* Core Code
*--------------------------------------------------------------------------
*        GOSBVL  =GetStrLenStk   ( now: C.A = length, D1 = body )
        C=DAT1  A               ( get adr of s )
        D1=C                    ( points to s )
        D1=D1+  5               ( skip prolog to get length )
        C=DAT1  A               ( get total length, incl. length itself )
        C=C-CON A,5             ( true length, number of char nibbles )
        D1=D1+  5               ( D1 points to first char of s )
*
        ?C=0    A               ( empty string? )
        GOYES   RausSWC         ( yes, do nothing )
        A=R2.F  A               ( A = n )
        ?A=0    A               ( n=0? )
        GOYES   RausSWC         ( yes, do nothing )
        A=A+A   A               ( n*2 for nibble address )
        A=A-CON A,2             ( n=1 points to nibble 0 )
        ?C<A    A               ( n > length? )
        GOYES   RausSWC         ( yes, do nothing )
        CD1EX                   ( calculate write address )
        C=C+A   A
        CD1EX
        C=R3.F  A               ( get char to write )
        DAT1=C  B               ( write byte )
*--------------------------------------------------------------------------
* Epilog
*--------------------------------------------------------------------------
RausSWC GOVLNG  =$jGETPTRLOOP   ( return to RPL )
ENDCODE                         ( machine language end )
;                               ( s )

*****************************************************************************
* 32bit shift left
* s32 -> s31 #cout
*****************************************************************************
NULLNAME _BSL
::
  DUP BINT1 SUB$1#              ( s32 MSB --- 1)
  SWAP                          ( MSB s32 --- 1 1..32 )
  BINT2 LAST$                   ( MSB s31 --- 1 2..32 )
  SWAP                          ( s31 MSB --- 2..32 1 )
;

*****************************************************************************
* 32bit shift right
* s32 -> s31 #cout
*****************************************************************************
NULLNAME _BSR
::
  DUP BINT32 SUB$1#             ( s32 LSB --- 1..32 32 )
  SWAP                          ( LSB s32 --- 32 1..32 )
  BINT32 1_#1-SUB$              ( LSB s31 --- 32 1..31 )
  SWAP                          ( s31 LSB --- 1..31 32 )
;

*****************************************************************************
* shift primitive, for looping
* T/F #p $s -> T/F #p $s'
* T for left shift, F for right shift
* p = 0: pull in LSB (shift left) or MSB (shift right) (arithmetic shift)
* p = 1: pull in 0 (logic shift )
* p = 2: pull in 1 (fill with ones)
* p = 3: pull in shifted-out bit (rotate)
*****************************************************************************
NULLNAME _BSHF
::                              ( f p s )
  3PICK                         ( f p s f )
  ITE
    ::                          ( f p s --- left shift )
      _BSL                      ( f p s31 cout )
      3PICK                     ( f p s31 cout p )
      ::
        BINT0 #=casedrop        ( f p s31 cout --- pull in LSB )
          ::
            DROPDUP             ( f p s31 s31 )
            BINT31 SUB$1#       ( f p s31 LSB )
          ;
        BINT1 #=casedrop        ( f p s31 cout --- pull in 0 )
          ::
            DROP                ( f p s31 )
            BINT48              ( f p s31 0 )
          ;
        BINT2 #=casedrop        ( f p s31 cout --- pull in 1 )
          ::
            DROP                ( f p s31 )
            BINT49              ( f p s31 1 )
          ;
        BINT3 #=casedrop        ( f p s31 cout --- pull in cout )
          ::
          ;
        SETSIZEERR              ( --- bad arg value )
      ;
      #>CHR >T$                 ( f p s32 )
    ;
    ::                          ( f p s --- right shift )
      _BSR                      ( f p s31 cout )
      3PICK                     ( f p s31 cout p )
      ::
        BINT0 #=casedrop        ( f p s31 cout --- pull in MSB )
          ::
            DROPDUP             ( f p s31 s31 )
            BINT1 SUB$1#        ( f p s31 MSB )
          ;
        BINT1 #=casedrop        ( f p s31 cout --- pull in 0 )
          ::
            DROP                ( f p s31 )
            BINT48              ( f p s31 0 )
          ;
        BINT2 #=casedrop        ( f p s31 cout --- pull in 1 )
          ::
            DROP                ( f p s31 )
            BINT49              ( f p s31 1 )
          ;
        BINT3 #=casedrop        ( f p s31 cout --- pull in cout )
          ::
          ;
        SETSIZEERR              ( --- bad arg value )
      ;
      #>CHR >H$                 ( f p s32 )
    ;
;

***************************************************************************
* omega (circular f)
* f -> 2 pi f
***************************************************************************
RPL
NULLNAME _OM
::
  %2 %* %PI %*
;

***************************************************************************
* concatenate two vectors
* [a] [b] -> [ab]
* assumes same type of objs in vectors
***************************************************************************
NULLNAME _VAPP
::                              ( a b )
  SWAP
  ROMPTR 004 03C                ( --- ARRY> )
  ONE NTHCOMPDROP COERCE
  DUP #2+ ROLL
  ROMPTR 004 03C                ( --- ARRY> )
  ONE NTHCOMPDROP COERCE
  DUP #2+ ROLL
  #+
  UNCOERCE
  ROMPTR 004 03B                ( --- >ARRY )
;

***************************************************************************
* n -> "Pn"
***************************************************************************
RPL
NULLNAME _PNAME
::                              ( n )
  ROMPTR 004 02B                ( n f --- xRCLF )
  SWAP                          ( f n )
  BINT49 ClrSysFlag             ( f n  --- set standard display format )
  BINT50 ClrSysFlag             ( f n  )
  DO>STR                        ( f "n" --- string formed in std fmt )
  CHR_P >H$                     ( f "Pn" )
  SWAP                          ( "Pn" f )
  ROMPTR 004 02C                ( "Pn" --- xSTOF )
;

***************************************************************************
* returns true if user has/had pressed . (point) key
***************************************************************************
RPL
NULLNAME _CHKUSR
::                              ( n )
  CHECKKEY ITE
  ::                            ( #kc )
    FLUSHKEYS
    BINT49 #=                   ( T/F --- T only for . key )
  ;
  FALSE                         ( F --- no key pressed )
;

***************************************************************************
* save and restore text screen
* for full screen functions
* to be used with stack balance!
* _SAVESCR   : -> poi'
* _RESTORESCR: poi' out -> out --- out is function output
***************************************************************************
RPL
NULLNAME _SAVESCR
::
  ABUFF                         ( poi --- pointer to current screen )
  TOTEMPOB                      ( poi' --- make a copy ) 
  RECLAIMDISP                   ( poi' --- get and clear text grob )
  TURNMENUOFF                   ( poi' --- remove menu keys )
;

RPL
NULLNAME _RESTORESCR
::                              ( poi' out --- pointer to saved screen in tmp )
  SWAP                          ( out poi' )
  ZEROZERO                      ( poi' 0 0 )
  ROT                           ( 0 0 poi' )
  XYGROBDISP                    ( --- current screen restored )
* does not work, and SysDisplay and ClrDAsOK not in entry points
*  ClrDA1OK                      ( --- redraw )
*  ClrDA2OK                      ( --- redraw )
*  ClrDA3OK                      ( --- redraw )
  TURNMENUOFF                   ( --- remove ineffective menues at least )
;

*****************************************************************************
* Revision
*****************************************************************************
ASSEMBLE
        CON(3)  8
RPL
xNAME MALFUNCT
::
  CK0
  $ "MAL/20030413"
;

*****************************************************************************
* End
*****************************************************************************
